/**
 * Copyright (c) 2014 CEA LIST.
 *  
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *  
 * Contributors:
 *  CEA LIST - Initial API and implementation
 */
package org.eclipse.papyrus.umldi;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.papyrus.dd.di.DIPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 * <li>each class,</li>
 * <li>each feature of each class,</li>
 * <li>each operation of each class,</li>
 * <li>each enum,</li>
 * <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * 
 * @see org.eclipse.papyrus.umldi.UMLDIFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/uml2/2.0.0/UML originalName='UMLDI'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore validationDelegates='http://www.eclipse.org/emf/2002/Ecore/OCL'"
 * @generated
 */
public interface UMLDIPackage extends EPackage {

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String eNAME = "umldi";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String eNS_URI = "http://www.omg.org/spec/UML/20131001/UMLDI";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	String eNS_PREFIX = "umldi";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	UMLDIPackage eINSTANCE = org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UmlDiagramElementImpl <em>Uml Diagram Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UmlDiagramElementImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlDiagramElement()
	 * @generated
	 */
	int UML_DIAGRAM_ELEMENT = 1;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__MODEL_ELEMENT = DIPackage.DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT = DIPackage.DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT = DIPackage.DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__LOCAL_STYLE = DIPackage.DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__SHARED_STYLE = DIPackage.DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__TARGET_EDGE = DIPackage.DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__SOURCE_EDGE = DIPackage.DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__DIAGRAM = DIPackage.DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Uml Diagram Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT_FEATURE_COUNT = DIPackage.DIAGRAM_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT___DIAGRAM = DIPackage.DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Uml Diagram Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_ELEMENT_OPERATION_COUNT = DIPackage.DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UmlDiagramImpl <em>Uml Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UmlDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlDiagram()
	 * @generated
	 */
	int UML_DIAGRAM = 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__OWNING_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__OWNED_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__LOCAL_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__SHARED_STYLE = UML_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__TARGET_EDGE = UML_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__SOURCE_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__DIAGRAM = UML_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__UML_MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__SHARED_UML_STYLE = UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__LOCAL_UML_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__TARGET_UML_EDGE = UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__SOURCE_UML_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__BOUNDS = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__NAME = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__DOCUMENTATION = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__RESOLUTION = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Uml Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_FEATURE_COUNT = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM___DIAGRAM = UML_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Uml Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_DIAGRAM_OPERATION_COUNT = UML_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UmlStyleImpl <em>Uml Style</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UmlStyleImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlStyle()
	 * @generated
	 */
	int UML_STYLE = 2;

	/**
	 * The feature id for the '<em><b>Font Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_STYLE__FONT_NAME = DIPackage.STYLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Font Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_STYLE__FONT_SIZE = DIPackage.STYLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Uml Style</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_STYLE_FEATURE_COUNT = DIPackage.STYLE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Fontsize Positive</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_STYLE___FONTSIZE_POSITIVE__DIAGNOSTICCHAIN_MAP = DIPackage.STYLE_OPERATION_COUNT + 0;

	/**
	 * The number of operations of the '<em>Uml Style</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_STYLE_OPERATION_COUNT = DIPackage.STYLE_OPERATION_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StereotypedDiagramElementImpl <em>Stereotyped Diagram Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StereotypedDiagramElementImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypedDiagramElement()
	 * @generated
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT = 5;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__LOCAL_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__SHARED_STYLE = UML_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__TARGET_EDGE = UML_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__SOURCE_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__DIAGRAM = UML_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__SHARED_UML_STYLE = UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__LOCAL_UML_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__TARGET_UML_EDGE = UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__SOURCE_UML_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__SHOW_STEREOTYPE_ATTRIBUTES = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT__STEREOTYPE_LABEL = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Stereotyped Diagram Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT___DIAGRAM = UML_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Stereotyped Diagram Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPED_DIAGRAM_ELEMENT_OPERATION_COUNT = UML_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TopUmlDiagramElementImpl <em>Top Uml Diagram Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TopUmlDiagramElementImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTopUmlDiagramElement()
	 * @generated
	 */
	int TOP_UML_DIAGRAM_ELEMENT = 4;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__MODEL_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__LOCAL_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__SHARED_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__TARGET_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__SOURCE_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__DIAGRAM = STEREOTYPED_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__SHOW_STEREOTYPE_ATTRIBUTES = STEREOTYPED_DIAGRAM_ELEMENT__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__STEREOTYPE_LABEL = STEREOTYPED_DIAGRAM_ELEMENT__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__UML_DIAGRAM = STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__DIAGRAM_COMPARTMENT = STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT__MAIN_LABEL = STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Top Uml Diagram Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT = STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT___DIAGRAM = STEREOTYPED_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Top Uml Diagram Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TOP_UML_DIAGRAM_ELEMENT_OPERATION_COUNT = STEREOTYPED_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UmlEdgeImpl <em>Uml Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UmlEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlEdge()
	 * @generated
	 */
	int UML_EDGE = 3;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__MODEL_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__OWNING_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__OWNED_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__LOCAL_STYLE = TOP_UML_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__SHARED_STYLE = TOP_UML_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__TARGET_EDGE = TOP_UML_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__SOURCE_EDGE = TOP_UML_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__DIAGRAM = TOP_UML_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__UML_MODEL_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__SHARED_UML_STYLE = TOP_UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__LOCAL_UML_STYLE = TOP_UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__OWNED_UML_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__OWNING_UML_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__TARGET_UML_EDGE = TOP_UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__SOURCE_UML_EDGE = TOP_UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = TOP_UML_DIAGRAM_ELEMENT__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__STEREOTYPE_LABEL = TOP_UML_DIAGRAM_ELEMENT__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__UML_DIAGRAM = TOP_UML_DIAGRAM_ELEMENT__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__DIAGRAM_COMPARTMENT = TOP_UML_DIAGRAM_ELEMENT__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__MAIN_LABEL = TOP_UML_DIAGRAM_ELEMENT__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__SOURCE_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__WAYPOINT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__TARGET_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE__TARGET_UML_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Uml Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE_FEATURE_COUNT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE___DIAGRAM = TOP_UML_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Uml Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_EDGE_OPERATION_COUNT = TOP_UML_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UmlCompartmentImpl <em>Uml Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UmlCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlCompartment()
	 * @generated
	 */
	int UML_COMPARTMENT = 9;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DiagramCompartmentImpl <em>Diagram Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DiagramCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDiagramCompartment()
	 * @generated
	 */
	int DIAGRAM_COMPARTMENT = 8;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UmlLabelImpl <em>Uml Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UmlLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlLabel()
	 * @generated
	 */
	int UML_LABEL = 7;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__OWNING_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__OWNED_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__LOCAL_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__SHARED_STYLE = UML_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__TARGET_EDGE = UML_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__SOURCE_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__DIAGRAM = UML_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__UML_MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__SHARED_UML_STYLE = UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__LOCAL_UML_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__TARGET_UML_EDGE = UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__SOURCE_UML_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL__BOUNDS = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Uml Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL_FEATURE_COUNT = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL___DIAGRAM = UML_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Uml Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_LABEL_OPERATION_COUNT = UML_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.MainLabelImpl <em>Main Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.MainLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMainLabel()
	 * @generated
	 */
	int MAIN_LABEL = 10;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UmlShapeImpl <em>Uml Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UmlShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlShape()
	 * @generated
	 */
	int UML_SHAPE = 11;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StructureDiagramImpl <em>Structure Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StructureDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStructureDiagram()
	 * @generated
	 */
	int STRUCTURE_DIAGRAM = 16;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassDiagramImpl <em>Class Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassDiagram()
	 * @generated
	 */
	int CLASS_DIAGRAM = 15;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ElementShapeImpl <em>Element Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ElementShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementShape()
	 * @generated
	 */
	int ELEMENT_SHAPE = 19;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TemplateableElementShapeImpl <em>Templateable Element Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TemplateableElementShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTemplateableElementShape()
	 * @generated
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE = 18;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierShapeImpl <em>Classifier Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassifierShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierShape()
	 * @generated
	 */
	int CLASSIFIER_SHAPE = 17;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ListCompartmentImpl <em>List Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ListCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getListCompartment()
	 * @generated
	 */
	int LIST_COMPARTMENT = 13;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StereotypeCompartmentImpl <em>Stereotype Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StereotypeCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypeCompartment()
	 * @generated
	 */
	int STEREOTYPE_COMPARTMENT = 12;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TemplateParameterCompartmentImpl <em>Template Parameter Compartment</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TemplateParameterCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTemplateParameterCompartment()
	 * @generated
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT = 20;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ListItemLabelImpl <em>List Item Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ListItemLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getListItemLabel()
	 * @generated
	 */
	int LIST_ITEM_LABEL = 14;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StereotypeLabelImpl <em>Stereotype Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StereotypeLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypeLabel()
	 * @generated
	 */
	int STEREOTYPE_LABEL = 6;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotyped Diagram Element</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL__STEREOTYPED_DIAGRAM_ELEMENT = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Stereotype Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Stereotype Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__LOCAL_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__SHARED_STYLE = UML_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__TARGET_EDGE = UML_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__SOURCE_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__DIAGRAM = UML_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__UML_MODEL_ELEMENT = UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__SHARED_UML_STYLE = UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__LOCAL_UML_STYLE = UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__TARGET_UML_EDGE = UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__SOURCE_UML_EDGE = UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT__BOUNDS = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Uml Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT_FEATURE_COUNT = UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT___DIAGRAM = UML_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Uml Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_COMPARTMENT_OPERATION_COUNT = UML_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__MODEL_ELEMENT = UML_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__LOCAL_STYLE = UML_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__SHARED_STYLE = UML_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__TARGET_EDGE = UML_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__SOURCE_EDGE = UML_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__DIAGRAM = UML_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT = UML_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__SHARED_UML_STYLE = UML_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE = UML_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__TARGET_UML_EDGE = UML_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE = UML_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__BOUNDS = UML_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = UML_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Diagram Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT_FEATURE_COUNT = UML_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT___DIAGRAM = UML_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Diagram Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DIAGRAM_COMPARTMENT_OPERATION_COUNT = UML_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL__TOP_UML_DIAGRAM_ELEMENT = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Main Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Main Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MAIN_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__MODEL_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__OWNING_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__OWNED_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__LOCAL_STYLE = TOP_UML_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__SHARED_STYLE = TOP_UML_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__TARGET_EDGE = TOP_UML_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__SOURCE_EDGE = TOP_UML_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__DIAGRAM = TOP_UML_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__UML_MODEL_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__SHARED_UML_STYLE = TOP_UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__LOCAL_UML_STYLE = TOP_UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = TOP_UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__TARGET_UML_EDGE = TOP_UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__SOURCE_UML_EDGE = TOP_UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = TOP_UML_DIAGRAM_ELEMENT__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__STEREOTYPE_LABEL = TOP_UML_DIAGRAM_ELEMENT__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__UML_DIAGRAM = TOP_UML_DIAGRAM_ELEMENT__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__DIAGRAM_COMPARTMENT = TOP_UML_DIAGRAM_ELEMENT__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__MAIN_LABEL = TOP_UML_DIAGRAM_ELEMENT__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__BOUNDS = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE__STEREOTYPE_COMPARTMENT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Uml Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE_FEATURE_COUNT = TOP_UML_DIAGRAM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE___DIAGRAM = TOP_UML_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Uml Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int UML_SHAPE_OPERATION_COUNT = TOP_UML_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__MODEL_ELEMENT = UML_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__LOCAL_STYLE = UML_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__SHARED_STYLE = UML_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__TARGET_EDGE = UML_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__SOURCE_EDGE = UML_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__DIAGRAM = UML_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__UML_MODEL_ELEMENT = UML_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__SHARED_UML_STYLE = UML_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__LOCAL_UML_STYLE = UML_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = UML_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__TARGET_UML_EDGE = UML_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__SOURCE_UML_EDGE = UML_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__BOUNDS = UML_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT__LIST_ITEM_LABEL = UML_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>List Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT_FEATURE_COUNT = UML_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT___DIAGRAM = UML_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>List Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_COMPARTMENT_OPERATION_COUNT = UML_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT__UML_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Stereotype Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Stereotype Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__MODEL_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__OWNING_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__OWNED_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__LOCAL_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__SHARED_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__TARGET_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__SOURCE_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__DIAGRAM = STEREOTYPED_DIAGRAM_ELEMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__UML_MODEL_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__SHARED_UML_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__LOCAL_UML_STYLE = STEREOTYPED_DIAGRAM_ELEMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__OWNED_UML_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__OWNING_UML_DIAGRAM_ELEMENT = STEREOTYPED_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__TARGET_UML_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__SOURCE_UML_EDGE = STEREOTYPED_DIAGRAM_ELEMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__SHOW_STEREOTYPE_ATTRIBUTES = STEREOTYPED_DIAGRAM_ELEMENT__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__STEREOTYPE_LABEL = STEREOTYPED_DIAGRAM_ELEMENT__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__BOUNDS = STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>List Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL__LIST_COMPARTMENT = STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>List Item Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL_FEATURE_COUNT = STEREOTYPED_DIAGRAM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL___DIAGRAM = STEREOTYPED_DIAGRAM_ELEMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>List Item Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIST_ITEM_LABEL_OPERATION_COUNT = STEREOTYPED_DIAGRAM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__MODEL_ELEMENT = UML_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__LOCAL_STYLE = UML_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__SHARED_STYLE = UML_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__TARGET_EDGE = UML_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__SOURCE_EDGE = UML_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__DIAGRAM = UML_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT = UML_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__SHARED_UML_STYLE = UML_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__LOCAL_UML_STYLE = UML_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__TARGET_UML_EDGE = UML_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__SOURCE_UML_EDGE = UML_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__BOUNDS = UML_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__NAME = UML_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__DOCUMENTATION = UML_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__RESOLUTION = UML_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = UML_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Structure Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM_FEATURE_COUNT = UML_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM___DIAGRAM = UML_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Structure Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_DIAGRAM_OPERATION_COUNT = UML_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__MODEL_ELEMENT = STRUCTURE_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__OWNING_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__OWNED_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__LOCAL_STYLE = STRUCTURE_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__SHARED_STYLE = STRUCTURE_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__TARGET_EDGE = STRUCTURE_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__SOURCE_EDGE = STRUCTURE_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__DIAGRAM = STRUCTURE_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__UML_MODEL_ELEMENT = STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__SHARED_UML_STYLE = STRUCTURE_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__LOCAL_UML_STYLE = STRUCTURE_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__TARGET_UML_EDGE = STRUCTURE_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__SOURCE_UML_EDGE = STRUCTURE_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__BOUNDS = STRUCTURE_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__NAME = STRUCTURE_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__DOCUMENTATION = STRUCTURE_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__RESOLUTION = STRUCTURE_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Class Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM_FEATURE_COUNT = STRUCTURE_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM___DIAGRAM = STRUCTURE_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Class Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_DIAGRAM_OPERATION_COUNT = STRUCTURE_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__MODEL_ELEMENT = UML_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT = UML_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT = UML_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__LOCAL_STYLE = UML_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__SHARED_STYLE = UML_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__TARGET_EDGE = UML_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__SOURCE_EDGE = UML_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__DIAGRAM = UML_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__UML_MODEL_ELEMENT = UML_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__SHARED_UML_STYLE = UML_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__LOCAL_UML_STYLE = UML_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = UML_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = UML_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__TARGET_UML_EDGE = UML_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__SOURCE_UML_EDGE = UML_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = UML_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__STEREOTYPE_LABEL = UML_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__UML_DIAGRAM = UML_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__DIAGRAM_COMPARTMENT = UML_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__MAIN_LABEL = UML_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__BOUNDS = UML_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT = UML_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Element Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE_FEATURE_COUNT = UML_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE___DIAGRAM = UML_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Element Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_SHAPE_OPERATION_COUNT = UML_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Templateable Element Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Templateable Element Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATEABLE_ELEMENT_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__MODEL_ELEMENT = TEMPLATEABLE_ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT = TEMPLATEABLE_ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT = TEMPLATEABLE_ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__LOCAL_STYLE = TEMPLATEABLE_ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__SHARED_STYLE = TEMPLATEABLE_ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__TARGET_EDGE = TEMPLATEABLE_ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__SOURCE_EDGE = TEMPLATEABLE_ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__DIAGRAM = TEMPLATEABLE_ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__UML_MODEL_ELEMENT = TEMPLATEABLE_ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__SHARED_UML_STYLE = TEMPLATEABLE_ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__LOCAL_UML_STYLE = TEMPLATEABLE_ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = TEMPLATEABLE_ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = TEMPLATEABLE_ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__TARGET_UML_EDGE = TEMPLATEABLE_ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__SOURCE_UML_EDGE = TEMPLATEABLE_ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = TEMPLATEABLE_ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__STEREOTYPE_LABEL = TEMPLATEABLE_ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__UML_DIAGRAM = TEMPLATEABLE_ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT = TEMPLATEABLE_ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__MAIN_LABEL = TEMPLATEABLE_ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__BOUNDS = TEMPLATEABLE_ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT = TEMPLATEABLE_ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = TEMPLATEABLE_ELEMENT_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION = TEMPLATEABLE_ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT = TEMPLATEABLE_ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT = TEMPLATEABLE_ELEMENT_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Classifier Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE_FEATURE_COUNT = TEMPLATEABLE_ELEMENT_SHAPE_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE___DIAGRAM = TEMPLATEABLE_ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Classifier Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_SHAPE_OPERATION_COUNT = TEMPLATEABLE_ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierCompartmentImpl <em>Classifier Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassifierCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierCompartment()
	 * @generated
	 */
	int CLASSIFIER_COMPARTMENT = 22;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.OwnedUseCaseCompartmentImpl <em>Owned Use Case Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.OwnedUseCaseCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOwnedUseCaseCompartment()
	 * @generated
	 */
	int OWNED_USE_CASE_COMPARTMENT = 21;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UseCaseCompartmentImpl <em>Use Case Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UseCaseCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUseCaseCompartment()
	 * @generated
	 */
	int USE_CASE_COMPARTMENT = 23;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithPackagedElementsShapeImpl
	 * <em>Element With Packaged Elements Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ElementWithPackagedElementsShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithPackagedElementsShape()
	 * @generated
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE = 25;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PackageShapeImpl <em>Package Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PackageShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageShape()
	 * @generated
	 */
	int PACKAGE_SHAPE = 24;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PackagedElementCompartmentImpl <em>Packaged Element Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PackagedElementCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackagedElementCompartment()
	 * @generated
	 */
	int PACKAGED_ELEMENT_COMPARTMENT = 26;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ConstraintShapeImpl <em>Constraint Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ConstraintShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConstraintShape()
	 * @generated
	 */
	int CONSTRAINT_SHAPE = 27;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.AttributeCompartmentImpl <em>Attribute Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.AttributeCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAttributeCompartment()
	 * @generated
	 */
	int ATTRIBUTE_COMPARTMENT = 28;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithAttributesShapeImpl <em>Classifier With Attributes Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithAttributesShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithAttributesShape()
	 * @generated
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE = 29;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.OperationCompartmentImpl <em>Operation Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.OperationCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOperationCompartment()
	 * @generated
	 */
	int OPERATION_COMPARTMENT = 30;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithOperationsShapeImpl <em>Classifier With Operations Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithOperationsShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithOperationsShape()
	 * @generated
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE = 31;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ReceptionCompartmentImpl <em>Reception Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ReceptionCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getReceptionCompartment()
	 * @generated
	 */
	int RECEPTION_COMPARTMENT = 32;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithReceptionsShapeImpl <em>Classifier With Receptions Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithReceptionsShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithReceptionsShape()
	 * @generated
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE = 33;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.LiteralCompartmentImpl <em>Literal Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.LiteralCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getLiteralCompartment()
	 * @generated
	 */
	int LITERAL_COMPARTMENT = 34;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.EnumerationShapeImpl <em>Enumeration Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.EnumerationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getEnumerationShape()
	 * @generated
	 */
	int ENUMERATION_SHAPE = 35;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.RoleLabelImpl <em>Role Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.RoleLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRoleLabel()
	 * @generated
	 */
	int ROLE_LABEL = 36;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ElementEdgeImpl <em>Element Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ElementEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementEdge()
	 * @generated
	 */
	int ELEMENT_EDGE = 38;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Templateable Element Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT__TEMPLATEABLE_ELEMENT_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Template Parameter Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Template Parameter Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_PARAMETER_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Layout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT__LAYOUT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Classifier Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Classifier Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__LOCAL_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__SHARED_STYLE = CLASSIFIER_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__TARGET_EDGE = CLASSIFIER_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__SOURCE_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__DIAGRAM = CLASSIFIER_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__UML_MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__SHARED_UML_STYLE = CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__LOCAL_UML_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__TARGET_UML_EDGE = CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__SOURCE_UML_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__BOUNDS = CLASSIFIER_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__LIST_ITEM_LABEL = CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Layout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__LAYOUT = CLASSIFIER_COMPARTMENT__LAYOUT;

	/**
	 * The feature id for the '<em><b>Classifier Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT__CLASSIFIER_SHAPE = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Owned Use Case Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT_FEATURE_COUNT = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT___DIAGRAM = CLASSIFIER_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Owned Use Case Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_USE_CASE_COMPARTMENT_OPERATION_COUNT = CLASSIFIER_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Classifier Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT__CLASSIFIER_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Use Case Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Use Case Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Packaged Element Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__PACKAGED_ELEMENT_COMPARTMENT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Element With Packaged Elements Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Element With Packaged Elements Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__MODEL_ELEMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__LOCAL_STYLE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__SHARED_STYLE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__TARGET_EDGE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__SOURCE_EDGE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__DIAGRAM = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__SHARED_UML_STYLE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__LOCAL_UML_STYLE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__TARGET_UML_EDGE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__SOURCE_UML_EDGE = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__STEREOTYPE_LABEL = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__UML_DIAGRAM = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__MAIN_LABEL = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__BOUNDS = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Packaged Element Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__PACKAGED_ELEMENT_COMPARTMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__PACKAGED_ELEMENT_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Package Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE_FEATURE_COUNT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE___DIAGRAM = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Package Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_SHAPE_OPERATION_COUNT = ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Element With Packaged Elements Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT__ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Packaged Element Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Packaged Element Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGED_ELEMENT_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Constraint Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Constraint Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Classifier With Attributes Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT__CLASSIFIER_WITH_ATTRIBUTES_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Attribute Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Attribute Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__MODEL_ELEMENT = CLASSIFIER_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__LOCAL_STYLE = CLASSIFIER_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHARED_STYLE = CLASSIFIER_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TARGET_EDGE = CLASSIFIER_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SOURCE_EDGE = CLASSIFIER_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__DIAGRAM = CLASSIFIER_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHARED_UML_STYLE = CLASSIFIER_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TARGET_UML_EDGE = CLASSIFIER_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__UML_DIAGRAM = CLASSIFIER_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__MAIN_LABEL = CLASSIFIER_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__BOUNDS = CLASSIFIER_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Classifier With Attributes Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE_FEATURE_COUNT = CLASSIFIER_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE___DIAGRAM = CLASSIFIER_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Classifier With Attributes Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_ATTRIBUTES_SHAPE_OPERATION_COUNT = CLASSIFIER_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Classifier With Operations Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT__CLASSIFIER_WITH_OPERATIONS_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Operation Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Operation Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPERATION_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__BOUNDS = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Classifier With Operations Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE___DIAGRAM = CLASSIFIER_WITH_ATTRIBUTES_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Classifier With Operations Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_OPERATIONS_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Classifier With Reception Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT__CLASSIFIER_WITH_RECEPTION_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Reception Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Reception Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int RECEPTION_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__BOUNDS = CLASSIFIER_WITH_OPERATIONS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE__RECEPTION_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Classifier With Receptions Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE___DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Classifier With Receptions Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_RECEPTIONS_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Enumeration Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT__ENUMERATION_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Literal Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Literal Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LITERAL_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__MODEL_ELEMENT = CLASSIFIER_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__LOCAL_STYLE = CLASSIFIER_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__SHARED_STYLE = CLASSIFIER_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__TARGET_EDGE = CLASSIFIER_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__SOURCE_EDGE = CLASSIFIER_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__DIAGRAM = CLASSIFIER_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__SHARED_UML_STYLE = CLASSIFIER_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__TARGET_UML_EDGE = CLASSIFIER_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__UML_DIAGRAM = CLASSIFIER_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__MAIN_LABEL = CLASSIFIER_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__BOUNDS = CLASSIFIER_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Literal Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE__LITERAL_COMPARTMENT = CLASSIFIER_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Enumeration Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE_FEATURE_COUNT = CLASSIFIER_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE___DIAGRAM = CLASSIFIER_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Enumeration Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ENUMERATION_SHAPE_OPERATION_COUNT = CLASSIFIER_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Association Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__ASSOCIATION_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Instance Specification Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__INSTANCE_SPECIFICATION_EDGE = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Role Binding Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL__ROLE_BINDING_EDGE = UML_LABEL_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Role Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Role Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ROLE_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__MODEL_ELEMENT = UML_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT = UML_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT = UML_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__LOCAL_STYLE = UML_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__SHARED_STYLE = UML_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__TARGET_EDGE = UML_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__SOURCE_EDGE = UML_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__DIAGRAM = UML_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__UML_MODEL_ELEMENT = UML_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__SHARED_UML_STYLE = UML_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__LOCAL_UML_STYLE = UML_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__TARGET_UML_EDGE = UML_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__SOURCE_UML_EDGE = UML_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = UML_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__STEREOTYPE_LABEL = UML_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__UML_DIAGRAM = UML_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__DIAGRAM_COMPARTMENT = UML_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__MAIN_LABEL = UML_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__WAYPOINT = UML_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT = UML_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT = UML_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Element Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE_FEATURE_COUNT = UML_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE___DIAGRAM = UML_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Element Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_EDGE_OPERATION_COUNT = UML_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.AssociationEdgeImpl <em>Association Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.AssociationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationEdge()
	 * @generated
	 */
	int ASSOCIATION_EDGE = 37;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>End Multiplicity Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__END_MULTIPLICITY_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>End Constraint Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__END_CONSTRAINT_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>End Role Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__END_ROLE_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Association Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Association Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.MultiplicityLabelImpl <em>Multiplicity Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.MultiplicityLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMultiplicityLabel()
	 * @generated
	 */
	int MULTIPLICITY_LABEL = 39;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Property Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__PROPERTY_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Connector Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__CONNECTOR_EDGE = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Association Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL__ASSOCIATION_EDGE = UML_LABEL_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Multiplicity Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Multiplicity Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MULTIPLICITY_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PropertyEdgeImpl <em>Property Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PropertyEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPropertyEdge()
	 * @generated
	 */
	int PROPERTY_EDGE = 40;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Constraint Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__CONSTRAINT_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Multiplicity Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE__MULTIPLICITY_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Property Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Property Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ConstraintLabelImpl <em>Constraint Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ConstraintLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConstraintLabel()
	 * @generated
	 */
	int CONSTRAINT_LABEL = 41;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Association Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__ASSOCIATION_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Generalization Set Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__GENERALIZATION_SET_EDGE = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Object Node Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__OBJECT_NODE_SHAPE = UML_LABEL_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__LIFELINE_SHAPE = UML_LABEL_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Action Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__ACTION_SHAPE = UML_LABEL_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Property Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL__PROPERTY_EDGE = UML_LABEL_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Constraint Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 6;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Constraint Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.GeneralizationSetEdgeImpl <em>Generalization Set Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.GeneralizationSetEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGeneralizationSetEdge()
	 * @generated
	 */
	int GENERALIZATION_SET_EDGE = 42;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Power Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__POWER_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Constraint Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE__CONSTRAINT_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Generalization Set Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Generalization Set Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_SET_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PowerLabelImpl <em>Power Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PowerLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPowerLabel()
	 * @generated
	 */
	int POWER_LABEL = 43;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Generalization Set Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL__GENERALIZATION_SET_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Power Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Power Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POWER_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityNodeShapeImpl <em>Activity Node Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityNodeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityNodeShape()
	 * @generated
	 */
	int ACTIVITY_NODE_SHAPE = 45;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Activity Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ObjectNodeShapeImpl <em>Object Node Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ObjectNodeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getObjectNodeShape()
	 * @generated
	 */
	int OBJECT_NODE_SHAPE = 44;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__MODEL_ELEMENT = ACTIVITY_NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__LOCAL_STYLE = ACTIVITY_NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__SHARED_STYLE = ACTIVITY_NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__TARGET_EDGE = ACTIVITY_NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__SOURCE_EDGE = ACTIVITY_NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__DIAGRAM = ACTIVITY_NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__UML_MODEL_ELEMENT = ACTIVITY_NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__SHARED_UML_STYLE = ACTIVITY_NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__LOCAL_UML_STYLE = ACTIVITY_NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__TARGET_UML_EDGE = ACTIVITY_NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__SOURCE_UML_EDGE = ACTIVITY_NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ACTIVITY_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__STEREOTYPE_LABEL = ACTIVITY_NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__UML_DIAGRAM = ACTIVITY_NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__DIAGRAM_COMPARTMENT = ACTIVITY_NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__MAIN_LABEL = ACTIVITY_NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__BOUNDS = ACTIVITY_NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__STEREOTYPE_COMPARTMENT = ACTIVITY_NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Selection Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__SELECTION_LABEL = ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Constraint Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE__CONSTRAINT_LABEL = ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Object Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE_FEATURE_COUNT = ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE___DIAGRAM = ACTIVITY_NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Object Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_NODE_SHAPE_OPERATION_COUNT = ACTIVITY_NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SelectionLabelImpl <em>Selection Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SelectionLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSelectionLabel()
	 * @generated
	 */
	int SELECTION_LABEL = 46;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Object Flow Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__OBJECT_FLOW_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Object Node Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL__OBJECT_NODE_SHAPE = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Selection Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Selection Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SELECTION_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityEdgeEdgeImpl <em>Activity Edge Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityEdgeEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityEdgeEdge()
	 * @generated
	 */
	int ACTIVITY_EDGE_EDGE = 48;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Guard Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__GUARD_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Weight Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE__WEIGHT_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Activity Edge Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Edge Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_EDGE_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ObjectFlowEdgeImpl <em>Object Flow Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ObjectFlowEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getObjectFlowEdge()
	 * @generated
	 */
	int OBJECT_FLOW_EDGE = 47;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__MODEL_ELEMENT = ACTIVITY_EDGE_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__OWNING_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__OWNED_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__LOCAL_STYLE = ACTIVITY_EDGE_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SHARED_STYLE = ACTIVITY_EDGE_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__TARGET_EDGE = ACTIVITY_EDGE_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SOURCE_EDGE = ACTIVITY_EDGE_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__DIAGRAM = ACTIVITY_EDGE_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__UML_MODEL_ELEMENT = ACTIVITY_EDGE_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SHARED_UML_STYLE = ACTIVITY_EDGE_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__LOCAL_UML_STYLE = ACTIVITY_EDGE_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__TARGET_UML_EDGE = ACTIVITY_EDGE_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SOURCE_UML_EDGE = ACTIVITY_EDGE_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ACTIVITY_EDGE_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__STEREOTYPE_LABEL = ACTIVITY_EDGE_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__UML_DIAGRAM = ACTIVITY_EDGE_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__DIAGRAM_COMPARTMENT = ACTIVITY_EDGE_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__MAIN_LABEL = ACTIVITY_EDGE_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SOURCE_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__WAYPOINT = ACTIVITY_EDGE_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__TARGET_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Guard Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__GUARD_LABEL = ACTIVITY_EDGE_EDGE__GUARD_LABEL;

	/**
	 * The feature id for the '<em><b>Weight Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__WEIGHT_LABEL = ACTIVITY_EDGE_EDGE__WEIGHT_LABEL;

	/**
	 * The feature id for the '<em><b>Transformation Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__TRANSFORMATION_LABEL = ACTIVITY_EDGE_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Selection Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE__SELECTION_LABEL = ACTIVITY_EDGE_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Object Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE_FEATURE_COUNT = ACTIVITY_EDGE_EDGE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE___DIAGRAM = ACTIVITY_EDGE_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Object Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_FLOW_EDGE_OPERATION_COUNT = ACTIVITY_EDGE_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.GuardLabelImpl <em>Guard Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.GuardLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGuardLabel()
	 * @generated
	 */
	int GUARD_LABEL = 49;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Activity Edge Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL__ACTIVITY_EDGE_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Guard Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Guard Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GUARD_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.WeightLabelImpl <em>Weight Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.WeightLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getWeightLabel()
	 * @generated
	 */
	int WEIGHT_LABEL = 50;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TransformationLabelImpl <em>Transformation Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TransformationLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTransformationLabel()
	 * @generated
	 */
	int TRANSFORMATION_LABEL = 51;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ConnectorEdgeImpl <em>Connector Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ConnectorEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConnectorEdge()
	 * @generated
	 */
	int CONNECTOR_EDGE = 56;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InstanceSpecificationEdgeImpl <em>Instance Specification Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InstanceSpecificationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInstanceSpecificationEdge()
	 * @generated
	 */
	int INSTANCE_SPECIFICATION_EDGE = 57;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DependencyEdgeImpl <em>Dependency Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DependencyEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDependencyEdge()
	 * @generated
	 */
	int DEPENDENCY_EDGE = 58;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentTargetShapeImpl <em>Deployment Target Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DeploymentTargetShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentTargetShape()
	 * @generated
	 */
	int DEPLOYMENT_TARGET_SHAPE = 60;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InstanceSpecificationShapeImpl <em>Instance Specification Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InstanceSpecificationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInstanceSpecificationShape()
	 * @generated
	 */
	int INSTANCE_SPECIFICATION_SHAPE = 59;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DeployedArtifactCompartmentImpl <em>Deployed Artifact Compartment</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DeployedArtifactCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeployedArtifactCompartment()
	 * @generated
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT = 61;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SlotCompartmentImpl <em>Slot Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SlotCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSlotCompartment()
	 * @generated
	 */
	int SLOT_COMPARTMENT = 62;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithNestedClassifiersShapeImpl
	 * <em>Classifier With Nested Classifiers Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithNestedClassifiersShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithNestedClassifiersShape()
	 * @generated
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE = 68;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ClassShapeImpl <em>Class Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ClassShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassShape()
	 * @generated
	 */
	int CLASS_SHAPE = 63;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithStructureShapeImpl <em>Element With Structure Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ElementWithStructureShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithStructureShape()
	 * @generated
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE = 65;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithPortsShapeImpl <em>Element With Ports Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ElementWithPortsShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithPortsShape()
	 * @generated
	 */
	int ELEMENT_WITH_PORTS_SHAPE = 64;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StructureCompartmentImpl <em>Structure Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StructureCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStructureCompartment()
	 * @generated
	 */
	int STRUCTURE_COMPARTMENT = 66;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PortShapeImpl <em>Port Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PortShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPortShape()
	 * @generated
	 */
	int PORT_SHAPE = 67;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.NestedClassifierCompartmentImpl <em>Nested Classifier Compartment</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.NestedClassifierCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNestedClassifierCompartment()
	 * @generated
	 */
	int NESTED_CLASSIFIER_COMPARTMENT = 69;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.BehavioredClassifierShapeImpl <em>Behaviored Classifier Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.BehavioredClassifierShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getBehavioredClassifierShape()
	 * @generated
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE = 70;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.OwnedBehaviorCompartmentImpl <em>Owned Behavior Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.OwnedBehaviorCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOwnedBehaviorCompartment()
	 * @generated
	 */
	int OWNED_BEHAVIOR_COMPARTMENT = 71;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InterfaceShapeImpl <em>Interface Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InterfaceShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInterfaceShape()
	 * @generated
	 */
	int INTERFACE_SHAPE = 72;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DataTypeShapeImpl <em>Data Type Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DataTypeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDataTypeShape()
	 * @generated
	 */
	int DATA_TYPE_SHAPE = 73;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PrimitiveTypeShapeImpl <em>Primitive Type Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PrimitiveTypeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPrimitiveTypeShape()
	 * @generated
	 */
	int PRIMITIVE_TYPE_SHAPE = 74;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SignalShapeImpl <em>Signal Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SignalShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSignalShape()
	 * @generated
	 */
	int SIGNAL_SHAPE = 75;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ModelShapeImpl <em>Model Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ModelShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getModelShape()
	 * @generated
	 */
	int MODEL_SHAPE = 76;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ContainmentEdgeImpl <em>Containment Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ContainmentEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getContainmentEdge()
	 * @generated
	 */
	int CONTAINMENT_EDGE = 77;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.GeneralizationEdgeImpl <em>Generalization Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.GeneralizationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGeneralizationEdge()
	 * @generated
	 */
	int GENERALIZATION_EDGE = 78;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.AbstractionEdgeImpl <em>Abstraction Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.AbstractionEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAbstractionEdge()
	 * @generated
	 */
	int ABSTRACTION_EDGE = 80;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.RealizationEdgeImpl <em>Realization Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.RealizationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRealizationEdge()
	 * @generated
	 */
	int REALIZATION_EDGE = 79;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InterfaceRealizationEdgeImpl <em>Interface Realization Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InterfaceRealizationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInterfaceRealizationEdge()
	 * @generated
	 */
	int INTERFACE_REALIZATION_EDGE = 81;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UsageEdgeImpl <em>Usage Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UsageEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUsageEdge()
	 * @generated
	 */
	int USAGE_EDGE = 82;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ElementImportEdgeImpl <em>Element Import Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ElementImportEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementImportEdge()
	 * @generated
	 */
	int ELEMENT_IMPORT_EDGE = 83;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PackageImportEdgeImpl <em>Package Import Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PackageImportEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageImportEdge()
	 * @generated
	 */
	int PACKAGE_IMPORT_EDGE = 84;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PackageMergeEdgeImpl <em>Package Merge Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PackageMergeEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageMergeEdge()
	 * @generated
	 */
	int PACKAGE_MERGE_EDGE = 85;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SubstitutionEdgeImpl <em>Substitution Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SubstitutionEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubstitutionEdge()
	 * @generated
	 */
	int SUBSTITUTION_EDGE = 86;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InformationFlowEdgeImpl <em>Information Flow Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InformationFlowEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInformationFlowEdge()
	 * @generated
	 */
	int INFORMATION_FLOW_EDGE = 87;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ConveyedLabelImpl <em>Conveyed Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ConveyedLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConveyedLabel()
	 * @generated
	 */
	int CONVEYED_LABEL = 88;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.AssociationClassEdgeImpl <em>Association Class Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.AssociationClassEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationClassEdge()
	 * @generated
	 */
	int ASSOCIATION_CLASS_EDGE = 89;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.CommentShapeImpl <em>Comment Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.CommentShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCommentShape()
	 * @generated
	 */
	int COMMENT_SHAPE = 90;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.AttachmentEdgeImpl <em>Attachment Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.AttachmentEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAttachmentEdge()
	 * @generated
	 */
	int ATTACHMENT_EDGE = 91;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.AssociationClassShapeImpl <em>Association Class Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.AssociationClassShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationClassShape()
	 * @generated
	 */
	int ASSOCIATION_CLASS_SHAPE = 92;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ComponentShapeImpl <em>Component Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ComponentShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getComponentShape()
	 * @generated
	 */
	int COMPONENT_SHAPE = 93;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InformationItemShapeImpl <em>Information Item Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InformationItemShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInformationItemShape()
	 * @generated
	 */
	int INFORMATION_ITEM_SHAPE = 94;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.RepresentationEdgeImpl <em>Representation Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.RepresentationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRepresentationEdge()
	 * @generated
	 */
	int REPRESENTATION_EDGE = 95;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.AssociationShapeImpl <em>Association Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.AssociationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationShape()
	 * @generated
	 */
	int ASSOCIATION_SHAPE = 96;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DependencyShapeImpl <em>Dependency Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DependencyShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDependencyShape()
	 * @generated
	 */
	int DEPENDENCY_SHAPE = 97;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TimeObservationShapeImpl <em>Time Observation Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TimeObservationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeObservationShape()
	 * @generated
	 */
	int TIME_OBSERVATION_SHAPE = 98;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DurationObservationShapeImpl <em>Duration Observation Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DurationObservationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDurationObservationShape()
	 * @generated
	 */
	int DURATION_OBSERVATION_SHAPE = 100;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PackageDiagramImpl <em>Package Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PackageDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageDiagram()
	 * @generated
	 */
	int PACKAGE_DIAGRAM = 101;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ProfileDiagramImpl <em>Profile Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ProfileDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProfileDiagram()
	 * @generated
	 */
	int PROFILE_DIAGRAM = 102;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.CompositeStructureDiagramImpl <em>Composite Structure Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.CompositeStructureDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCompositeStructureDiagram()
	 * @generated
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM = 103;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentDiagramImpl <em>Deployment Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DeploymentDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentDiagram()
	 * @generated
	 */
	int DEPLOYMENT_DIAGRAM = 104;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ComponentDiagramImpl <em>Component Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ComponentDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getComponentDiagram()
	 * @generated
	 */
	int COMPONENT_DIAGRAM = 105;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ObjectDiagramImpl <em>Object Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ObjectDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getObjectDiagram()
	 * @generated
	 */
	int OBJECT_DIAGRAM = 106;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ProfileShapeImpl <em>Profile Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ProfileShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProfileShape()
	 * @generated
	 */
	int PROFILE_SHAPE = 107;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ProfileApplicationEdgeImpl <em>Profile Application Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ProfileApplicationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProfileApplicationEdge()
	 * @generated
	 */
	int PROFILE_APPLICATION_EDGE = 108;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExtensionEdgeImpl <em>Extension Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExtensionEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExtensionEdge()
	 * @generated
	 */
	int EXTENSION_EDGE = 109;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.BehaviorDiagramImpl <em>Behavior Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.BehaviorDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getBehaviorDiagram()
	 * @generated
	 */
	int BEHAVIOR_DIAGRAM = 110;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UseCaseDiagramImpl <em>Use Case Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UseCaseDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUseCaseDiagram()
	 * @generated
	 */
	int USE_CASE_DIAGRAM = 111;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ArtifactShapeImpl <em>Artifact Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ArtifactShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getArtifactShape()
	 * @generated
	 */
	int ARTIFACT_SHAPE = 112;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.NestedArtifactCompartmentImpl <em>Nested Artifact Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.NestedArtifactCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNestedArtifactCompartment()
	 * @generated
	 */
	int NESTED_ARTIFACT_COMPARTMENT = 113;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ComponentRealizationEdgeImpl <em>Component Realization Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ComponentRealizationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getComponentRealizationEdge()
	 * @generated
	 */
	int COMPONENT_REALIZATION_EDGE = 114;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ManifestationEdgeImpl <em>Manifestation Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ManifestationEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getManifestationEdge()
	 * @generated
	 */
	int MANIFESTATION_EDGE = 115;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PropertyShapeImpl <em>Property Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PropertyShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPropertyShape()
	 * @generated
	 */
	int PROPERTY_SHAPE = 116;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.CollaborationShapeImpl <em>Collaboration Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.CollaborationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCollaborationShape()
	 * @generated
	 */
	int COLLABORATION_SHAPE = 117;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.CollaborationUseShapeImpl <em>Collaboration Use Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.CollaborationUseShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCollaborationUseShape()
	 * @generated
	 */
	int COLLABORATION_USE_SHAPE = 118;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TemplateBindingEdgeImpl <em>Template Binding Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TemplateBindingEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTemplateBindingEdge()
	 * @generated
	 */
	int TEMPLATE_BINDING_EDGE = 119;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StereotypeShapeImpl <em>Stereotype Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StereotypeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypeShape()
	 * @generated
	 */
	int STEREOTYPE_SHAPE = 120;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.NodeShapeImpl <em>Node Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.NodeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNodeShape()
	 * @generated
	 */
	int NODE_SHAPE = 121;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.NestedNodeCompartmentImpl <em>Nested Node Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.NestedNodeCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNestedNodeCompartment()
	 * @generated
	 */
	int NESTED_NODE_COMPARTMENT = 122;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DeviceShapeImpl <em>Device Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DeviceShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeviceShape()
	 * @generated
	 */
	int DEVICE_SHAPE = 123;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExecutionEnvironmentShapeImpl <em>Execution Environment Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExecutionEnvironmentShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExecutionEnvironmentShape()
	 * @generated
	 */
	int EXECUTION_ENVIRONMENT_SHAPE = 124;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityShapeImpl <em>Activity Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityShape()
	 * @generated
	 */
	int ACTIVITY_SHAPE = 125;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithActivityNodesShapeImpl <em>Element With Activity Nodes Shape</em>}
	 * ' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ElementWithActivityNodesShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithActivityNodesShape()
	 * @generated
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE = 126;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityNodeCompartmentImpl <em>Activity Node Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityNodeCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityNodeCompartment()
	 * @generated
	 */
	int ACTIVITY_NODE_COMPARTMENT = 127;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ParameterCompartmentImpl <em>Parameter Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ParameterCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getParameterCompartment()
	 * @generated
	 */
	int PARAMETER_COMPARTMENT = 128;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PostConditionCompartmentImpl <em>Post Condition Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PostConditionCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPostConditionCompartment()
	 * @generated
	 */
	int POST_CONDITION_COMPARTMENT = 129;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PreConditionCompartmentImpl <em>Pre Condition Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PreConditionCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPreConditionCompartment()
	 * @generated
	 */
	int PRE_CONDITION_COMPARTMENT = 130;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityParameterNodeShapeImpl <em>Activity Parameter Node Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityParameterNodeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityParameterNodeShape()
	 * @generated
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE = 131;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionShapeImpl <em>Interaction Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionShape()
	 * @generated
	 */
	int INTERACTION_SHAPE = 132;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionFragmentShapeImpl <em>Interaction Fragment Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionFragmentShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionFragmentShape()
	 * @generated
	 */
	int INTERACTION_FRAGMENT_SHAPE = 53;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionFragmentWithSubfragmentsShapeImpl
	 * <em>Interaction Fragment With Subfragments Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionFragmentWithSubfragmentsShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionFragmentWithSubfragmentsShape()
	 * @generated
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE = 133;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SubfragmentCompartmentImpl <em>Subfragment Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SubfragmentCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubfragmentCompartment()
	 * @generated
	 */
	int SUBFRAGMENT_COMPARTMENT = 134;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionFragmentWithGatesShapeImpl
	 * <em>Interaction Fragment With Gates Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionFragmentWithGatesShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionFragmentWithGatesShape()
	 * @generated
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE = 135;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.GateShapeImpl <em>Gate Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.GateShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGateShape()
	 * @generated
	 */
	int GATE_SHAPE = 136;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.OpaqueBehaviorShapeImpl <em>Opaque Behavior Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.OpaqueBehaviorShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOpaqueBehaviorShape()
	 * @generated
	 */
	int OPAQUE_BEHAVIOR_SHAPE = 137;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.FunctionBehaviorShapeImpl <em>Function Behavior Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.FunctionBehaviorShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getFunctionBehaviorShape()
	 * @generated
	 */
	int FUNCTION_BEHAVIOR_SHAPE = 138;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StateMachineShapeImpl <em>State Machine Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StateMachineShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateMachineShape()
	 * @generated
	 */
	int STATE_MACHINE_SHAPE = 139;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.BaseStateShapeImpl <em>Base State Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.BaseStateShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getBaseStateShape()
	 * @generated
	 */
	int BASE_STATE_SHAPE = 140;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PseudostateShapeImpl <em>Pseudostate Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PseudostateShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPseudostateShape()
	 * @generated
	 */
	int PSEUDOSTATE_SHAPE = 141;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.RegionCompartmentImpl <em>Region Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.RegionCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRegionCompartment()
	 * @generated
	 */
	int REGION_COMPARTMENT = 142;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ProtocolStateMachineShapeImpl <em>Protocol State Machine Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ProtocolStateMachineShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProtocolStateMachineShape()
	 * @generated
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE = 143;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentSpecificationShapeImpl <em>Deployment Specification Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DeploymentSpecificationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentSpecificationShape()
	 * @generated
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE = 144;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.CommunicationPathEdgeImpl <em>Communication Path Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.CommunicationPathEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCommunicationPathEdge()
	 * @generated
	 */
	int COMMUNICATION_PATH_EDGE = 145;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentEdgeImpl <em>Deployment Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DeploymentEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentEdge()
	 * @generated
	 */
	int DEPLOYMENT_EDGE = 146;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActorShapeImpl <em>Actor Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActorShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActorShape()
	 * @generated
	 */
	int ACTOR_SHAPE = 147;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExtensionPointCompartmentImpl <em>Extension Point Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExtensionPointCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExtensionPointCompartment()
	 * @generated
	 */
	int EXTENSION_POINT_COMPARTMENT = 148;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.UseCaseShapeImpl <em>Use Case Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.UseCaseShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUseCaseShape()
	 * @generated
	 */
	int USE_CASE_SHAPE = 149;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.IncludeEdgeImpl <em>Include Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.IncludeEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getIncludeEdge()
	 * @generated
	 */
	int INCLUDE_EDGE = 150;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExtendEdgeImpl <em>Extend Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExtendEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExtendEdge()
	 * @generated
	 */
	int EXTEND_EDGE = 151;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StateMachineDiagramImpl <em>State Machine Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StateMachineDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateMachineDiagram()
	 * @generated
	 */
	int STATE_MACHINE_DIAGRAM = 152;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityDiagramImpl <em>Activity Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityDiagram()
	 * @generated
	 */
	int ACTIVITY_DIAGRAM = 153;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionDiagramImpl <em>Interaction Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionDiagram()
	 * @generated
	 */
	int INTERACTION_DIAGRAM = 155;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SequenceDiagramImpl <em>Sequence Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SequenceDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSequenceDiagram()
	 * @generated
	 */
	int SEQUENCE_DIAGRAM = 154;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.CommunicationDiagramImpl <em>Communication Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.CommunicationDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCommunicationDiagram()
	 * @generated
	 */
	int COMMUNICATION_DIAGRAM = 156;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TimingDiagramImpl <em>Timing Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TimingDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimingDiagram()
	 * @generated
	 */
	int TIMING_DIAGRAM = 157;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionOverviewDiagramImpl <em>Interaction Overview Diagram</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionOverviewDiagramImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionOverviewDiagram()
	 * @generated
	 */
	int INTERACTION_OVERVIEW_DIAGRAM = 158;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InternalBehaviorCompartmentImpl <em>Internal Behavior Compartment</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InternalBehaviorCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInternalBehaviorCompartment()
	 * @generated
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT = 159;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StateShapeImpl <em>State Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StateShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateShape()
	 * @generated
	 */
	int STATE_SHAPE = 160;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ConnectionPointReferenceShapeImpl <em>Connection Point Reference Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ConnectionPointReferenceShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConnectionPointReferenceShape()
	 * @generated
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE = 161;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InternalTransitionCompartmentImpl <em>Internal Transition Compartment</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InternalTransitionCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInternalTransitionCompartment()
	 * @generated
	 */
	int INTERNAL_TRANSITION_COMPARTMENT = 162;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DeferrableTriggerCompartmentImpl <em>Deferrable Trigger Compartment</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DeferrableTriggerCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeferrableTriggerCompartment()
	 * @generated
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT = 163;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.RegionShapeImpl <em>Region Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.RegionShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRegionShape()
	 * @generated
	 */
	int REGION_SHAPE = 164;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SubvertexCompartmentImpl <em>Subvertex Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SubvertexCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubvertexCompartment()
	 * @generated
	 */
	int SUBVERTEX_COMPARTMENT = 165;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TransitionEdgeImpl <em>Transition Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TransitionEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTransitionEdge()
	 * @generated
	 */
	int TRANSITION_EDGE = 166;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ControlFlowEdgeImpl <em>Control Flow Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ControlFlowEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getControlFlowEdge()
	 * @generated
	 */
	int CONTROL_FLOW_EDGE = 167;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityGroupShapeImpl <em>Activity Group Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityGroupShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityGroupShape()
	 * @generated
	 */
	int ACTIVITY_GROUP_SHAPE = 168;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExceptionHandlerEdgeImpl <em>Exception Handler Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExceptionHandlerEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExceptionHandlerEdge()
	 * @generated
	 */
	int EXCEPTION_HANDLER_EDGE = 169;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TypeLabelImpl <em>Type Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TypeLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTypeLabel()
	 * @generated
	 */
	int TYPE_LABEL = 170;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.IconLabelImpl <em>Icon Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.IconLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getIconLabel()
	 * @generated
	 */
	int ICON_LABEL = 172;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActionShapeImpl <em>Action Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActionShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActionShape()
	 * @generated
	 */
	int ACTION_SHAPE = 54;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PinShapeImpl <em>Pin Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PinShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPinShape()
	 * @generated
	 */
	int PIN_SHAPE = 55;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.SubpartitionCompartmentImpl <em>Subpartition Compartment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.SubpartitionCompartmentImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubpartitionCompartment()
	 * @generated
	 */
	int SUBPARTITION_COMPARTMENT = 173;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ActivityPartitionShapeImpl <em>Activity Partition Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ActivityPartitionShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityPartitionShape()
	 * @generated
	 */
	int ACTIVITY_PARTITION_SHAPE = 174;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StructuredActivityNodeShapeImpl <em>Structured Activity Node Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StructuredActivityNodeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStructuredActivityNodeShape()
	 * @generated
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE = 175;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExpansionRegionShapeImpl <em>Expansion Region Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExpansionRegionShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExpansionRegionShape()
	 * @generated
	 */
	int EXPANSION_REGION_SHAPE = 176;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExpansionNodeShapeImpl <em>Expansion Node Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExpansionNodeShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExpansionNodeShape()
	 * @generated
	 */
	int EXPANSION_NODE_SHAPE = 177;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.LifelineShapeImpl <em>Lifeline Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.LifelineShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getLifelineShape()
	 * @generated
	 */
	int LIFELINE_SHAPE = 52;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.MessageEdgeImpl <em>Message Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.MessageEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMessageEdge()
	 * @generated
	 */
	int MESSAGE_EDGE = 178;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.GeneralOrderingEdgeImpl <em>General Ordering Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.GeneralOrderingEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGeneralOrderingEdge()
	 * @generated
	 */
	int GENERAL_ORDERING_EDGE = 179;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.CombinedFragmentShapeImpl <em>Combined Fragment Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.CombinedFragmentShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCombinedFragmentShape()
	 * @generated
	 */
	int COMBINED_FRAGMENT_SHAPE = 180;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionUseShapeImpl <em>Interaction Use Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionUseShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionUseShape()
	 * @generated
	 */
	int INTERACTION_USE_SHAPE = 171;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.InteractionOperandShapeImpl <em>Interaction Operand Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.InteractionOperandShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionOperandShape()
	 * @generated
	 */
	int INTERACTION_OPERAND_SHAPE = 181;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Activity Edge Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL__ACTIVITY_EDGE_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Weight Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Weight Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int WEIGHT_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Object Flow Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL__OBJECT_FLOW_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Transformation Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Transformation Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TimeObservationShape_TimeObservationShapeImpl
	 * <em>Time Observation Shape Time Observation Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TimeObservationShape_TimeObservationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeObservationShape_TimeObservationShape()
	 * @generated
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE = 99;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Subfragment Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__SUBFRAGMENT_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nesting Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__NESTING_LIFELINE_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Nested Lifeline Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__NESTED_LIFELINE_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Constraint Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE__CONSTRAINT_LABEL = ELEMENT_SHAPE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Lifeline Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 4;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Lifeline Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int LIFELINE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE__LIFELINE_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Interaction Fragment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Fragment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__MODEL_ELEMENT = ACTIVITY_NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__OWNING_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__OWNED_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__LOCAL_STYLE = ACTIVITY_NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__SHARED_STYLE = ACTIVITY_NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__TARGET_EDGE = ACTIVITY_NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__SOURCE_EDGE = ACTIVITY_NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__DIAGRAM = ACTIVITY_NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__UML_MODEL_ELEMENT = ACTIVITY_NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__SHARED_UML_STYLE = ACTIVITY_NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__LOCAL_UML_STYLE = ACTIVITY_NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ACTIVITY_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__TARGET_UML_EDGE = ACTIVITY_NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__SOURCE_UML_EDGE = ACTIVITY_NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ACTIVITY_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__STEREOTYPE_LABEL = ACTIVITY_NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__UML_DIAGRAM = ACTIVITY_NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__DIAGRAM_COMPARTMENT = ACTIVITY_NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__MAIN_LABEL = ACTIVITY_NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__BOUNDS = ACTIVITY_NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__STEREOTYPE_COMPARTMENT = ACTIVITY_NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Pin Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__PIN_SHAPE = ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Condition Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE__CONDITION_LABEL = ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Action Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE_FEATURE_COUNT = ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE___DIAGRAM = ACTIVITY_NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Action Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTION_SHAPE_OPERATION_COUNT = ACTIVITY_NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__MODEL_ELEMENT = OBJECT_NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__OWNING_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__OWNED_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__LOCAL_STYLE = OBJECT_NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__SHARED_STYLE = OBJECT_NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__TARGET_EDGE = OBJECT_NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__SOURCE_EDGE = OBJECT_NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__DIAGRAM = OBJECT_NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__UML_MODEL_ELEMENT = OBJECT_NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__SHARED_UML_STYLE = OBJECT_NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__LOCAL_UML_STYLE = OBJECT_NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__TARGET_UML_EDGE = OBJECT_NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__SOURCE_UML_EDGE = OBJECT_NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = OBJECT_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__STEREOTYPE_LABEL = OBJECT_NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__UML_DIAGRAM = OBJECT_NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__DIAGRAM_COMPARTMENT = OBJECT_NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__MAIN_LABEL = OBJECT_NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__BOUNDS = OBJECT_NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__STEREOTYPE_COMPARTMENT = OBJECT_NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Selection Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__SELECTION_LABEL = OBJECT_NODE_SHAPE__SELECTION_LABEL;

	/**
	 * The feature id for the '<em><b>Constraint Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__CONSTRAINT_LABEL = OBJECT_NODE_SHAPE__CONSTRAINT_LABEL;

	/**
	 * The feature id for the '<em><b>Action Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE__ACTION_SHAPE = OBJECT_NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Pin Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE_FEATURE_COUNT = OBJECT_NODE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE___DIAGRAM = OBJECT_NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Pin Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PIN_SHAPE_OPERATION_COUNT = OBJECT_NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>End Multiplicity Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE__END_MULTIPLICITY_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Connector Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Connector Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTOR_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>End Role Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE__END_ROLE_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Instance Specification Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Instance Specification Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE__ROLE_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Dependency Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Dependency Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Deployed Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Deployment Target Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Deployment Target Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_TARGET_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__MODEL_ELEMENT = DEPLOYMENT_TARGET_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__OWNING_DIAGRAM_ELEMENT = DEPLOYMENT_TARGET_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__OWNED_DIAGRAM_ELEMENT = DEPLOYMENT_TARGET_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__LOCAL_STYLE = DEPLOYMENT_TARGET_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__SHARED_STYLE = DEPLOYMENT_TARGET_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__TARGET_EDGE = DEPLOYMENT_TARGET_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__SOURCE_EDGE = DEPLOYMENT_TARGET_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__DIAGRAM = DEPLOYMENT_TARGET_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__UML_MODEL_ELEMENT = DEPLOYMENT_TARGET_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__SHARED_UML_STYLE = DEPLOYMENT_TARGET_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__LOCAL_UML_STYLE = DEPLOYMENT_TARGET_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = DEPLOYMENT_TARGET_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = DEPLOYMENT_TARGET_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__TARGET_UML_EDGE = DEPLOYMENT_TARGET_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__SOURCE_UML_EDGE = DEPLOYMENT_TARGET_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = DEPLOYMENT_TARGET_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__STEREOTYPE_LABEL = DEPLOYMENT_TARGET_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__UML_DIAGRAM = DEPLOYMENT_TARGET_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__DIAGRAM_COMPARTMENT = DEPLOYMENT_TARGET_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__MAIN_LABEL = DEPLOYMENT_TARGET_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__BOUNDS = DEPLOYMENT_TARGET_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__STEREOTYPE_COMPARTMENT = DEPLOYMENT_TARGET_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Deployed Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT = DEPLOYMENT_TARGET_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Slot Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE__SLOT_COMPARTMENT = DEPLOYMENT_TARGET_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Instance Specification Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE_FEATURE_COUNT = DEPLOYMENT_TARGET_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE___DIAGRAM = DEPLOYMENT_TARGET_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Instance Specification Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INSTANCE_SPECIFICATION_SHAPE_OPERATION_COUNT = DEPLOYMENT_TARGET_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__LOCAL_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__SHARED_STYLE = CLASSIFIER_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__TARGET_EDGE = CLASSIFIER_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__SOURCE_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__DIAGRAM = CLASSIFIER_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__UML_MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__SHARED_UML_STYLE = CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__LOCAL_UML_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__TARGET_UML_EDGE = CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__SOURCE_UML_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__BOUNDS = CLASSIFIER_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__LIST_ITEM_LABEL = CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Layout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__LAYOUT = CLASSIFIER_COMPARTMENT__LAYOUT;

	/**
	 * The feature id for the '<em><b>Deployment Target Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT__DEPLOYMENT_TARGET_SHAPE = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Deployed Artifact Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT_FEATURE_COUNT = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT___DIAGRAM = CLASSIFIER_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Deployed Artifact Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYED_ARTIFACT_COMPARTMENT_OPERATION_COUNT = CLASSIFIER_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Instance Specification Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT__INSTANCE_SPECIFICATION_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Slot Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Slot Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SLOT_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__DIAGRAM = CLASSIFIER_WITH_RECEPTIONS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_RECEPTIONS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_RECEPTIONS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_RECEPTIONS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_RECEPTIONS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_RECEPTIONS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__BOUNDS = CLASSIFIER_WITH_RECEPTIONS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_RECEPTIONS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__RECEPTION_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASSIFIER_WITH_RECEPTIONS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Classifier With Nested Classifiers Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_RECEPTIONS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE___DIAGRAM = CLASSIFIER_WITH_RECEPTIONS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Classifier With Nested Classifiers Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_RECEPTIONS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__DIAGRAM = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__BOUNDS = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__RECEPTION_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__STRUCTURE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE__PORT_SHAPE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Class Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE___DIAGRAM = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Class Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CLASS_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE__STRUCTURE_COMPARTMENT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Element With Structure Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Element With Structure Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_STRUCTURE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__MODEL_ELEMENT = ELEMENT_WITH_STRUCTURE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_WITH_STRUCTURE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_WITH_STRUCTURE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__LOCAL_STYLE = ELEMENT_WITH_STRUCTURE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__SHARED_STYLE = ELEMENT_WITH_STRUCTURE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__TARGET_EDGE = ELEMENT_WITH_STRUCTURE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__SOURCE_EDGE = ELEMENT_WITH_STRUCTURE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__DIAGRAM = ELEMENT_WITH_STRUCTURE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__UML_MODEL_ELEMENT = ELEMENT_WITH_STRUCTURE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__SHARED_UML_STYLE = ELEMENT_WITH_STRUCTURE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__LOCAL_UML_STYLE = ELEMENT_WITH_STRUCTURE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_WITH_STRUCTURE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_WITH_STRUCTURE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__TARGET_UML_EDGE = ELEMENT_WITH_STRUCTURE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__SOURCE_UML_EDGE = ELEMENT_WITH_STRUCTURE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_WITH_STRUCTURE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__STEREOTYPE_LABEL = ELEMENT_WITH_STRUCTURE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__UML_DIAGRAM = ELEMENT_WITH_STRUCTURE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_WITH_STRUCTURE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__MAIN_LABEL = ELEMENT_WITH_STRUCTURE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__BOUNDS = ELEMENT_WITH_STRUCTURE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_WITH_STRUCTURE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__STRUCTURE_COMPARTMENT = ELEMENT_WITH_STRUCTURE_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE__PORT_SHAPE = ELEMENT_WITH_STRUCTURE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Element With Ports Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE_FEATURE_COUNT = ELEMENT_WITH_STRUCTURE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE___DIAGRAM = ELEMENT_WITH_STRUCTURE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Element With Ports Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_PORTS_SHAPE_OPERATION_COUNT = ELEMENT_WITH_STRUCTURE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Element With Structure Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT__ELEMENT_WITH_STRUCTURE_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Structure Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Structure Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURE_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Element With Ports Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE__ELEMENT_WITH_PORTS_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Port Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Port Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PORT_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__LOCAL_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__SHARED_STYLE = CLASSIFIER_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__TARGET_EDGE = CLASSIFIER_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__SOURCE_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__DIAGRAM = CLASSIFIER_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE = CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE = CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__BOUNDS = CLASSIFIER_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL = CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Layout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__LAYOUT = CLASSIFIER_COMPARTMENT__LAYOUT;

	/**
	 * The feature id for the '<em><b>Classifier With Nested Classifiers Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT__CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Nested Classifier Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT_FEATURE_COUNT = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT___DIAGRAM = CLASSIFIER_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Nested Classifier Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_CLASSIFIER_COMPARTMENT_OPERATION_COUNT = CLASSIFIER_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__MODEL_ELEMENT = CLASSIFIER_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__LOCAL_STYLE = CLASSIFIER_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__SHARED_STYLE = CLASSIFIER_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__TARGET_EDGE = CLASSIFIER_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__SOURCE_EDGE = CLASSIFIER_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__DIAGRAM = CLASSIFIER_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__SHARED_UML_STYLE = CLASSIFIER_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__TARGET_UML_EDGE = CLASSIFIER_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__UML_DIAGRAM = CLASSIFIER_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__MAIN_LABEL = CLASSIFIER_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__BOUNDS = CLASSIFIER_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASSIFIER_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Behaviored Classifier Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE_FEATURE_COUNT = CLASSIFIER_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE___DIAGRAM = CLASSIFIER_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Behaviored Classifier Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIORED_CLASSIFIER_SHAPE_OPERATION_COUNT = CLASSIFIER_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__LOCAL_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__SHARED_STYLE = CLASSIFIER_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__TARGET_EDGE = CLASSIFIER_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__SOURCE_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__DIAGRAM = CLASSIFIER_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__UML_MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__SHARED_UML_STYLE = CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__LOCAL_UML_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__TARGET_UML_EDGE = CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__SOURCE_UML_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__BOUNDS = CLASSIFIER_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__LIST_ITEM_LABEL = CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Layout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__LAYOUT = CLASSIFIER_COMPARTMENT__LAYOUT;

	/**
	 * The feature id for the '<em><b>Behaviored Classifier Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT__BEHAVIORED_CLASSIFIER_SHAPE = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Owned Behavior Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT_FEATURE_COUNT = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT___DIAGRAM = CLASSIFIER_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Owned Behavior Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OWNED_BEHAVIOR_COMPARTMENT_OPERATION_COUNT = CLASSIFIER_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__DIAGRAM = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__BOUNDS = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__RECEPTION_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Interface Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE___DIAGRAM = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interface Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__BOUNDS = CLASSIFIER_WITH_OPERATIONS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Data Type Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE___DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Data Type Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DATA_TYPE_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__MODEL_ELEMENT = DATA_TYPE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__OWNING_DIAGRAM_ELEMENT = DATA_TYPE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__OWNED_DIAGRAM_ELEMENT = DATA_TYPE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__LOCAL_STYLE = DATA_TYPE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__SHARED_STYLE = DATA_TYPE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__TARGET_EDGE = DATA_TYPE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__SOURCE_EDGE = DATA_TYPE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__DIAGRAM = DATA_TYPE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__UML_MODEL_ELEMENT = DATA_TYPE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__SHARED_UML_STYLE = DATA_TYPE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__LOCAL_UML_STYLE = DATA_TYPE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = DATA_TYPE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = DATA_TYPE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__TARGET_UML_EDGE = DATA_TYPE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__SOURCE_UML_EDGE = DATA_TYPE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = DATA_TYPE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__STEREOTYPE_LABEL = DATA_TYPE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__UML_DIAGRAM = DATA_TYPE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__DIAGRAM_COMPARTMENT = DATA_TYPE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__MAIN_LABEL = DATA_TYPE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__BOUNDS = DATA_TYPE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__STEREOTYPE_COMPARTMENT = DATA_TYPE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = DATA_TYPE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__USE_CLASSIFIER_NOTATION = DATA_TYPE_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__OWNED_USE_CASE_COMPARTMENT = DATA_TYPE_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__USE_CASE_COMPARTMENT = DATA_TYPE_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__ATTRIBUTE_COMPARTMENT = DATA_TYPE_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE__OPERATION_COMPARTMENT = DATA_TYPE_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Primitive Type Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE_FEATURE_COUNT = DATA_TYPE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE___DIAGRAM = DATA_TYPE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Primitive Type Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRIMITIVE_TYPE_SHAPE_OPERATION_COUNT = DATA_TYPE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__DIAGRAM = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__BOUNDS = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Signal Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE___DIAGRAM = CLASSIFIER_WITH_ATTRIBUTES_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Signal Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SIGNAL_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_ATTRIBUTES_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__MODEL_ELEMENT = PACKAGE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__OWNING_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__OWNED_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__LOCAL_STYLE = PACKAGE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__SHARED_STYLE = PACKAGE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__TARGET_EDGE = PACKAGE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__SOURCE_EDGE = PACKAGE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__DIAGRAM = PACKAGE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__UML_MODEL_ELEMENT = PACKAGE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__SHARED_UML_STYLE = PACKAGE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__LOCAL_UML_STYLE = PACKAGE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__TARGET_UML_EDGE = PACKAGE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__SOURCE_UML_EDGE = PACKAGE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = PACKAGE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__STEREOTYPE_LABEL = PACKAGE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__UML_DIAGRAM = PACKAGE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__DIAGRAM_COMPARTMENT = PACKAGE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__MAIN_LABEL = PACKAGE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__BOUNDS = PACKAGE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__STEREOTYPE_COMPARTMENT = PACKAGE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Packaged Element Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__PACKAGED_ELEMENT_COMPARTMENT = PACKAGE_SHAPE__PACKAGED_ELEMENT_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = PACKAGE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Model Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE_FEATURE_COUNT = PACKAGE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE___DIAGRAM = PACKAGE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Model Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MODEL_SHAPE_OPERATION_COUNT = PACKAGE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__MODEL_ELEMENT = UML_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__OWNING_DIAGRAM_ELEMENT = UML_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__OWNED_DIAGRAM_ELEMENT = UML_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__LOCAL_STYLE = UML_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__SHARED_STYLE = UML_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__TARGET_EDGE = UML_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__SOURCE_EDGE = UML_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__DIAGRAM = UML_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__UML_MODEL_ELEMENT = UML_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__SHARED_UML_STYLE = UML_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__LOCAL_UML_STYLE = UML_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__TARGET_UML_EDGE = UML_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__SOURCE_UML_EDGE = UML_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = UML_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__STEREOTYPE_LABEL = UML_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__UML_DIAGRAM = UML_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__DIAGRAM_COMPARTMENT = UML_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__MAIN_LABEL = UML_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__SOURCE_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__WAYPOINT = UML_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__TARGET_DIAGRAM_ELEMENT = UML_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT = UML_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Containment Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE_FEATURE_COUNT = UML_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE___DIAGRAM = UML_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Containment Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_EDGE_OPERATION_COUNT = UML_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Generalization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Generalization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERALIZATION_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__MODEL_ELEMENT = DEPENDENCY_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__OWNING_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__OWNED_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__LOCAL_STYLE = DEPENDENCY_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__SHARED_STYLE = DEPENDENCY_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__TARGET_EDGE = DEPENDENCY_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__SOURCE_EDGE = DEPENDENCY_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__DIAGRAM = DEPENDENCY_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__UML_MODEL_ELEMENT = DEPENDENCY_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__SHARED_UML_STYLE = DEPENDENCY_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__LOCAL_UML_STYLE = DEPENDENCY_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__TARGET_UML_EDGE = DEPENDENCY_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__SOURCE_UML_EDGE = DEPENDENCY_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = DEPENDENCY_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__STEREOTYPE_LABEL = DEPENDENCY_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__UML_DIAGRAM = DEPENDENCY_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__DIAGRAM_COMPARTMENT = DEPENDENCY_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__MAIN_LABEL = DEPENDENCY_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__SOURCE_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__WAYPOINT = DEPENDENCY_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__TARGET_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE__ROLE_LABEL = DEPENDENCY_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Abstraction Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE_FEATURE_COUNT = DEPENDENCY_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE___DIAGRAM = DEPENDENCY_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Abstraction Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ABSTRACTION_EDGE_OPERATION_COUNT = DEPENDENCY_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__MODEL_ELEMENT = ABSTRACTION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__OWNING_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__OWNED_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__LOCAL_STYLE = ABSTRACTION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__SHARED_STYLE = ABSTRACTION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__TARGET_EDGE = ABSTRACTION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__SOURCE_EDGE = ABSTRACTION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__DIAGRAM = ABSTRACTION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__UML_MODEL_ELEMENT = ABSTRACTION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__SHARED_UML_STYLE = ABSTRACTION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__LOCAL_UML_STYLE = ABSTRACTION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__TARGET_UML_EDGE = ABSTRACTION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__SOURCE_UML_EDGE = ABSTRACTION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ABSTRACTION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__STEREOTYPE_LABEL = ABSTRACTION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__UML_DIAGRAM = ABSTRACTION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__DIAGRAM_COMPARTMENT = ABSTRACTION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__MAIN_LABEL = ABSTRACTION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__SOURCE_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__WAYPOINT = ABSTRACTION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__TARGET_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE__ROLE_LABEL = ABSTRACTION_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Realization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE_FEATURE_COUNT = ABSTRACTION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE___DIAGRAM = ABSTRACTION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Realization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REALIZATION_EDGE_OPERATION_COUNT = ABSTRACTION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__MODEL_ELEMENT = REALIZATION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__OWNING_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__OWNED_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__LOCAL_STYLE = REALIZATION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__SHARED_STYLE = REALIZATION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__TARGET_EDGE = REALIZATION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__SOURCE_EDGE = REALIZATION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__DIAGRAM = REALIZATION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__UML_MODEL_ELEMENT = REALIZATION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__SHARED_UML_STYLE = REALIZATION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__LOCAL_UML_STYLE = REALIZATION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__TARGET_UML_EDGE = REALIZATION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__SOURCE_UML_EDGE = REALIZATION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = REALIZATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__STEREOTYPE_LABEL = REALIZATION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__UML_DIAGRAM = REALIZATION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__DIAGRAM_COMPARTMENT = REALIZATION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__MAIN_LABEL = REALIZATION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__SOURCE_DIAGRAM_ELEMENT = REALIZATION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__WAYPOINT = REALIZATION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__TARGET_DIAGRAM_ELEMENT = REALIZATION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE__ROLE_LABEL = REALIZATION_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Interface Realization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE_FEATURE_COUNT = REALIZATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE___DIAGRAM = REALIZATION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interface Realization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERFACE_REALIZATION_EDGE_OPERATION_COUNT = REALIZATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__MODEL_ELEMENT = DEPENDENCY_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__OWNING_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__OWNED_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__LOCAL_STYLE = DEPENDENCY_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__SHARED_STYLE = DEPENDENCY_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__TARGET_EDGE = DEPENDENCY_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__SOURCE_EDGE = DEPENDENCY_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__DIAGRAM = DEPENDENCY_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__UML_MODEL_ELEMENT = DEPENDENCY_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__SHARED_UML_STYLE = DEPENDENCY_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__LOCAL_UML_STYLE = DEPENDENCY_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__OWNED_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__OWNING_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__TARGET_UML_EDGE = DEPENDENCY_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__SOURCE_UML_EDGE = DEPENDENCY_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = DEPENDENCY_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__STEREOTYPE_LABEL = DEPENDENCY_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__UML_DIAGRAM = DEPENDENCY_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__DIAGRAM_COMPARTMENT = DEPENDENCY_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__MAIN_LABEL = DEPENDENCY_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__SOURCE_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__WAYPOINT = DEPENDENCY_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__TARGET_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__TARGET_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE__ROLE_LABEL = DEPENDENCY_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Usage Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE_FEATURE_COUNT = DEPENDENCY_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE___DIAGRAM = DEPENDENCY_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Usage Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USAGE_EDGE_OPERATION_COUNT = DEPENDENCY_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Element Import Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Element Import Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_IMPORT_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Package Import Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Package Import Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_IMPORT_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Package Merge Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Package Merge Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_MERGE_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__MODEL_ELEMENT = REALIZATION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__OWNING_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__OWNED_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__LOCAL_STYLE = REALIZATION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__SHARED_STYLE = REALIZATION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__TARGET_EDGE = REALIZATION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__SOURCE_EDGE = REALIZATION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__DIAGRAM = REALIZATION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__UML_MODEL_ELEMENT = REALIZATION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__SHARED_UML_STYLE = REALIZATION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__LOCAL_UML_STYLE = REALIZATION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__TARGET_UML_EDGE = REALIZATION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__SOURCE_UML_EDGE = REALIZATION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = REALIZATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__STEREOTYPE_LABEL = REALIZATION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__UML_DIAGRAM = REALIZATION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__DIAGRAM_COMPARTMENT = REALIZATION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__MAIN_LABEL = REALIZATION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__SOURCE_DIAGRAM_ELEMENT = REALIZATION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__WAYPOINT = REALIZATION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__TARGET_DIAGRAM_ELEMENT = REALIZATION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE__ROLE_LABEL = REALIZATION_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Substitution Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE_FEATURE_COUNT = REALIZATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE___DIAGRAM = REALIZATION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Substitution Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_EDGE_OPERATION_COUNT = REALIZATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Conveyed Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE__CONVEYED_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Information Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Information Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_FLOW_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Information Flow Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL__INFORMATION_FLOW_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Conveyed Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Conveyed Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONVEYED_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__MODEL_ELEMENT = ASSOCIATION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__OWNING_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__OWNED_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__LOCAL_STYLE = ASSOCIATION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__SHARED_STYLE = ASSOCIATION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__TARGET_EDGE = ASSOCIATION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__SOURCE_EDGE = ASSOCIATION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__DIAGRAM = ASSOCIATION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__UML_MODEL_ELEMENT = ASSOCIATION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__SHARED_UML_STYLE = ASSOCIATION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__LOCAL_UML_STYLE = ASSOCIATION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__TARGET_UML_EDGE = ASSOCIATION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__SOURCE_UML_EDGE = ASSOCIATION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ASSOCIATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__STEREOTYPE_LABEL = ASSOCIATION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__UML_DIAGRAM = ASSOCIATION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__DIAGRAM_COMPARTMENT = ASSOCIATION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__MAIN_LABEL = ASSOCIATION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__SOURCE_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__WAYPOINT = ASSOCIATION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__TARGET_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>End Multiplicity Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__END_MULTIPLICITY_LABEL = ASSOCIATION_EDGE__END_MULTIPLICITY_LABEL;

	/**
	 * The feature id for the '<em><b>End Constraint Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__END_CONSTRAINT_LABEL = ASSOCIATION_EDGE__END_CONSTRAINT_LABEL;

	/**
	 * The feature id for the '<em><b>End Role Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE__END_ROLE_LABEL = ASSOCIATION_EDGE__END_ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Association Class Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE_FEATURE_COUNT = ASSOCIATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE___DIAGRAM = ASSOCIATION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Association Class Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_EDGE_OPERATION_COUNT = ASSOCIATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Comment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Comment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMENT_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__MODEL_ELEMENT = UML_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__OWNING_DIAGRAM_ELEMENT = UML_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__OWNED_DIAGRAM_ELEMENT = UML_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__LOCAL_STYLE = UML_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__SHARED_STYLE = UML_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__TARGET_EDGE = UML_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__SOURCE_EDGE = UML_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__DIAGRAM = UML_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__UML_MODEL_ELEMENT = UML_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__SHARED_UML_STYLE = UML_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__LOCAL_UML_STYLE = UML_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__TARGET_UML_EDGE = UML_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__SOURCE_UML_EDGE = UML_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = UML_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__STEREOTYPE_LABEL = UML_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__UML_DIAGRAM = UML_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__DIAGRAM_COMPARTMENT = UML_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__MAIN_LABEL = UML_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__SOURCE_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__WAYPOINT = UML_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__TARGET_DIAGRAM_ELEMENT = UML_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT = UML_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Attachment Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE_FEATURE_COUNT = UML_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE___DIAGRAM = UML_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Attachment Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ATTACHMENT_EDGE_OPERATION_COUNT = UML_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The number of structural features of the '<em>Association Class Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Association Class Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_CLASS_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Packaged Element Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE__PACKAGED_ELEMENT_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Component Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Component Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__MODEL_ELEMENT = CLASSIFIER_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__LOCAL_STYLE = CLASSIFIER_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__SHARED_STYLE = CLASSIFIER_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__TARGET_EDGE = CLASSIFIER_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__SOURCE_EDGE = CLASSIFIER_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__DIAGRAM = CLASSIFIER_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__SHARED_UML_STYLE = CLASSIFIER_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__TARGET_UML_EDGE = CLASSIFIER_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__UML_DIAGRAM = CLASSIFIER_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__MAIN_LABEL = CLASSIFIER_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__BOUNDS = CLASSIFIER_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Information Item Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE_FEATURE_COUNT = CLASSIFIER_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE___DIAGRAM = CLASSIFIER_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Information Item Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INFORMATION_ITEM_SHAPE_OPERATION_COUNT = CLASSIFIER_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__MODEL_ELEMENT = UML_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__OWNING_DIAGRAM_ELEMENT = UML_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__OWNED_DIAGRAM_ELEMENT = UML_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__LOCAL_STYLE = UML_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__SHARED_STYLE = UML_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__TARGET_EDGE = UML_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__SOURCE_EDGE = UML_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__DIAGRAM = UML_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__UML_MODEL_ELEMENT = UML_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__SHARED_UML_STYLE = UML_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__LOCAL_UML_STYLE = UML_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__TARGET_UML_EDGE = UML_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__SOURCE_UML_EDGE = UML_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = UML_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__STEREOTYPE_LABEL = UML_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__UML_DIAGRAM = UML_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__DIAGRAM_COMPARTMENT = UML_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__MAIN_LABEL = UML_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__SOURCE_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__WAYPOINT = UML_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__TARGET_DIAGRAM_ELEMENT = UML_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = UML_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Representation Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE_FEATURE_COUNT = UML_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE___DIAGRAM = UML_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Representation Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REPRESENTATION_EDGE_OPERATION_COUNT = UML_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__MODEL_ELEMENT = CLASSIFIER_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__LOCAL_STYLE = CLASSIFIER_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__SHARED_STYLE = CLASSIFIER_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__TARGET_EDGE = CLASSIFIER_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__SOURCE_EDGE = CLASSIFIER_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__DIAGRAM = CLASSIFIER_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__SHARED_UML_STYLE = CLASSIFIER_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__TARGET_UML_EDGE = CLASSIFIER_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__UML_DIAGRAM = CLASSIFIER_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__MAIN_LABEL = CLASSIFIER_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__BOUNDS = CLASSIFIER_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Association Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE_FEATURE_COUNT = CLASSIFIER_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE___DIAGRAM = CLASSIFIER_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Association Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_SHAPE_OPERATION_COUNT = CLASSIFIER_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Dependency Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Dependency Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPENDENCY_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Time Observation Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Time Observation Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Time Observation Shape Time Observation Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Time Observation Shape Time Observation Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Duration Observation Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Duration Observation Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_OBSERVATION_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__MODEL_ELEMENT = STRUCTURE_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__OWNING_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__OWNED_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__LOCAL_STYLE = STRUCTURE_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__SHARED_STYLE = STRUCTURE_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__TARGET_EDGE = STRUCTURE_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__SOURCE_EDGE = STRUCTURE_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__DIAGRAM = STRUCTURE_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__UML_MODEL_ELEMENT = STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__SHARED_UML_STYLE = STRUCTURE_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__LOCAL_UML_STYLE = STRUCTURE_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__TARGET_UML_EDGE = STRUCTURE_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__SOURCE_UML_EDGE = STRUCTURE_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__BOUNDS = STRUCTURE_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__NAME = STRUCTURE_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__DOCUMENTATION = STRUCTURE_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__RESOLUTION = STRUCTURE_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Package Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM_FEATURE_COUNT = STRUCTURE_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM___DIAGRAM = STRUCTURE_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Package Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PACKAGE_DIAGRAM_OPERATION_COUNT = STRUCTURE_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__MODEL_ELEMENT = STRUCTURE_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__OWNING_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__OWNED_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__LOCAL_STYLE = STRUCTURE_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__SHARED_STYLE = STRUCTURE_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__TARGET_EDGE = STRUCTURE_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__SOURCE_EDGE = STRUCTURE_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__DIAGRAM = STRUCTURE_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__UML_MODEL_ELEMENT = STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__SHARED_UML_STYLE = STRUCTURE_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__LOCAL_UML_STYLE = STRUCTURE_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__TARGET_UML_EDGE = STRUCTURE_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__SOURCE_UML_EDGE = STRUCTURE_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__BOUNDS = STRUCTURE_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__NAME = STRUCTURE_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__DOCUMENTATION = STRUCTURE_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__RESOLUTION = STRUCTURE_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Profile Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM_FEATURE_COUNT = STRUCTURE_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM___DIAGRAM = STRUCTURE_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Profile Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_DIAGRAM_OPERATION_COUNT = STRUCTURE_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__MODEL_ELEMENT = STRUCTURE_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__LOCAL_STYLE = STRUCTURE_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__SHARED_STYLE = STRUCTURE_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__TARGET_EDGE = STRUCTURE_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__SOURCE_EDGE = STRUCTURE_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__DIAGRAM = STRUCTURE_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT = STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__SHARED_UML_STYLE = STRUCTURE_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__LOCAL_UML_STYLE = STRUCTURE_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__TARGET_UML_EDGE = STRUCTURE_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__SOURCE_UML_EDGE = STRUCTURE_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__BOUNDS = STRUCTURE_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__NAME = STRUCTURE_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__DOCUMENTATION = STRUCTURE_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__RESOLUTION = STRUCTURE_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Composite Structure Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM_FEATURE_COUNT = STRUCTURE_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM___DIAGRAM = STRUCTURE_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Composite Structure Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_STRUCTURE_DIAGRAM_OPERATION_COUNT = STRUCTURE_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__MODEL_ELEMENT = STRUCTURE_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__OWNING_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__OWNED_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__LOCAL_STYLE = STRUCTURE_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__SHARED_STYLE = STRUCTURE_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__TARGET_EDGE = STRUCTURE_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__SOURCE_EDGE = STRUCTURE_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__DIAGRAM = STRUCTURE_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__UML_MODEL_ELEMENT = STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__SHARED_UML_STYLE = STRUCTURE_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__LOCAL_UML_STYLE = STRUCTURE_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__TARGET_UML_EDGE = STRUCTURE_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__SOURCE_UML_EDGE = STRUCTURE_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__BOUNDS = STRUCTURE_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__NAME = STRUCTURE_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__DOCUMENTATION = STRUCTURE_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__RESOLUTION = STRUCTURE_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Deployment Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM_FEATURE_COUNT = STRUCTURE_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM___DIAGRAM = STRUCTURE_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Deployment Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_DIAGRAM_OPERATION_COUNT = STRUCTURE_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__MODEL_ELEMENT = STRUCTURE_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__OWNING_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__OWNED_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__LOCAL_STYLE = STRUCTURE_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__SHARED_STYLE = STRUCTURE_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__TARGET_EDGE = STRUCTURE_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__SOURCE_EDGE = STRUCTURE_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__DIAGRAM = STRUCTURE_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__UML_MODEL_ELEMENT = STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__SHARED_UML_STYLE = STRUCTURE_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__LOCAL_UML_STYLE = STRUCTURE_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__TARGET_UML_EDGE = STRUCTURE_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__SOURCE_UML_EDGE = STRUCTURE_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__BOUNDS = STRUCTURE_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__NAME = STRUCTURE_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__DOCUMENTATION = STRUCTURE_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__RESOLUTION = STRUCTURE_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Component Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM_FEATURE_COUNT = STRUCTURE_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM___DIAGRAM = STRUCTURE_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Component Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DIAGRAM_OPERATION_COUNT = STRUCTURE_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__MODEL_ELEMENT = STRUCTURE_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__OWNING_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__OWNED_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__LOCAL_STYLE = STRUCTURE_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__SHARED_STYLE = STRUCTURE_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__TARGET_EDGE = STRUCTURE_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__SOURCE_EDGE = STRUCTURE_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__DIAGRAM = STRUCTURE_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__UML_MODEL_ELEMENT = STRUCTURE_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__SHARED_UML_STYLE = STRUCTURE_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__LOCAL_UML_STYLE = STRUCTURE_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__TARGET_UML_EDGE = STRUCTURE_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__SOURCE_UML_EDGE = STRUCTURE_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__BOUNDS = STRUCTURE_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__NAME = STRUCTURE_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__DOCUMENTATION = STRUCTURE_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__RESOLUTION = STRUCTURE_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = STRUCTURE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Object Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM_FEATURE_COUNT = STRUCTURE_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM___DIAGRAM = STRUCTURE_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Object Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OBJECT_DIAGRAM_OPERATION_COUNT = STRUCTURE_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__MODEL_ELEMENT = PACKAGE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__OWNING_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__OWNED_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__LOCAL_STYLE = PACKAGE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__SHARED_STYLE = PACKAGE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__TARGET_EDGE = PACKAGE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__SOURCE_EDGE = PACKAGE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__DIAGRAM = PACKAGE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__UML_MODEL_ELEMENT = PACKAGE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__SHARED_UML_STYLE = PACKAGE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__LOCAL_UML_STYLE = PACKAGE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = PACKAGE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__TARGET_UML_EDGE = PACKAGE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__SOURCE_UML_EDGE = PACKAGE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = PACKAGE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__STEREOTYPE_LABEL = PACKAGE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__UML_DIAGRAM = PACKAGE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__DIAGRAM_COMPARTMENT = PACKAGE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__MAIN_LABEL = PACKAGE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__BOUNDS = PACKAGE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__STEREOTYPE_COMPARTMENT = PACKAGE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Packaged Element Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__PACKAGED_ELEMENT_COMPARTMENT = PACKAGE_SHAPE__PACKAGED_ELEMENT_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = PACKAGE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Profile Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE_FEATURE_COUNT = PACKAGE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE___DIAGRAM = PACKAGE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Profile Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_SHAPE_OPERATION_COUNT = PACKAGE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Profile Application Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Profile Application Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROFILE_APPLICATION_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__MODEL_ELEMENT = ASSOCIATION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__OWNING_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__OWNED_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__LOCAL_STYLE = ASSOCIATION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__SHARED_STYLE = ASSOCIATION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__TARGET_EDGE = ASSOCIATION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__SOURCE_EDGE = ASSOCIATION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__DIAGRAM = ASSOCIATION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__UML_MODEL_ELEMENT = ASSOCIATION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__SHARED_UML_STYLE = ASSOCIATION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__LOCAL_UML_STYLE = ASSOCIATION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__TARGET_UML_EDGE = ASSOCIATION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__SOURCE_UML_EDGE = ASSOCIATION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ASSOCIATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__STEREOTYPE_LABEL = ASSOCIATION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__UML_DIAGRAM = ASSOCIATION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__DIAGRAM_COMPARTMENT = ASSOCIATION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__MAIN_LABEL = ASSOCIATION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__SOURCE_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__WAYPOINT = ASSOCIATION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__TARGET_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>End Multiplicity Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__END_MULTIPLICITY_LABEL = ASSOCIATION_EDGE__END_MULTIPLICITY_LABEL;

	/**
	 * The feature id for the '<em><b>End Constraint Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__END_CONSTRAINT_LABEL = ASSOCIATION_EDGE__END_CONSTRAINT_LABEL;

	/**
	 * The feature id for the '<em><b>End Role Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE__END_ROLE_LABEL = ASSOCIATION_EDGE__END_ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Extension Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE_FEATURE_COUNT = ASSOCIATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE___DIAGRAM = ASSOCIATION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Extension Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_EDGE_OPERATION_COUNT = ASSOCIATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__MODEL_ELEMENT = UML_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__OWNING_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__OWNED_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__LOCAL_STYLE = UML_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__SHARED_STYLE = UML_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__TARGET_EDGE = UML_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__SOURCE_EDGE = UML_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__DIAGRAM = UML_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__UML_MODEL_ELEMENT = UML_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__SHARED_UML_STYLE = UML_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__LOCAL_UML_STYLE = UML_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = UML_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__TARGET_UML_EDGE = UML_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__SOURCE_UML_EDGE = UML_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__BOUNDS = UML_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__NAME = UML_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__DOCUMENTATION = UML_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__RESOLUTION = UML_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = UML_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Behavior Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM_FEATURE_COUNT = UML_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM___DIAGRAM = UML_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Behavior Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BEHAVIOR_DIAGRAM_OPERATION_COUNT = UML_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__MODEL_ELEMENT = BEHAVIOR_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__OWNING_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__OWNED_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__LOCAL_STYLE = BEHAVIOR_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__SHARED_STYLE = BEHAVIOR_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__TARGET_EDGE = BEHAVIOR_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__SOURCE_EDGE = BEHAVIOR_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__DIAGRAM = BEHAVIOR_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__UML_MODEL_ELEMENT = BEHAVIOR_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__SHARED_UML_STYLE = BEHAVIOR_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__LOCAL_UML_STYLE = BEHAVIOR_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__TARGET_UML_EDGE = BEHAVIOR_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__SOURCE_UML_EDGE = BEHAVIOR_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__BOUNDS = BEHAVIOR_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__NAME = BEHAVIOR_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__DOCUMENTATION = BEHAVIOR_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__RESOLUTION = BEHAVIOR_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Use Case Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM_FEATURE_COUNT = BEHAVIOR_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM___DIAGRAM = BEHAVIOR_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Use Case Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_DIAGRAM_OPERATION_COUNT = BEHAVIOR_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__BOUNDS = CLASSIFIER_WITH_OPERATIONS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE__NESTED_ARTIFACT_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Artifact Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE___DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Artifact Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__LOCAL_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__SHARED_STYLE = CLASSIFIER_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__TARGET_EDGE = CLASSIFIER_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__SOURCE_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__DIAGRAM = CLASSIFIER_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__UML_MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__SHARED_UML_STYLE = CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__LOCAL_UML_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__TARGET_UML_EDGE = CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__SOURCE_UML_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__BOUNDS = CLASSIFIER_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__LIST_ITEM_LABEL = CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Layout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__LAYOUT = CLASSIFIER_COMPARTMENT__LAYOUT;

	/**
	 * The feature id for the '<em><b>Artifact Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT__ARTIFACT_SHAPE = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Nested Artifact Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT_FEATURE_COUNT = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT___DIAGRAM = CLASSIFIER_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Nested Artifact Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_ARTIFACT_COMPARTMENT_OPERATION_COUNT = CLASSIFIER_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__MODEL_ELEMENT = REALIZATION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__OWNING_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__OWNED_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__LOCAL_STYLE = REALIZATION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__SHARED_STYLE = REALIZATION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__TARGET_EDGE = REALIZATION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__SOURCE_EDGE = REALIZATION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__DIAGRAM = REALIZATION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__UML_MODEL_ELEMENT = REALIZATION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__SHARED_UML_STYLE = REALIZATION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__LOCAL_UML_STYLE = REALIZATION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__TARGET_UML_EDGE = REALIZATION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__SOURCE_UML_EDGE = REALIZATION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = REALIZATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__STEREOTYPE_LABEL = REALIZATION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__UML_DIAGRAM = REALIZATION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__DIAGRAM_COMPARTMENT = REALIZATION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__MAIN_LABEL = REALIZATION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__SOURCE_DIAGRAM_ELEMENT = REALIZATION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__WAYPOINT = REALIZATION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__TARGET_DIAGRAM_ELEMENT = REALIZATION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = REALIZATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE__ROLE_LABEL = REALIZATION_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Component Realization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE_FEATURE_COUNT = REALIZATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE___DIAGRAM = REALIZATION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Component Realization Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMPONENT_REALIZATION_EDGE_OPERATION_COUNT = REALIZATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__MODEL_ELEMENT = ABSTRACTION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__OWNING_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__OWNED_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__LOCAL_STYLE = ABSTRACTION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__SHARED_STYLE = ABSTRACTION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__TARGET_EDGE = ABSTRACTION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__SOURCE_EDGE = ABSTRACTION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__DIAGRAM = ABSTRACTION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__UML_MODEL_ELEMENT = ABSTRACTION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__SHARED_UML_STYLE = ABSTRACTION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__LOCAL_UML_STYLE = ABSTRACTION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__TARGET_UML_EDGE = ABSTRACTION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__SOURCE_UML_EDGE = ABSTRACTION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ABSTRACTION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__STEREOTYPE_LABEL = ABSTRACTION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__UML_DIAGRAM = ABSTRACTION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__DIAGRAM_COMPARTMENT = ABSTRACTION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__MAIN_LABEL = ABSTRACTION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__SOURCE_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__WAYPOINT = ABSTRACTION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__TARGET_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ABSTRACTION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE__ROLE_LABEL = ABSTRACTION_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Manifestation Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE_FEATURE_COUNT = ABSTRACTION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE___DIAGRAM = ABSTRACTION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Manifestation Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MANIFESTATION_EDGE_OPERATION_COUNT = ABSTRACTION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__MODEL_ELEMENT = ELEMENT_WITH_PORTS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_WITH_PORTS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_WITH_PORTS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__LOCAL_STYLE = ELEMENT_WITH_PORTS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__SHARED_STYLE = ELEMENT_WITH_PORTS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__TARGET_EDGE = ELEMENT_WITH_PORTS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__SOURCE_EDGE = ELEMENT_WITH_PORTS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__DIAGRAM = ELEMENT_WITH_PORTS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__UML_MODEL_ELEMENT = ELEMENT_WITH_PORTS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__SHARED_UML_STYLE = ELEMENT_WITH_PORTS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__LOCAL_UML_STYLE = ELEMENT_WITH_PORTS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_WITH_PORTS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_WITH_PORTS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__TARGET_UML_EDGE = ELEMENT_WITH_PORTS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__SOURCE_UML_EDGE = ELEMENT_WITH_PORTS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_WITH_PORTS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__STEREOTYPE_LABEL = ELEMENT_WITH_PORTS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__UML_DIAGRAM = ELEMENT_WITH_PORTS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_WITH_PORTS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__MAIN_LABEL = ELEMENT_WITH_PORTS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__BOUNDS = ELEMENT_WITH_PORTS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_WITH_PORTS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__STRUCTURE_COMPARTMENT = ELEMENT_WITH_PORTS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__PORT_SHAPE = ELEMENT_WITH_PORTS_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Deployed Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT = ELEMENT_WITH_PORTS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Property Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE_FEATURE_COUNT = ELEMENT_WITH_PORTS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE___DIAGRAM = ELEMENT_WITH_PORTS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Property Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHAPE_OPERATION_COUNT = ELEMENT_WITH_PORTS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__LOCAL_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__SHARED_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__TARGET_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__SOURCE_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__UML_MODEL_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__SHARED_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__LOCAL_UML_STYLE = CLASSIFIER_WITH_OPERATIONS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__TARGET_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__SOURCE_UML_EDGE = CLASSIFIER_WITH_OPERATIONS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASSIFIER_WITH_OPERATIONS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__STEREOTYPE_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__UML_DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__DIAGRAM_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__MAIN_LABEL = CLASSIFIER_WITH_OPERATIONS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__BOUNDS = CLASSIFIER_WITH_OPERATIONS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__STEREOTYPE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__USE_CLASSIFIER_NOTATION = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__USE_CASE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__ATTRIBUTE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__OPERATION_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__STRUCTURE_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE__RECEPTION_COMPARTMENT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Collaboration Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE_FEATURE_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE___DIAGRAM = CLASSIFIER_WITH_OPERATIONS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Collaboration Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_SHAPE_OPERATION_COUNT = CLASSIFIER_WITH_OPERATIONS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Collaboration Use Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Collaboration Use Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_USE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Template Binding Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Template Binding Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TEMPLATE_BINDING_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The number of structural features of the '<em>Stereotype Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Stereotype Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STEREOTYPE_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Deployed Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Nested Node Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE__NESTED_NODE_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NODE_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__LOCAL_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__SHARED_STYLE = CLASSIFIER_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__TARGET_EDGE = CLASSIFIER_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__SOURCE_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__DIAGRAM = CLASSIFIER_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__UML_MODEL_ELEMENT = CLASSIFIER_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__SHARED_UML_STYLE = CLASSIFIER_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__LOCAL_UML_STYLE = CLASSIFIER_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__TARGET_UML_EDGE = CLASSIFIER_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__SOURCE_UML_EDGE = CLASSIFIER_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__BOUNDS = CLASSIFIER_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = CLASSIFIER_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__LIST_ITEM_LABEL = CLASSIFIER_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Layout</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__LAYOUT = CLASSIFIER_COMPARTMENT__LAYOUT;

	/**
	 * The feature id for the '<em><b>Node Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT__NODE_SHAPE = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Nested Node Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT_FEATURE_COUNT = CLASSIFIER_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT___DIAGRAM = CLASSIFIER_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Nested Node Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int NESTED_NODE_COMPARTMENT_OPERATION_COUNT = CLASSIFIER_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__MODEL_ELEMENT = NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__OWNING_DIAGRAM_ELEMENT = NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__OWNED_DIAGRAM_ELEMENT = NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__LOCAL_STYLE = NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__SHARED_STYLE = NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__TARGET_EDGE = NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__SOURCE_EDGE = NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__DIAGRAM = NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__UML_MODEL_ELEMENT = NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__SHARED_UML_STYLE = NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__LOCAL_UML_STYLE = NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__TARGET_UML_EDGE = NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__SOURCE_UML_EDGE = NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__STEREOTYPE_LABEL = NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__UML_DIAGRAM = NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__DIAGRAM_COMPARTMENT = NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__MAIN_LABEL = NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__BOUNDS = NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__STEREOTYPE_COMPARTMENT = NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = NODE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__USE_CLASSIFIER_NOTATION = NODE_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__OWNED_USE_CASE_COMPARTMENT = NODE_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__USE_CASE_COMPARTMENT = NODE_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__ATTRIBUTE_COMPARTMENT = NODE_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__OPERATION_COMPARTMENT = NODE_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__RECEPTION_COMPARTMENT = NODE_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = NODE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = NODE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__STRUCTURE_COMPARTMENT = NODE_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__PORT_SHAPE = NODE_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Deployed Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT = NODE_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Node Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE__NESTED_NODE_COMPARTMENT = NODE_SHAPE__NESTED_NODE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Device Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE_FEATURE_COUNT = NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE___DIAGRAM = NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Device Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEVICE_SHAPE_OPERATION_COUNT = NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__MODEL_ELEMENT = NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__OWNING_DIAGRAM_ELEMENT = NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__OWNED_DIAGRAM_ELEMENT = NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__LOCAL_STYLE = NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__SHARED_STYLE = NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__TARGET_EDGE = NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__SOURCE_EDGE = NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__DIAGRAM = NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__UML_MODEL_ELEMENT = NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__SHARED_UML_STYLE = NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__LOCAL_UML_STYLE = NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__TARGET_UML_EDGE = NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__SOURCE_UML_EDGE = NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__STEREOTYPE_LABEL = NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__UML_DIAGRAM = NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__DIAGRAM_COMPARTMENT = NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__MAIN_LABEL = NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__BOUNDS = NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__STEREOTYPE_COMPARTMENT = NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = NODE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__USE_CLASSIFIER_NOTATION = NODE_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__OWNED_USE_CASE_COMPARTMENT = NODE_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__USE_CASE_COMPARTMENT = NODE_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__ATTRIBUTE_COMPARTMENT = NODE_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__OPERATION_COMPARTMENT = NODE_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__RECEPTION_COMPARTMENT = NODE_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = NODE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = NODE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__STRUCTURE_COMPARTMENT = NODE_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__PORT_SHAPE = NODE_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Deployed Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT = NODE_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Node Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE__NESTED_NODE_COMPARTMENT = NODE_SHAPE__NESTED_NODE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Execution Environment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE_FEATURE_COUNT = NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE___DIAGRAM = NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Execution Environment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_ENVIRONMENT_SHAPE_OPERATION_COUNT = NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Activity Node Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__ACTIVITY_NODE_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__PARAMETER_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Post Condition Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__POST_CONDITION_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Pre Condition Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__PRE_CONDITION_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Activity Parameter Node Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE__ACTIVITY_PARAMETER_NODE_SHAPE = CLASS_SHAPE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Activity Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 5;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Activity Node Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE__ACTIVITY_NODE_COMPARTMENT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Element With Activity Nodes Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Element With Activity Nodes Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ELEMENT_WITH_ACTIVITY_NODES_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Element With Activity Nodes Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT__ELEMENT_WITH_ACTIVITY_NODES_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Activity Node Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Node Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_NODE_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Activity Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT__ACTIVITY_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Parameter Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Parameter Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PARAMETER_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Activity Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT__ACTIVITY_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Post Condition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Post Condition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int POST_CONDITION_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Activity Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT__ACTIVITY_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Pre Condition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Pre Condition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PRE_CONDITION_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__MODEL_ELEMENT = OBJECT_NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__LOCAL_STYLE = OBJECT_NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__SHARED_STYLE = OBJECT_NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__TARGET_EDGE = OBJECT_NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__SOURCE_EDGE = OBJECT_NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__DIAGRAM = OBJECT_NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__UML_MODEL_ELEMENT = OBJECT_NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__SHARED_UML_STYLE = OBJECT_NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__LOCAL_UML_STYLE = OBJECT_NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__TARGET_UML_EDGE = OBJECT_NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__SOURCE_UML_EDGE = OBJECT_NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = OBJECT_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__STEREOTYPE_LABEL = OBJECT_NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__UML_DIAGRAM = OBJECT_NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__DIAGRAM_COMPARTMENT = OBJECT_NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__MAIN_LABEL = OBJECT_NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__BOUNDS = OBJECT_NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__STEREOTYPE_COMPARTMENT = OBJECT_NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Selection Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__SELECTION_LABEL = OBJECT_NODE_SHAPE__SELECTION_LABEL;

	/**
	 * The feature id for the '<em><b>Constraint Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__CONSTRAINT_LABEL = OBJECT_NODE_SHAPE__CONSTRAINT_LABEL;

	/**
	 * The feature id for the '<em><b>Activity Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE__ACTIVITY_SHAPE = OBJECT_NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Activity Parameter Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE_FEATURE_COUNT = OBJECT_NODE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE___DIAGRAM = OBJECT_NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Parameter Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARAMETER_NODE_SHAPE_OPERATION_COUNT = OBJECT_NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__LIFELINE_SHAPE = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Gate Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__GATE_SHAPE = CLASS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Subfragment Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE__SUBFRAGMENT_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Interaction Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNING_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNED_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__LOCAL_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SHARED_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__TARGET_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SOURCE_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__DIAGRAM = INTERACTION_FRAGMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__UML_MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SHARED_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__LOCAL_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__TARGET_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SOURCE_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = INTERACTION_FRAGMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__STEREOTYPE_LABEL = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__UML_DIAGRAM = INTERACTION_FRAGMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__DIAGRAM_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__MAIN_LABEL = INTERACTION_FRAGMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__BOUNDS = INTERACTION_FRAGMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__STEREOTYPE_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__LIFELINE_SHAPE = INTERACTION_FRAGMENT_SHAPE__LIFELINE_SHAPE;

	/**
	 * The feature id for the '<em><b>Subfragment Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SUBFRAGMENT_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Interaction Fragment With Subfragments Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE_FEATURE_COUNT = INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE___DIAGRAM = INTERACTION_FRAGMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Fragment With Subfragments Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE_OPERATION_COUNT = INTERACTION_FRAGMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Interaction Fragment With Subfragments Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT__INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subfragment Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Subfragment Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBFRAGMENT_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNING_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNED_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LOCAL_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHARED_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__TARGET_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SOURCE_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__DIAGRAM = INTERACTION_FRAGMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__UML_MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHARED_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LOCAL_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__TARGET_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SOURCE_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = INTERACTION_FRAGMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__STEREOTYPE_LABEL = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__UML_DIAGRAM = INTERACTION_FRAGMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__DIAGRAM_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__MAIN_LABEL = INTERACTION_FRAGMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__BOUNDS = INTERACTION_FRAGMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__STEREOTYPE_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LIFELINE_SHAPE = INTERACTION_FRAGMENT_SHAPE__LIFELINE_SHAPE;

	/**
	 * The feature id for the '<em><b>Gate Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE__GATE_SHAPE = INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Interaction Fragment With Gates Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE_FEATURE_COUNT = INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE___DIAGRAM = INTERACTION_FRAGMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Fragment With Gates Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FRAGMENT_WITH_GATES_SHAPE_OPERATION_COUNT = INTERACTION_FRAGMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Interaction Fragment With Gates Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE__INTERACTION_FRAGMENT_WITH_GATES_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Gate Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Gate Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GATE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The number of structural features of the '<em>Opaque Behavior Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Opaque Behavior Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int OPAQUE_BEHAVIOR_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__MODEL_ELEMENT = OPAQUE_BEHAVIOR_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__OWNING_DIAGRAM_ELEMENT = OPAQUE_BEHAVIOR_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__OWNED_DIAGRAM_ELEMENT = OPAQUE_BEHAVIOR_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__LOCAL_STYLE = OPAQUE_BEHAVIOR_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__SHARED_STYLE = OPAQUE_BEHAVIOR_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__TARGET_EDGE = OPAQUE_BEHAVIOR_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__SOURCE_EDGE = OPAQUE_BEHAVIOR_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__DIAGRAM = OPAQUE_BEHAVIOR_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__UML_MODEL_ELEMENT = OPAQUE_BEHAVIOR_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__SHARED_UML_STYLE = OPAQUE_BEHAVIOR_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__LOCAL_UML_STYLE = OPAQUE_BEHAVIOR_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = OPAQUE_BEHAVIOR_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = OPAQUE_BEHAVIOR_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__TARGET_UML_EDGE = OPAQUE_BEHAVIOR_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__SOURCE_UML_EDGE = OPAQUE_BEHAVIOR_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = OPAQUE_BEHAVIOR_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__STEREOTYPE_LABEL = OPAQUE_BEHAVIOR_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__UML_DIAGRAM = OPAQUE_BEHAVIOR_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__DIAGRAM_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__MAIN_LABEL = OPAQUE_BEHAVIOR_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__BOUNDS = OPAQUE_BEHAVIOR_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__STEREOTYPE_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__USE_CLASSIFIER_NOTATION = OPAQUE_BEHAVIOR_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__OWNED_USE_CASE_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__USE_CASE_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__ATTRIBUTE_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__OPERATION_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__RECEPTION_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__STRUCTURE_COMPARTMENT = OPAQUE_BEHAVIOR_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE__PORT_SHAPE = OPAQUE_BEHAVIOR_SHAPE__PORT_SHAPE;

	/**
	 * The number of structural features of the '<em>Function Behavior Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE_FEATURE_COUNT = OPAQUE_BEHAVIOR_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE___DIAGRAM = OPAQUE_BEHAVIOR_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Function Behavior Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int FUNCTION_BEHAVIOR_SHAPE_OPERATION_COUNT = OPAQUE_BEHAVIOR_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__MODEL_ELEMENT = CLASS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__OWNING_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__OWNED_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__LOCAL_STYLE = CLASS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__SHARED_STYLE = CLASS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__TARGET_EDGE = CLASS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__SOURCE_EDGE = CLASS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__DIAGRAM = CLASS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__UML_MODEL_ELEMENT = CLASS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__SHARED_UML_STYLE = CLASS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__LOCAL_UML_STYLE = CLASS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CLASS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__TARGET_UML_EDGE = CLASS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__SOURCE_UML_EDGE = CLASS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CLASS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__STEREOTYPE_LABEL = CLASS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__UML_DIAGRAM = CLASS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__DIAGRAM_COMPARTMENT = CLASS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__MAIN_LABEL = CLASS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__BOUNDS = CLASS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__STEREOTYPE_COMPARTMENT = CLASS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = CLASS_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__USE_CLASSIFIER_NOTATION = CLASS_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__OWNED_USE_CASE_COMPARTMENT = CLASS_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__USE_CASE_COMPARTMENT = CLASS_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__ATTRIBUTE_COMPARTMENT = CLASS_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__OPERATION_COMPARTMENT = CLASS_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__RECEPTION_COMPARTMENT = CLASS_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = CLASS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = CLASS_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__STRUCTURE_COMPARTMENT = CLASS_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__PORT_SHAPE = CLASS_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Connection Point Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__CONNECTION_POINT_SHAPE = CLASS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Region Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE__REGION_COMPARTMENT = CLASS_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>State Machine Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE_FEATURE_COUNT = CLASS_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE___DIAGRAM = CLASS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>State Machine Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_SHAPE_OPERATION_COUNT = CLASS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Connection Point Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__CONNECTION_POINT_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Region Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE__REGION_COMPARTMENT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Base State Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Base State Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int BASE_STATE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Base State Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE__BASE_STATE_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Pseudostate Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Pseudostate Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PSEUDOSTATE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Base State Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT__BASE_STATE_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Region Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Region Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__MODEL_ELEMENT = STATE_MACHINE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__OWNING_DIAGRAM_ELEMENT = STATE_MACHINE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__OWNED_DIAGRAM_ELEMENT = STATE_MACHINE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__LOCAL_STYLE = STATE_MACHINE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__SHARED_STYLE = STATE_MACHINE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__TARGET_EDGE = STATE_MACHINE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__SOURCE_EDGE = STATE_MACHINE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__DIAGRAM = STATE_MACHINE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__UML_MODEL_ELEMENT = STATE_MACHINE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__SHARED_UML_STYLE = STATE_MACHINE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__LOCAL_UML_STYLE = STATE_MACHINE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = STATE_MACHINE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = STATE_MACHINE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__TARGET_UML_EDGE = STATE_MACHINE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__SOURCE_UML_EDGE = STATE_MACHINE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = STATE_MACHINE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__STEREOTYPE_LABEL = STATE_MACHINE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__UML_DIAGRAM = STATE_MACHINE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__DIAGRAM_COMPARTMENT = STATE_MACHINE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__MAIN_LABEL = STATE_MACHINE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__BOUNDS = STATE_MACHINE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__STEREOTYPE_COMPARTMENT = STATE_MACHINE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = STATE_MACHINE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__USE_CLASSIFIER_NOTATION = STATE_MACHINE_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__OWNED_USE_CASE_COMPARTMENT = STATE_MACHINE_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__USE_CASE_COMPARTMENT = STATE_MACHINE_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__ATTRIBUTE_COMPARTMENT = STATE_MACHINE_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__OPERATION_COMPARTMENT = STATE_MACHINE_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Reception Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__RECEPTION_COMPARTMENT = STATE_MACHINE_SHAPE__RECEPTION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Classifier Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = STATE_MACHINE_SHAPE__NESTED_CLASSIFIER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = STATE_MACHINE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Structure Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__STRUCTURE_COMPARTMENT = STATE_MACHINE_SHAPE__STRUCTURE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Port Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__PORT_SHAPE = STATE_MACHINE_SHAPE__PORT_SHAPE;

	/**
	 * The feature id for the '<em><b>Connection Point Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__CONNECTION_POINT_SHAPE = STATE_MACHINE_SHAPE__CONNECTION_POINT_SHAPE;

	/**
	 * The feature id for the '<em><b>Region Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE__REGION_COMPARTMENT = STATE_MACHINE_SHAPE__REGION_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Protocol State Machine Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE_FEATURE_COUNT = STATE_MACHINE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE___DIAGRAM = STATE_MACHINE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Protocol State Machine Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PROTOCOL_STATE_MACHINE_SHAPE_OPERATION_COUNT = STATE_MACHINE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__MODEL_ELEMENT = ARTIFACT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__OWNING_DIAGRAM_ELEMENT = ARTIFACT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__OWNED_DIAGRAM_ELEMENT = ARTIFACT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__LOCAL_STYLE = ARTIFACT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__SHARED_STYLE = ARTIFACT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__TARGET_EDGE = ARTIFACT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__SOURCE_EDGE = ARTIFACT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__DIAGRAM = ARTIFACT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__UML_MODEL_ELEMENT = ARTIFACT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__SHARED_UML_STYLE = ARTIFACT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__LOCAL_UML_STYLE = ARTIFACT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ARTIFACT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ARTIFACT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__TARGET_UML_EDGE = ARTIFACT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__SOURCE_UML_EDGE = ARTIFACT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ARTIFACT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__STEREOTYPE_LABEL = ARTIFACT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__UML_DIAGRAM = ARTIFACT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__DIAGRAM_COMPARTMENT = ARTIFACT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__MAIN_LABEL = ARTIFACT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__BOUNDS = ARTIFACT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__STEREOTYPE_COMPARTMENT = ARTIFACT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = ARTIFACT_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__USE_CLASSIFIER_NOTATION = ARTIFACT_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__OWNED_USE_CASE_COMPARTMENT = ARTIFACT_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__USE_CASE_COMPARTMENT = ARTIFACT_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Attribute Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__ATTRIBUTE_COMPARTMENT = ARTIFACT_SHAPE__ATTRIBUTE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Operation Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__OPERATION_COMPARTMENT = ARTIFACT_SHAPE__OPERATION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Nested Artifact Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE__NESTED_ARTIFACT_COMPARTMENT = ARTIFACT_SHAPE__NESTED_ARTIFACT_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Deployment Specification Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE_FEATURE_COUNT = ARTIFACT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE___DIAGRAM = ARTIFACT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Deployment Specification Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_SPECIFICATION_SHAPE_OPERATION_COUNT = ARTIFACT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__MODEL_ELEMENT = ASSOCIATION_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__OWNING_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__OWNED_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__LOCAL_STYLE = ASSOCIATION_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__SHARED_STYLE = ASSOCIATION_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__TARGET_EDGE = ASSOCIATION_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__SOURCE_EDGE = ASSOCIATION_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__DIAGRAM = ASSOCIATION_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__UML_MODEL_ELEMENT = ASSOCIATION_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__SHARED_UML_STYLE = ASSOCIATION_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__LOCAL_UML_STYLE = ASSOCIATION_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__TARGET_UML_EDGE = ASSOCIATION_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__SOURCE_UML_EDGE = ASSOCIATION_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ASSOCIATION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__STEREOTYPE_LABEL = ASSOCIATION_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__UML_DIAGRAM = ASSOCIATION_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__DIAGRAM_COMPARTMENT = ASSOCIATION_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__MAIN_LABEL = ASSOCIATION_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__SOURCE_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__WAYPOINT = ASSOCIATION_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__TARGET_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ASSOCIATION_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>End Multiplicity Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__END_MULTIPLICITY_LABEL = ASSOCIATION_EDGE__END_MULTIPLICITY_LABEL;

	/**
	 * The feature id for the '<em><b>End Constraint Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__END_CONSTRAINT_LABEL = ASSOCIATION_EDGE__END_CONSTRAINT_LABEL;

	/**
	 * The feature id for the '<em><b>End Role Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE__END_ROLE_LABEL = ASSOCIATION_EDGE__END_ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Communication Path Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE_FEATURE_COUNT = ASSOCIATION_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE___DIAGRAM = ASSOCIATION_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Communication Path Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_PATH_EDGE_OPERATION_COUNT = ASSOCIATION_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__MODEL_ELEMENT = DEPENDENCY_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__OWNING_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__OWNED_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__LOCAL_STYLE = DEPENDENCY_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__SHARED_STYLE = DEPENDENCY_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__TARGET_EDGE = DEPENDENCY_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__SOURCE_EDGE = DEPENDENCY_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__DIAGRAM = DEPENDENCY_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__UML_MODEL_ELEMENT = DEPENDENCY_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__SHARED_UML_STYLE = DEPENDENCY_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__LOCAL_UML_STYLE = DEPENDENCY_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__TARGET_UML_EDGE = DEPENDENCY_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__SOURCE_UML_EDGE = DEPENDENCY_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = DEPENDENCY_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__STEREOTYPE_LABEL = DEPENDENCY_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__UML_DIAGRAM = DEPENDENCY_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__DIAGRAM_COMPARTMENT = DEPENDENCY_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__MAIN_LABEL = DEPENDENCY_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__SOURCE_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__WAYPOINT = DEPENDENCY_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__TARGET_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT = DEPENDENCY_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Role Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE__ROLE_LABEL = DEPENDENCY_EDGE__ROLE_LABEL;

	/**
	 * The number of structural features of the '<em>Deployment Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE_FEATURE_COUNT = DEPENDENCY_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE___DIAGRAM = DEPENDENCY_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Deployment Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEPLOYMENT_EDGE_OPERATION_COUNT = DEPENDENCY_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__MODEL_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__OWNING_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__OWNED_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__LOCAL_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__SHARED_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__TARGET_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__SOURCE_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__DIAGRAM = BEHAVIORED_CLASSIFIER_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__UML_MODEL_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__SHARED_UML_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__LOCAL_UML_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__TARGET_UML_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__SOURCE_UML_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = BEHAVIORED_CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__STEREOTYPE_LABEL = BEHAVIORED_CLASSIFIER_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__UML_DIAGRAM = BEHAVIORED_CLASSIFIER_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__DIAGRAM_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__MAIN_LABEL = BEHAVIORED_CLASSIFIER_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__BOUNDS = BEHAVIORED_CLASSIFIER_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__STEREOTYPE_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__USE_CLASSIFIER_NOTATION = BEHAVIORED_CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__OWNED_USE_CASE_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__USE_CASE_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Actor Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE_FEATURE_COUNT = BEHAVIORED_CLASSIFIER_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE___DIAGRAM = BEHAVIORED_CLASSIFIER_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Actor Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTOR_SHAPE_OPERATION_COUNT = BEHAVIORED_CLASSIFIER_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>Use Case Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT__USE_CASE_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Extension Point Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Extension Point Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTENSION_POINT_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__MODEL_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__OWNING_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__OWNED_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__LOCAL_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__SHARED_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__TARGET_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__SOURCE_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__DIAGRAM = BEHAVIORED_CLASSIFIER_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__UML_MODEL_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__SHARED_UML_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__LOCAL_UML_STYLE = BEHAVIORED_CLASSIFIER_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__TARGET_UML_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__SOURCE_UML_EDGE = BEHAVIORED_CLASSIFIER_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = BEHAVIORED_CLASSIFIER_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__STEREOTYPE_LABEL = BEHAVIORED_CLASSIFIER_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__UML_DIAGRAM = BEHAVIORED_CLASSIFIER_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__DIAGRAM_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__MAIN_LABEL = BEHAVIORED_CLASSIFIER_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__BOUNDS = BEHAVIORED_CLASSIFIER_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__STEREOTYPE_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Template Parameter Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Classifier Notation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__USE_CLASSIFIER_NOTATION = BEHAVIORED_CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION;

	/**
	 * The feature id for the '<em><b>Owned Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__OWNED_USE_CASE_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Use Case Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__USE_CASE_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Owned Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE__OWNED_BEHAVIOR_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Extension Point Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE__EXTENSION_POINT_COMPARTMENT = BEHAVIORED_CLASSIFIER_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Use Case Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE_FEATURE_COUNT = BEHAVIORED_CLASSIFIER_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE___DIAGRAM = BEHAVIORED_CLASSIFIER_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Use Case Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int USE_CASE_SHAPE_OPERATION_COUNT = BEHAVIORED_CLASSIFIER_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Include Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Include Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INCLUDE_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Extend Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Extend Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXTEND_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__MODEL_ELEMENT = BEHAVIOR_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__OWNING_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__OWNED_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__LOCAL_STYLE = BEHAVIOR_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__SHARED_STYLE = BEHAVIOR_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__TARGET_EDGE = BEHAVIOR_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__SOURCE_EDGE = BEHAVIOR_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__DIAGRAM = BEHAVIOR_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__UML_MODEL_ELEMENT = BEHAVIOR_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__SHARED_UML_STYLE = BEHAVIOR_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__LOCAL_UML_STYLE = BEHAVIOR_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__TARGET_UML_EDGE = BEHAVIOR_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__SOURCE_UML_EDGE = BEHAVIOR_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__BOUNDS = BEHAVIOR_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__NAME = BEHAVIOR_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__DOCUMENTATION = BEHAVIOR_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__RESOLUTION = BEHAVIOR_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>State Machine Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM_FEATURE_COUNT = BEHAVIOR_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM___DIAGRAM = BEHAVIOR_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>State Machine Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_MACHINE_DIAGRAM_OPERATION_COUNT = BEHAVIOR_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__MODEL_ELEMENT = BEHAVIOR_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__OWNING_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__OWNED_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__LOCAL_STYLE = BEHAVIOR_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__SHARED_STYLE = BEHAVIOR_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__TARGET_EDGE = BEHAVIOR_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__SOURCE_EDGE = BEHAVIOR_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__DIAGRAM = BEHAVIOR_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__UML_MODEL_ELEMENT = BEHAVIOR_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__SHARED_UML_STYLE = BEHAVIOR_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__LOCAL_UML_STYLE = BEHAVIOR_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__TARGET_UML_EDGE = BEHAVIOR_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__SOURCE_UML_EDGE = BEHAVIOR_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__BOUNDS = BEHAVIOR_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__NAME = BEHAVIOR_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__DOCUMENTATION = BEHAVIOR_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__RESOLUTION = BEHAVIOR_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Activity Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM_FEATURE_COUNT = BEHAVIOR_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM___DIAGRAM = BEHAVIOR_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_DIAGRAM_OPERATION_COUNT = BEHAVIOR_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__MODEL_ELEMENT = BEHAVIOR_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__OWNING_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__OWNED_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__LOCAL_STYLE = BEHAVIOR_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__SHARED_STYLE = BEHAVIOR_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__TARGET_EDGE = BEHAVIOR_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__SOURCE_EDGE = BEHAVIOR_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__DIAGRAM = BEHAVIOR_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__UML_MODEL_ELEMENT = BEHAVIOR_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__SHARED_UML_STYLE = BEHAVIOR_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__LOCAL_UML_STYLE = BEHAVIOR_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__TARGET_UML_EDGE = BEHAVIOR_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__SOURCE_UML_EDGE = BEHAVIOR_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__BOUNDS = BEHAVIOR_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__NAME = BEHAVIOR_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__DOCUMENTATION = BEHAVIOR_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__RESOLUTION = BEHAVIOR_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = BEHAVIOR_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Interaction Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM_FEATURE_COUNT = BEHAVIOR_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM___DIAGRAM = BEHAVIOR_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_DIAGRAM_OPERATION_COUNT = BEHAVIOR_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__MODEL_ELEMENT = INTERACTION_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__OWNING_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__OWNED_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__LOCAL_STYLE = INTERACTION_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__SHARED_STYLE = INTERACTION_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__TARGET_EDGE = INTERACTION_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__SOURCE_EDGE = INTERACTION_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__DIAGRAM = INTERACTION_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__UML_MODEL_ELEMENT = INTERACTION_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__SHARED_UML_STYLE = INTERACTION_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__LOCAL_UML_STYLE = INTERACTION_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__TARGET_UML_EDGE = INTERACTION_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__SOURCE_UML_EDGE = INTERACTION_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__BOUNDS = INTERACTION_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__NAME = INTERACTION_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__DOCUMENTATION = INTERACTION_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__RESOLUTION = INTERACTION_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Sequence Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM_FEATURE_COUNT = INTERACTION_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM___DIAGRAM = INTERACTION_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Sequence Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SEQUENCE_DIAGRAM_OPERATION_COUNT = INTERACTION_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__MODEL_ELEMENT = INTERACTION_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__OWNING_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__OWNED_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__LOCAL_STYLE = INTERACTION_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__SHARED_STYLE = INTERACTION_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__TARGET_EDGE = INTERACTION_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__SOURCE_EDGE = INTERACTION_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__DIAGRAM = INTERACTION_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__UML_MODEL_ELEMENT = INTERACTION_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__SHARED_UML_STYLE = INTERACTION_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__LOCAL_UML_STYLE = INTERACTION_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__TARGET_UML_EDGE = INTERACTION_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__SOURCE_UML_EDGE = INTERACTION_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__BOUNDS = INTERACTION_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__NAME = INTERACTION_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__DOCUMENTATION = INTERACTION_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__RESOLUTION = INTERACTION_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Communication Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM_FEATURE_COUNT = INTERACTION_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM___DIAGRAM = INTERACTION_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Communication Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMMUNICATION_DIAGRAM_OPERATION_COUNT = INTERACTION_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__MODEL_ELEMENT = INTERACTION_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__OWNING_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__OWNED_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__LOCAL_STYLE = INTERACTION_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__SHARED_STYLE = INTERACTION_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__TARGET_EDGE = INTERACTION_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__SOURCE_EDGE = INTERACTION_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__DIAGRAM = INTERACTION_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__UML_MODEL_ELEMENT = INTERACTION_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__SHARED_UML_STYLE = INTERACTION_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__LOCAL_UML_STYLE = INTERACTION_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__TARGET_UML_EDGE = INTERACTION_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__SOURCE_UML_EDGE = INTERACTION_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__BOUNDS = INTERACTION_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__NAME = INTERACTION_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__DOCUMENTATION = INTERACTION_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__RESOLUTION = INTERACTION_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Timing Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM_FEATURE_COUNT = INTERACTION_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM___DIAGRAM = INTERACTION_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Timing Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIMING_DIAGRAM_OPERATION_COUNT = INTERACTION_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__MODEL_ELEMENT = INTERACTION_DIAGRAM__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__OWNING_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__OWNED_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__LOCAL_STYLE = INTERACTION_DIAGRAM__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__SHARED_STYLE = INTERACTION_DIAGRAM__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__TARGET_EDGE = INTERACTION_DIAGRAM__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__SOURCE_EDGE = INTERACTION_DIAGRAM__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__DIAGRAM = INTERACTION_DIAGRAM__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__UML_MODEL_ELEMENT = INTERACTION_DIAGRAM__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__SHARED_UML_STYLE = INTERACTION_DIAGRAM__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__LOCAL_UML_STYLE = INTERACTION_DIAGRAM__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__TARGET_UML_EDGE = INTERACTION_DIAGRAM__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__SOURCE_UML_EDGE = INTERACTION_DIAGRAM__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__BOUNDS = INTERACTION_DIAGRAM__BOUNDS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__NAME = INTERACTION_DIAGRAM__NAME;

	/**
	 * The feature id for the '<em><b>Documentation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__DOCUMENTATION = INTERACTION_DIAGRAM__DOCUMENTATION;

	/**
	 * The feature id for the '<em><b>Resolution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__RESOLUTION = INTERACTION_DIAGRAM__RESOLUTION;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = INTERACTION_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Interaction Overview Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM_FEATURE_COUNT = INTERACTION_DIAGRAM_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM___DIAGRAM = INTERACTION_DIAGRAM___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Overview Diagram</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OVERVIEW_DIAGRAM_OPERATION_COUNT = INTERACTION_DIAGRAM_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>State Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT__STATE_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Internal Behavior Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Internal Behavior Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_BEHAVIOR_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__MODEL_ELEMENT = BASE_STATE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__OWNING_DIAGRAM_ELEMENT = BASE_STATE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__OWNED_DIAGRAM_ELEMENT = BASE_STATE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__LOCAL_STYLE = BASE_STATE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__SHARED_STYLE = BASE_STATE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__TARGET_EDGE = BASE_STATE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__SOURCE_EDGE = BASE_STATE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__DIAGRAM = BASE_STATE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__UML_MODEL_ELEMENT = BASE_STATE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__SHARED_UML_STYLE = BASE_STATE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__LOCAL_UML_STYLE = BASE_STATE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = BASE_STATE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = BASE_STATE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__TARGET_UML_EDGE = BASE_STATE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__SOURCE_UML_EDGE = BASE_STATE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = BASE_STATE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__STEREOTYPE_LABEL = BASE_STATE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__UML_DIAGRAM = BASE_STATE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__DIAGRAM_COMPARTMENT = BASE_STATE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__MAIN_LABEL = BASE_STATE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__BOUNDS = BASE_STATE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__STEREOTYPE_COMPARTMENT = BASE_STATE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Connection Point Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__CONNECTION_POINT_SHAPE = BASE_STATE_SHAPE__CONNECTION_POINT_SHAPE;

	/**
	 * The feature id for the '<em><b>Region Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__REGION_COMPARTMENT = BASE_STATE_SHAPE__REGION_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Connection Point Reference Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__CONNECTION_POINT_REFERENCE_SHAPE = BASE_STATE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Internal Transition Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__INTERNAL_TRANSITION_COMPARTMENT = BASE_STATE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Deferrable Trigger Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__DEFERRABLE_TRIGGER_COMPARTMENT = BASE_STATE_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Internal Behavior Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE__INTERNAL_BEHAVIOR_COMPARTMENT = BASE_STATE_SHAPE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>State Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE_FEATURE_COUNT = BASE_STATE_SHAPE_FEATURE_COUNT + 4;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE___DIAGRAM = BASE_STATE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>State Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_SHAPE_OPERATION_COUNT = BASE_STATE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>State Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE__STATE_SHAPE = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Connection Point Reference Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Connection Point Reference Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONNECTION_POINT_REFERENCE_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>State Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT__STATE_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Internal Transition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Internal Transition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERNAL_TRANSITION_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__MODEL_ELEMENT = LIST_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__LOCAL_STYLE = LIST_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__SHARED_STYLE = LIST_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__TARGET_EDGE = LIST_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__SOURCE_EDGE = LIST_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__DIAGRAM = LIST_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__UML_MODEL_ELEMENT = LIST_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__SHARED_UML_STYLE = LIST_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__LOCAL_UML_STYLE = LIST_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = LIST_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__TARGET_UML_EDGE = LIST_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__SOURCE_UML_EDGE = LIST_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__BOUNDS = LIST_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>List Item Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__LIST_ITEM_LABEL = LIST_COMPARTMENT__LIST_ITEM_LABEL;

	/**
	 * The feature id for the '<em><b>State Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT__STATE_SHAPE = LIST_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Deferrable Trigger Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT_FEATURE_COUNT = LIST_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT___DIAGRAM = LIST_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Deferrable Trigger Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DEFERRABLE_TRIGGER_COMPARTMENT_OPERATION_COUNT = LIST_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Placement</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__PLACEMENT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Subvertex Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE__SUBVERTEX_COMPARTMENT = ELEMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Region Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Region Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int REGION_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Region Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT__REGION_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subvertex Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Subvertex Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBVERTEX_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Transition Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Transition Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TRANSITION_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__MODEL_ELEMENT = ACTIVITY_EDGE_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__OWNING_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__OWNED_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__LOCAL_STYLE = ACTIVITY_EDGE_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__SHARED_STYLE = ACTIVITY_EDGE_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__TARGET_EDGE = ACTIVITY_EDGE_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__SOURCE_EDGE = ACTIVITY_EDGE_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__DIAGRAM = ACTIVITY_EDGE_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__UML_MODEL_ELEMENT = ACTIVITY_EDGE_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__SHARED_UML_STYLE = ACTIVITY_EDGE_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__LOCAL_UML_STYLE = ACTIVITY_EDGE_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__TARGET_UML_EDGE = ACTIVITY_EDGE_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__SOURCE_UML_EDGE = ACTIVITY_EDGE_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ACTIVITY_EDGE_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__STEREOTYPE_LABEL = ACTIVITY_EDGE_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__UML_DIAGRAM = ACTIVITY_EDGE_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__DIAGRAM_COMPARTMENT = ACTIVITY_EDGE_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__MAIN_LABEL = ACTIVITY_EDGE_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__SOURCE_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__WAYPOINT = ACTIVITY_EDGE_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__TARGET_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ACTIVITY_EDGE_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Guard Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__GUARD_LABEL = ACTIVITY_EDGE_EDGE__GUARD_LABEL;

	/**
	 * The feature id for the '<em><b>Weight Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE__WEIGHT_LABEL = ACTIVITY_EDGE_EDGE__WEIGHT_LABEL;

	/**
	 * The number of structural features of the '<em>Control Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE_FEATURE_COUNT = ACTIVITY_EDGE_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE___DIAGRAM = ACTIVITY_EDGE_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Control Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int CONTROL_FLOW_EDGE_OPERATION_COUNT = ACTIVITY_EDGE_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Activity Group Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Group Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_GROUP_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Type Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__TYPE_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Icon Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE__ICON_LABEL = ELEMENT_EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Exception Handler Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Exception Handler Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXCEPTION_HANDLER_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Interaction Use Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__INTERACTION_USE_SHAPE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Exception Handler Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL__EXCEPTION_HANDLER_EDGE = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Type Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Type Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TYPE_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__MODEL_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__OWNING_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__OWNED_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__LOCAL_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__SHARED_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__TARGET_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__SOURCE_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__DIAGRAM = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__UML_MODEL_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__SHARED_UML_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__LOCAL_UML_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__TARGET_UML_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__SOURCE_UML_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__STEREOTYPE_LABEL = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__UML_DIAGRAM = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__DIAGRAM_COMPARTMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__MAIN_LABEL = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__BOUNDS = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__STEREOTYPE_COMPARTMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__LIFELINE_SHAPE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LIFELINE_SHAPE;

	/**
	 * The feature id for the '<em><b>Gate Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__GATE_SHAPE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__GATE_SHAPE;

	/**
	 * The feature id for the '<em><b>Type Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE__TYPE_LABEL = INTERACTION_FRAGMENT_WITH_GATES_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Interaction Use Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE_FEATURE_COUNT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE___DIAGRAM = INTERACTION_FRAGMENT_WITH_GATES_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Use Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_USE_SHAPE_OPERATION_COUNT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Exception Handler Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL__EXCEPTION_HANDLER_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Icon Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Icon Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ICON_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__MODEL_ELEMENT = DIAGRAM_COMPARTMENT__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__OWNING_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__OWNED_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__LOCAL_STYLE = DIAGRAM_COMPARTMENT__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__SHARED_STYLE = DIAGRAM_COMPARTMENT__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__TARGET_EDGE = DIAGRAM_COMPARTMENT__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__SOURCE_EDGE = DIAGRAM_COMPARTMENT__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__DIAGRAM = DIAGRAM_COMPARTMENT__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__UML_MODEL_ELEMENT = DIAGRAM_COMPARTMENT__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__SHARED_UML_STYLE = DIAGRAM_COMPARTMENT__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__LOCAL_UML_STYLE = DIAGRAM_COMPARTMENT__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__TARGET_UML_EDGE = DIAGRAM_COMPARTMENT__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__SOURCE_UML_EDGE = DIAGRAM_COMPARTMENT__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__BOUNDS = DIAGRAM_COMPARTMENT__BOUNDS;

	/**
	 * The feature id for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Activity Partition Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT__ACTIVITY_PARTITION_SHAPE = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Subpartition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT_FEATURE_COUNT = DIAGRAM_COMPARTMENT_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT___DIAGRAM = DIAGRAM_COMPARTMENT___DIAGRAM;

	/**
	 * The number of operations of the '<em>Subpartition Compartment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int SUBPARTITION_COMPARTMENT_OPERATION_COUNT = DIAGRAM_COMPARTMENT_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__MODEL_ELEMENT = ACTIVITY_GROUP_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__OWNING_DIAGRAM_ELEMENT = ACTIVITY_GROUP_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__OWNED_DIAGRAM_ELEMENT = ACTIVITY_GROUP_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__LOCAL_STYLE = ACTIVITY_GROUP_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__SHARED_STYLE = ACTIVITY_GROUP_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__TARGET_EDGE = ACTIVITY_GROUP_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__SOURCE_EDGE = ACTIVITY_GROUP_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__DIAGRAM = ACTIVITY_GROUP_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__UML_MODEL_ELEMENT = ACTIVITY_GROUP_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__SHARED_UML_STYLE = ACTIVITY_GROUP_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__LOCAL_UML_STYLE = ACTIVITY_GROUP_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ACTIVITY_GROUP_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ACTIVITY_GROUP_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__TARGET_UML_EDGE = ACTIVITY_GROUP_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__SOURCE_UML_EDGE = ACTIVITY_GROUP_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ACTIVITY_GROUP_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__STEREOTYPE_LABEL = ACTIVITY_GROUP_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__UML_DIAGRAM = ACTIVITY_GROUP_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__DIAGRAM_COMPARTMENT = ACTIVITY_GROUP_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__MAIN_LABEL = ACTIVITY_GROUP_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__BOUNDS = ACTIVITY_GROUP_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__STEREOTYPE_COMPARTMENT = ACTIVITY_GROUP_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Is Vertical</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__IS_VERTICAL = ACTIVITY_GROUP_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Subpartition Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE__SUBPARTITION_COMPARTMENT = ACTIVITY_GROUP_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Activity Partition Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE_FEATURE_COUNT = ACTIVITY_GROUP_SHAPE_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE___DIAGRAM = ACTIVITY_GROUP_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Activity Partition Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int ACTIVITY_PARTITION_SHAPE_OPERATION_COUNT = ACTIVITY_GROUP_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__MODEL_ELEMENT = ACTION_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT = ACTION_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT = ACTION_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__LOCAL_STYLE = ACTION_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__SHARED_STYLE = ACTION_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__TARGET_EDGE = ACTION_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__SOURCE_EDGE = ACTION_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__DIAGRAM = ACTION_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__UML_MODEL_ELEMENT = ACTION_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__SHARED_UML_STYLE = ACTION_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__LOCAL_UML_STYLE = ACTION_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ACTION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ACTION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__TARGET_UML_EDGE = ACTION_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__SOURCE_UML_EDGE = ACTION_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ACTION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__STEREOTYPE_LABEL = ACTION_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__UML_DIAGRAM = ACTION_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__DIAGRAM_COMPARTMENT = ACTION_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__MAIN_LABEL = ACTION_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__BOUNDS = ACTION_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__STEREOTYPE_COMPARTMENT = ACTION_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Pin Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__PIN_SHAPE = ACTION_SHAPE__PIN_SHAPE;

	/**
	 * The feature id for the '<em><b>Condition Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__CONDITION_LABEL = ACTION_SHAPE__CONDITION_LABEL;

	/**
	 * The feature id for the '<em><b>Activity Node Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE__ACTIVITY_NODE_COMPARTMENT = ACTION_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Structured Activity Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE_FEATURE_COUNT = ACTION_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE___DIAGRAM = ACTION_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Structured Activity Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STRUCTURED_ACTIVITY_NODE_SHAPE_OPERATION_COUNT = ACTION_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__MODEL_ELEMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__OWNING_DIAGRAM_ELEMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__OWNED_DIAGRAM_ELEMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__LOCAL_STYLE = STRUCTURED_ACTIVITY_NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__SHARED_STYLE = STRUCTURED_ACTIVITY_NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__TARGET_EDGE = STRUCTURED_ACTIVITY_NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__SOURCE_EDGE = STRUCTURED_ACTIVITY_NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__DIAGRAM = STRUCTURED_ACTIVITY_NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__UML_MODEL_ELEMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__SHARED_UML_STYLE = STRUCTURED_ACTIVITY_NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__LOCAL_UML_STYLE = STRUCTURED_ACTIVITY_NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__TARGET_UML_EDGE = STRUCTURED_ACTIVITY_NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__SOURCE_UML_EDGE = STRUCTURED_ACTIVITY_NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = STRUCTURED_ACTIVITY_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__STEREOTYPE_LABEL = STRUCTURED_ACTIVITY_NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__UML_DIAGRAM = STRUCTURED_ACTIVITY_NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__DIAGRAM_COMPARTMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__MAIN_LABEL = STRUCTURED_ACTIVITY_NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__BOUNDS = STRUCTURED_ACTIVITY_NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__STEREOTYPE_COMPARTMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Pin Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__PIN_SHAPE = STRUCTURED_ACTIVITY_NODE_SHAPE__PIN_SHAPE;

	/**
	 * The feature id for the '<em><b>Condition Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__CONDITION_LABEL = STRUCTURED_ACTIVITY_NODE_SHAPE__CONDITION_LABEL;

	/**
	 * The feature id for the '<em><b>Activity Node Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__ACTIVITY_NODE_COMPARTMENT = STRUCTURED_ACTIVITY_NODE_SHAPE__ACTIVITY_NODE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Expansion Node Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE__EXPANSION_NODE_SHAPE = STRUCTURED_ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Expansion Region Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE_FEATURE_COUNT = STRUCTURED_ACTIVITY_NODE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE___DIAGRAM = STRUCTURED_ACTIVITY_NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Expansion Region Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_REGION_SHAPE_OPERATION_COUNT = STRUCTURED_ACTIVITY_NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__MODEL_ELEMENT = OBJECT_NODE_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__LOCAL_STYLE = OBJECT_NODE_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__SHARED_STYLE = OBJECT_NODE_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__TARGET_EDGE = OBJECT_NODE_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__SOURCE_EDGE = OBJECT_NODE_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__DIAGRAM = OBJECT_NODE_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__UML_MODEL_ELEMENT = OBJECT_NODE_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__SHARED_UML_STYLE = OBJECT_NODE_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__LOCAL_UML_STYLE = OBJECT_NODE_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = OBJECT_NODE_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__TARGET_UML_EDGE = OBJECT_NODE_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__SOURCE_UML_EDGE = OBJECT_NODE_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = OBJECT_NODE_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__STEREOTYPE_LABEL = OBJECT_NODE_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__UML_DIAGRAM = OBJECT_NODE_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__DIAGRAM_COMPARTMENT = OBJECT_NODE_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__MAIN_LABEL = OBJECT_NODE_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__BOUNDS = OBJECT_NODE_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__STEREOTYPE_COMPARTMENT = OBJECT_NODE_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Selection Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__SELECTION_LABEL = OBJECT_NODE_SHAPE__SELECTION_LABEL;

	/**
	 * The feature id for the '<em><b>Constraint Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__CONSTRAINT_LABEL = OBJECT_NODE_SHAPE__CONSTRAINT_LABEL;

	/**
	 * The feature id for the '<em><b>Expansion Region Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE__EXPANSION_REGION_SHAPE = OBJECT_NODE_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Expansion Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE_FEATURE_COUNT = OBJECT_NODE_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE___DIAGRAM = OBJECT_NODE_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Expansion Node Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXPANSION_NODE_SHAPE_OPERATION_COUNT = OBJECT_NODE_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.ExecutionSpecificationShapeImpl <em>Execution Specification Shape</em>}'
	 * class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.ExecutionSpecificationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExecutionSpecificationShape()
	 * @generated
	 */
	int EXECUTION_SPECIFICATION_SHAPE = 182;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>Message Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Message Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__MODEL_ELEMENT = ELEMENT_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__OWNING_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__OWNED_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__LOCAL_STYLE = ELEMENT_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__SHARED_STYLE = ELEMENT_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__TARGET_EDGE = ELEMENT_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__SOURCE_EDGE = ELEMENT_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__DIAGRAM = ELEMENT_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__UML_MODEL_ELEMENT = ELEMENT_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__SHARED_UML_STYLE = ELEMENT_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__LOCAL_UML_STYLE = ELEMENT_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__TARGET_UML_EDGE = ELEMENT_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__SOURCE_UML_EDGE = ELEMENT_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__STEREOTYPE_LABEL = ELEMENT_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__UML_DIAGRAM = ELEMENT_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__DIAGRAM_COMPARTMENT = ELEMENT_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__MAIN_LABEL = ELEMENT_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__SOURCE_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__WAYPOINT = ELEMENT_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__TARGET_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE__TARGET_UML_DIAGRAM_ELEMENT = ELEMENT_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The number of structural features of the '<em>General Ordering Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE_FEATURE_COUNT = ELEMENT_EDGE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE___DIAGRAM = ELEMENT_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>General Ordering Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int GENERAL_ORDERING_EDGE_OPERATION_COUNT = ELEMENT_EDGE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__MODEL_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__OWNING_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__OWNED_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__LOCAL_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__SHARED_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__TARGET_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__SOURCE_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__DIAGRAM = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__UML_MODEL_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__SHARED_UML_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__LOCAL_UML_STYLE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__TARGET_UML_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__SOURCE_UML_EDGE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__STEREOTYPE_LABEL = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__UML_DIAGRAM = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__DIAGRAM_COMPARTMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__MAIN_LABEL = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__BOUNDS = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__STEREOTYPE_COMPARTMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__LIFELINE_SHAPE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__LIFELINE_SHAPE;

	/**
	 * The feature id for the '<em><b>Gate Shape</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__GATE_SHAPE = INTERACTION_FRAGMENT_WITH_GATES_SHAPE__GATE_SHAPE;

	/**
	 * The feature id for the '<em><b>Subfragment Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE__SUBFRAGMENT_COMPARTMENT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Combined Fragment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE_FEATURE_COUNT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE___DIAGRAM = INTERACTION_FRAGMENT_WITH_GATES_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Combined Fragment Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int COMBINED_FRAGMENT_SHAPE_OPERATION_COUNT = INTERACTION_FRAGMENT_WITH_GATES_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__MODEL_ELEMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__OWNING_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__OWNED_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__LOCAL_STYLE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__SHARED_STYLE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__TARGET_EDGE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__SOURCE_EDGE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__DIAGRAM = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__UML_MODEL_ELEMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__SHARED_UML_STYLE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__LOCAL_UML_STYLE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__TARGET_UML_EDGE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__SOURCE_UML_EDGE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__STEREOTYPE_LABEL = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__UML_DIAGRAM = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__DIAGRAM_COMPARTMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__MAIN_LABEL = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__BOUNDS = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__STEREOTYPE_COMPARTMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__LIFELINE_SHAPE = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__LIFELINE_SHAPE;

	/**
	 * The feature id for the '<em><b>Subfragment Compartment</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE__SUBFRAGMENT_COMPARTMENT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SUBFRAGMENT_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Interaction Operand Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE_FEATURE_COUNT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE___DIAGRAM = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Interaction Operand Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERAND_SHAPE_OPERATION_COUNT = INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__OWNING_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__OWNED_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__LOCAL_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__SHARED_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__TARGET_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__SOURCE_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__DIAGRAM = INTERACTION_FRAGMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__UML_MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__SHARED_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__LOCAL_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__TARGET_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__SOURCE_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = INTERACTION_FRAGMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__STEREOTYPE_LABEL = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__UML_DIAGRAM = INTERACTION_FRAGMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__DIAGRAM_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__MAIN_LABEL = INTERACTION_FRAGMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__BOUNDS = INTERACTION_FRAGMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__STEREOTYPE_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE__LIFELINE_SHAPE = INTERACTION_FRAGMENT_SHAPE__LIFELINE_SHAPE;

	/**
	 * The number of structural features of the '<em>Execution Specification Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE_FEATURE_COUNT = INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE___DIAGRAM = INTERACTION_FRAGMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Execution Specification Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int EXECUTION_SPECIFICATION_SHAPE_OPERATION_COUNT = INTERACTION_FRAGMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DurationConstraintShapeImpl <em>Duration Constraint Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DurationConstraintShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDurationConstraintShape()
	 * @generated
	 */
	int DURATION_CONSTRAINT_SHAPE = 183;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__MODEL_ELEMENT = CONSTRAINT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__OWNING_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__OWNED_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__LOCAL_STYLE = CONSTRAINT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__SHARED_STYLE = CONSTRAINT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__TARGET_EDGE = CONSTRAINT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__SOURCE_EDGE = CONSTRAINT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__DIAGRAM = CONSTRAINT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__UML_MODEL_ELEMENT = CONSTRAINT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__SHARED_UML_STYLE = CONSTRAINT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__LOCAL_UML_STYLE = CONSTRAINT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__TARGET_UML_EDGE = CONSTRAINT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__SOURCE_UML_EDGE = CONSTRAINT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CONSTRAINT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__STEREOTYPE_LABEL = CONSTRAINT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__UML_DIAGRAM = CONSTRAINT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__DIAGRAM_COMPARTMENT = CONSTRAINT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__MAIN_LABEL = CONSTRAINT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__BOUNDS = CONSTRAINT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE__STEREOTYPE_COMPARTMENT = CONSTRAINT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Duration Constraint Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE_FEATURE_COUNT = CONSTRAINT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE___DIAGRAM = CONSTRAINT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Duration Constraint Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_CONSTRAINT_SHAPE_OPERATION_COUNT = CONSTRAINT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TimeConstraintShapeImpl <em>Time Constraint Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TimeConstraintShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeConstraintShape()
	 * @generated
	 */
	int TIME_CONSTRAINT_SHAPE = 184;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__MODEL_ELEMENT = CONSTRAINT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__OWNING_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__OWNED_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__LOCAL_STYLE = CONSTRAINT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__SHARED_STYLE = CONSTRAINT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__TARGET_EDGE = CONSTRAINT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__SOURCE_EDGE = CONSTRAINT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__DIAGRAM = CONSTRAINT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__UML_MODEL_ELEMENT = CONSTRAINT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__SHARED_UML_STYLE = CONSTRAINT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__LOCAL_UML_STYLE = CONSTRAINT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = CONSTRAINT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__TARGET_UML_EDGE = CONSTRAINT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__SOURCE_UML_EDGE = CONSTRAINT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = CONSTRAINT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__STEREOTYPE_LABEL = CONSTRAINT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__UML_DIAGRAM = CONSTRAINT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__DIAGRAM_COMPARTMENT = CONSTRAINT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__MAIN_LABEL = CONSTRAINT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__BOUNDS = CONSTRAINT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE__STEREOTYPE_COMPARTMENT = CONSTRAINT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Time Constraint Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE_FEATURE_COUNT = CONSTRAINT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE___DIAGRAM = CONSTRAINT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Time Constraint Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_CONSTRAINT_SHAPE_OPERATION_COUNT = CONSTRAINT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.TimeExpressionShapeImpl <em>Time Expression Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.TimeExpressionShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeExpressionShape()
	 * @generated
	 */
	int TIME_EXPRESSION_SHAPE = 185;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Time Expression Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Time Expression Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int TIME_EXPRESSION_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.DurationShapeImpl <em>Duration Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.DurationShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDurationShape()
	 * @generated
	 */
	int DURATION_SHAPE = 186;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__MODEL_ELEMENT = ELEMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__OWNING_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__OWNED_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__LOCAL_STYLE = ELEMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__SHARED_STYLE = ELEMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__TARGET_EDGE = ELEMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__SOURCE_EDGE = ELEMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__DIAGRAM = ELEMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__UML_MODEL_ELEMENT = ELEMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__SHARED_UML_STYLE = ELEMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__LOCAL_UML_STYLE = ELEMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = ELEMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__TARGET_UML_EDGE = ELEMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__SOURCE_UML_EDGE = ELEMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = ELEMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__STEREOTYPE_LABEL = ELEMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__UML_DIAGRAM = ELEMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__DIAGRAM_COMPARTMENT = ELEMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__MAIN_LABEL = ELEMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__BOUNDS = ELEMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE__STEREOTYPE_COMPARTMENT = ELEMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The number of structural features of the '<em>Duration Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE_FEATURE_COUNT = ELEMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE___DIAGRAM = ELEMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Duration Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int DURATION_SHAPE_OPERATION_COUNT = ELEMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.PathEdgeImpl <em>Path Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.PathEdgeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPathEdge()
	 * @generated
	 */
	int PATH_EDGE = 187;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__MODEL_ELEMENT = UML_EDGE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__OWNING_DIAGRAM_ELEMENT = UML_EDGE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__OWNED_DIAGRAM_ELEMENT = UML_EDGE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__LOCAL_STYLE = UML_EDGE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__SHARED_STYLE = UML_EDGE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__TARGET_EDGE = UML_EDGE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__SOURCE_EDGE = UML_EDGE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__DIAGRAM = UML_EDGE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__UML_MODEL_ELEMENT = UML_EDGE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__SHARED_UML_STYLE = UML_EDGE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__LOCAL_UML_STYLE = UML_EDGE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__OWNED_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__OWNING_UML_DIAGRAM_ELEMENT = UML_EDGE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__TARGET_UML_EDGE = UML_EDGE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__SOURCE_UML_EDGE = UML_EDGE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__SHOW_STEREOTYPE_ATTRIBUTES = UML_EDGE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__STEREOTYPE_LABEL = UML_EDGE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__UML_DIAGRAM = UML_EDGE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__DIAGRAM_COMPARTMENT = UML_EDGE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__MAIN_LABEL = UML_EDGE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Source Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__SOURCE_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Waypoint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__WAYPOINT = UML_EDGE__WAYPOINT;

	/**
	 * The feature id for the '<em><b>Target Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__TARGET_DIAGRAM_ELEMENT = UML_EDGE__TARGET_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Source Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = UML_EDGE__SOURCE_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__TARGET_UML_DIAGRAM_ELEMENT = UML_EDGE__TARGET_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Message Label</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE__MESSAGE_LABEL = UML_EDGE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Path Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE_FEATURE_COUNT = UML_EDGE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE___DIAGRAM = UML_EDGE___DIAGRAM;

	/**
	 * The number of operations of the '<em>Path Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int PATH_EDGE_OPERATION_COUNT = UML_EDGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.MessageLabelImpl <em>Message Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.MessageLabelImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMessageLabel()
	 * @generated
	 */
	int MESSAGE_LABEL = 188;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__MODEL_ELEMENT = UML_LABEL__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__OWNING_DIAGRAM_ELEMENT = UML_LABEL__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__OWNED_DIAGRAM_ELEMENT = UML_LABEL__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__LOCAL_STYLE = UML_LABEL__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__SHARED_STYLE = UML_LABEL__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__TARGET_EDGE = UML_LABEL__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__SOURCE_EDGE = UML_LABEL__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__DIAGRAM = UML_LABEL__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__UML_MODEL_ELEMENT = UML_LABEL__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__SHARED_UML_STYLE = UML_LABEL__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__LOCAL_UML_STYLE = UML_LABEL__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__OWNED_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__OWNING_UML_DIAGRAM_ELEMENT = UML_LABEL__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__TARGET_UML_EDGE = UML_LABEL__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__SOURCE_UML_EDGE = UML_LABEL__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__BOUNDS = UML_LABEL__BOUNDS;

	/**
	 * The feature id for the '<em><b>Path Edge</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL__PATH_EDGE = UML_LABEL_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Message Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL_FEATURE_COUNT = UML_LABEL_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL___DIAGRAM = UML_LABEL___DIAGRAM;

	/**
	 * The number of operations of the '<em>Message Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int MESSAGE_LABEL_OPERATION_COUNT = UML_LABEL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.impl.StateInvariantShapeImpl <em>State Invariant Shape</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.impl.StateInvariantShapeImpl
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateInvariantShape()
	 * @generated
	 */
	int STATE_INVARIANT_SHAPE = 189;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__OWNING_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owned Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__OWNED_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Local Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__LOCAL_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_STYLE;

	/**
	 * The feature id for the '<em><b>Shared Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__SHARED_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_STYLE;

	/**
	 * The feature id for the '<em><b>Target Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__TARGET_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_EDGE;

	/**
	 * The feature id for the '<em><b>Source Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__SOURCE_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_EDGE;

	/**
	 * The feature id for the '<em><b>Diagram</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__DIAGRAM = INTERACTION_FRAGMENT_SHAPE__DIAGRAM;

	/**
	 * The feature id for the '<em><b>Uml Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__UML_MODEL_ELEMENT = INTERACTION_FRAGMENT_SHAPE__UML_MODEL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Shared Uml Style</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__SHARED_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__SHARED_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Local Uml Style</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__LOCAL_UML_STYLE = INTERACTION_FRAGMENT_SHAPE__LOCAL_UML_STYLE;

	/**
	 * The feature id for the '<em><b>Owned Uml Diagram Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNED_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Owning Uml Diagram Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT = INTERACTION_FRAGMENT_SHAPE__OWNING_UML_DIAGRAM_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__TARGET_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__TARGET_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Source Uml Edge</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__SOURCE_UML_EDGE = INTERACTION_FRAGMENT_SHAPE__SOURCE_UML_EDGE;

	/**
	 * The feature id for the '<em><b>Show Stereotype Attributes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES = INTERACTION_FRAGMENT_SHAPE__SHOW_STEREOTYPE_ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Stereotype Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__STEREOTYPE_LABEL = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_LABEL;

	/**
	 * The feature id for the '<em><b>Uml Diagram</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__UML_DIAGRAM = INTERACTION_FRAGMENT_SHAPE__UML_DIAGRAM;

	/**
	 * The feature id for the '<em><b>Diagram Compartment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__DIAGRAM_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__DIAGRAM_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Main Label</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__MAIN_LABEL = INTERACTION_FRAGMENT_SHAPE__MAIN_LABEL;

	/**
	 * The feature id for the '<em><b>Bounds</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__BOUNDS = INTERACTION_FRAGMENT_SHAPE__BOUNDS;

	/**
	 * The feature id for the '<em><b>Stereotype Compartment</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__STEREOTYPE_COMPARTMENT = INTERACTION_FRAGMENT_SHAPE__STEREOTYPE_COMPARTMENT;

	/**
	 * The feature id for the '<em><b>Lifeline Shape</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__LIFELINE_SHAPE = INTERACTION_FRAGMENT_SHAPE__LIFELINE_SHAPE;

	/**
	 * The feature id for the '<em><b>Use State Shape</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE__USE_STATE_SHAPE = INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>State Invariant Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE_FEATURE_COUNT = INTERACTION_FRAGMENT_SHAPE_FEATURE_COUNT + 1;

	/**
	 * The operation id for the '<em>Diagram</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE___DIAGRAM = INTERACTION_FRAGMENT_SHAPE___DIAGRAM;

	/**
	 * The number of operations of the '<em>State Invariant Shape</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	int STATE_INVARIANT_SHAPE_OPERATION_COUNT = INTERACTION_FRAGMENT_SHAPE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.CompartmentLayout <em>Compartment Layout</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.CompartmentLayout
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCompartmentLayout()
	 * @generated
	 */
	int COMPARTMENT_LAYOUT = 190;

	/**
	 * The meta object id for the '{@link org.eclipse.papyrus.umldi.Placement <em>Placement</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.papyrus.umldi.Placement
	 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPlacement()
	 * @generated
	 */
	int PLACEMENT = 191;

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UmlDiagram <em>Uml Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Uml Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagram
	 * @generated
	 */
	EClass getUmlDiagram();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.UmlDiagram#getTopUmlDiagramElement
	 * <em>Top Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Top Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagram#getTopUmlDiagramElement()
	 * @see #getUmlDiagram()
	 * @generated
	 */
	EReference getUmlDiagram_TopUmlDiagramElement();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UmlDiagramElement <em>Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement
	 * @generated
	 */
	EClass getUmlDiagramElement();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.papyrus.umldi.UmlDiagramElement#getUmlModelElement <em>Uml Model Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Uml Model Element</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement#getUmlModelElement()
	 * @see #getUmlDiagramElement()
	 * @generated
	 */
	EReference getUmlDiagramElement_UmlModelElement();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.papyrus.umldi.UmlDiagramElement#getSharedUmlStyle <em>Shared Uml Style</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Shared Uml Style</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement#getSharedUmlStyle()
	 * @see #getUmlDiagramElement()
	 * @generated
	 */
	EReference getUmlDiagramElement_SharedUmlStyle();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.UmlDiagramElement#getLocalUmlStyle
	 * <em>Local Uml Style</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Local Uml Style</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement#getLocalUmlStyle()
	 * @see #getUmlDiagramElement()
	 * @generated
	 */
	EReference getUmlDiagramElement_LocalUmlStyle();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.papyrus.umldi.UmlDiagramElement#getOwnedUmlDiagramElement
	 * <em>Owned Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Owned Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement#getOwnedUmlDiagramElement()
	 * @see #getUmlDiagramElement()
	 * @generated
	 */
	EReference getUmlDiagramElement_OwnedUmlDiagramElement();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.papyrus.umldi.UmlDiagramElement#getOwningUmlDiagramElement
	 * <em>Owning Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Owning Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement#getOwningUmlDiagramElement()
	 * @see #getUmlDiagramElement()
	 * @generated
	 */
	EReference getUmlDiagramElement_OwningUmlDiagramElement();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.papyrus.umldi.UmlDiagramElement#getTargetUmlEdge <em>Target Uml Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Target Uml Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement#getTargetUmlEdge()
	 * @see #getUmlDiagramElement()
	 * @generated
	 */
	EReference getUmlDiagramElement_TargetUmlEdge();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.papyrus.umldi.UmlDiagramElement#getSourceUmlEdge <em>Source Uml Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference list '<em>Source Uml Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlDiagramElement#getSourceUmlEdge()
	 * @see #getUmlDiagramElement()
	 * @generated
	 */
	EReference getUmlDiagramElement_SourceUmlEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UmlStyle <em>Uml Style</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Uml Style</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlStyle
	 * @generated
	 */
	EClass getUmlStyle();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.papyrus.umldi.UmlStyle#getFontName <em>Font Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Font Name</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlStyle#getFontName()
	 * @see #getUmlStyle()
	 * @generated
	 */
	EAttribute getUmlStyle_FontName();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.papyrus.umldi.UmlStyle#getFontSize <em>Font Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Font Size</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlStyle#getFontSize()
	 * @see #getUmlStyle()
	 * @generated
	 */
	EAttribute getUmlStyle_FontSize();

	/**
	 * Returns the meta object for the '
	 * {@link org.eclipse.papyrus.umldi.UmlStyle#fontsizePositive(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * <em>Fontsize Positive</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the '<em>Fontsize Positive</em>' operation.
	 * @see org.eclipse.papyrus.umldi.UmlStyle#fontsizePositive(org.eclipse.emf.common.util.DiagnosticChain, java.util.Map)
	 * @generated
	 */
	EOperation getUmlStyle__FontsizePositive__DiagnosticChain_Map();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UmlEdge <em>Uml Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Uml Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlEdge
	 * @generated
	 */
	EClass getUmlEdge();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.papyrus.umldi.UmlEdge#getSourceUmlDiagramElement
	 * <em>Source Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Source Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlEdge#getSourceUmlDiagramElement()
	 * @see #getUmlEdge()
	 * @generated
	 */
	EReference getUmlEdge_SourceUmlDiagramElement();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.papyrus.umldi.UmlEdge#getTargetUmlDiagramElement
	 * <em>Target Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the reference '<em>Target Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlEdge#getTargetUmlDiagramElement()
	 * @see #getUmlEdge()
	 * @generated
	 */
	EReference getUmlEdge_TargetUmlDiagramElement();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TopUmlDiagramElement <em>Top Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Top Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.TopUmlDiagramElement
	 * @generated
	 */
	EClass getTopUmlDiagramElement();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.TopUmlDiagramElement#getUmlDiagram <em>Uml Diagram</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Uml Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.TopUmlDiagramElement#getUmlDiagram()
	 * @see #getTopUmlDiagramElement()
	 * @generated
	 */
	EReference getTopUmlDiagramElement_UmlDiagram();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.TopUmlDiagramElement#getDiagramCompartment
	 * <em>Diagram Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Diagram Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.TopUmlDiagramElement#getDiagramCompartment()
	 * @see #getTopUmlDiagramElement()
	 * @generated
	 */
	EReference getTopUmlDiagramElement_DiagramCompartment();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.TopUmlDiagramElement#getMainLabel <em>Main Label</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Main Label</em>'.
	 * @see org.eclipse.papyrus.umldi.TopUmlDiagramElement#getMainLabel()
	 * @see #getTopUmlDiagramElement()
	 * @generated
	 */
	EReference getTopUmlDiagramElement_MainLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StereotypedDiagramElement <em>Stereotyped Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Stereotyped Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypedDiagramElement
	 * @generated
	 */
	EClass getStereotypedDiagramElement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.papyrus.umldi.StereotypedDiagramElement#isShowStereotypeAttributes
	 * <em>Show Stereotype Attributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Show Stereotype Attributes</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypedDiagramElement#isShowStereotypeAttributes()
	 * @see #getStereotypedDiagramElement()
	 * @generated
	 */
	EAttribute getStereotypedDiagramElement_ShowStereotypeAttributes();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.StereotypedDiagramElement#getStereotypeLabel
	 * <em>Stereotype Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Stereotype Label</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypedDiagramElement#getStereotypeLabel()
	 * @see #getStereotypedDiagramElement()
	 * @generated
	 */
	EReference getStereotypedDiagramElement_StereotypeLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DiagramCompartment <em>Diagram Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Diagram Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.DiagramCompartment
	 * @generated
	 */
	EClass getDiagramCompartment();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.DiagramCompartment#getTopUmlDiagramElement
	 * <em>Top Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Top Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.DiagramCompartment#getTopUmlDiagramElement()
	 * @see #getDiagramCompartment()
	 * @generated
	 */
	EReference getDiagramCompartment_TopUmlDiagramElement();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UmlCompartment <em>Uml Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Uml Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlCompartment
	 * @generated
	 */
	EClass getUmlCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.MainLabel <em>Main Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Main Label</em>'.
	 * @see org.eclipse.papyrus.umldi.MainLabel
	 * @generated
	 */
	EClass getMainLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.MainLabel#getTopUmlDiagramElement
	 * <em>Top Uml Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Top Uml Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.MainLabel#getTopUmlDiagramElement()
	 * @see #getMainLabel()
	 * @generated
	 */
	EReference getMainLabel_TopUmlDiagramElement();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UmlLabel <em>Uml Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Uml Label</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlLabel
	 * @generated
	 */
	EClass getUmlLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UmlShape <em>Uml Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Uml Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlShape
	 * @generated
	 */
	EClass getUmlShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.UmlShape#getStereotypeCompartment
	 * <em>Stereotype Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Stereotype Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.UmlShape#getStereotypeCompartment()
	 * @see #getUmlShape()
	 * @generated
	 */
	EReference getUmlShape_StereotypeCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassDiagram <em>Class Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Class Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassDiagram
	 * @generated
	 */
	EClass getClassDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StructureDiagram <em>Structure Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Structure Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.StructureDiagram
	 * @generated
	 */
	EClass getStructureDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassifierShape <em>Classifier Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Classifier Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierShape
	 * @generated
	 */
	EClass getClassifierShape();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.papyrus.umldi.ClassifierShape#isUseClassifierNotation
	 * <em>Use Classifier Notation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Use Classifier Notation</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierShape#isUseClassifierNotation()
	 * @see #getClassifierShape()
	 * @generated
	 */
	EAttribute getClassifierShape_UseClassifierNotation();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ClassifierShape#getOwnedUseCaseCompartment
	 * <em>Owned Use Case Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Owned Use Case Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierShape#getOwnedUseCaseCompartment()
	 * @see #getClassifierShape()
	 * @generated
	 */
	EReference getClassifierShape_OwnedUseCaseCompartment();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ClassifierShape#getUseCaseCompartment
	 * <em>Use Case Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Use Case Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierShape#getUseCaseCompartment()
	 * @see #getClassifierShape()
	 * @generated
	 */
	EReference getClassifierShape_UseCaseCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TemplateableElementShape <em>Templateable Element Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Templateable Element Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.TemplateableElementShape
	 * @generated
	 */
	EClass getTemplateableElementShape();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link org.eclipse.papyrus.umldi.TemplateableElementShape#getTemplateParameterCompartment <em>Template Parameter Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Template Parameter Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.TemplateableElementShape#getTemplateParameterCompartment()
	 * @see #getTemplateableElementShape()
	 * @generated
	 */
	EReference getTemplateableElementShape_TemplateParameterCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ElementShape <em>Element Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Element Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementShape
	 * @generated
	 */
	EClass getElementShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StereotypeCompartment <em>Stereotype Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Stereotype Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypeCompartment
	 * @generated
	 */
	EClass getStereotypeCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.StereotypeCompartment#getUmlShape <em>Uml Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Uml Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypeCompartment#getUmlShape()
	 * @see #getStereotypeCompartment()
	 * @generated
	 */
	EReference getStereotypeCompartment_UmlShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TemplateParameterCompartment <em>Template Parameter Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Template Parameter Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.TemplateParameterCompartment
	 * @generated
	 */
	EClass getTemplateParameterCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.TemplateParameterCompartment#getTemplateableElementShape
	 * <em>Templateable Element Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Templateable Element Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.TemplateParameterCompartment#getTemplateableElementShape()
	 * @see #getTemplateParameterCompartment()
	 * @generated
	 */
	EReference getTemplateParameterCompartment_TemplateableElementShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ListCompartment <em>List Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>List Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ListCompartment
	 * @generated
	 */
	EClass getListCompartment();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.ListCompartment#getListItemLabel
	 * <em>List Item Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>List Item Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ListCompartment#getListItemLabel()
	 * @see #getListCompartment()
	 * @generated
	 */
	EReference getListCompartment_ListItemLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ListItemLabel <em>List Item Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>List Item Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ListItemLabel
	 * @generated
	 */
	EClass getListItemLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ListItemLabel#getListCompartment
	 * <em>List Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>List Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ListItemLabel#getListCompartment()
	 * @see #getListItemLabel()
	 * @generated
	 */
	EReference getListItemLabel_ListCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StereotypeLabel <em>Stereotype Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Stereotype Label</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypeLabel
	 * @generated
	 */
	EClass getStereotypeLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.StereotypeLabel#getStereotypedDiagramElement
	 * <em>Stereotyped Diagram Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Stereotyped Diagram Element</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypeLabel#getStereotypedDiagramElement()
	 * @see #getStereotypeLabel()
	 * @generated
	 */
	EReference getStereotypeLabel_StereotypedDiagramElement();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.OwnedUseCaseCompartment <em>Owned Use Case Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Owned Use Case Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.OwnedUseCaseCompartment
	 * @generated
	 */
	EClass getOwnedUseCaseCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.OwnedUseCaseCompartment#getClassifierShape
	 * <em>Classifier Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Classifier Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.OwnedUseCaseCompartment#getClassifierShape()
	 * @see #getOwnedUseCaseCompartment()
	 * @generated
	 */
	EReference getOwnedUseCaseCompartment_ClassifierShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassifierCompartment <em>Classifier Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Classifier Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierCompartment
	 * @generated
	 */
	EClass getClassifierCompartment();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.papyrus.umldi.ClassifierCompartment#getLayout <em>Layout</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Layout</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierCompartment#getLayout()
	 * @see #getClassifierCompartment()
	 * @generated
	 */
	EAttribute getClassifierCompartment_Layout();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UseCaseCompartment <em>Use Case Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Use Case Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.UseCaseCompartment
	 * @generated
	 */
	EClass getUseCaseCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.UseCaseCompartment#getClassifierShape
	 * <em>Classifier Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Classifier Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.UseCaseCompartment#getClassifierShape()
	 * @see #getUseCaseCompartment()
	 * @generated
	 */
	EReference getUseCaseCompartment_ClassifierShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PackageShape <em>Package Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Package Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PackageShape
	 * @generated
	 */
	EClass getPackageShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ElementWithPackagedElementsShape
	 * <em>Element With Packaged Elements Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Element With Packaged Elements Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithPackagedElementsShape
	 * @generated
	 */
	EClass getElementWithPackagedElementsShape();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link org.eclipse.papyrus.umldi.ElementWithPackagedElementsShape#getPackagedElementCompartment <em>Packaged Element Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Packaged Element Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithPackagedElementsShape#getPackagedElementCompartment()
	 * @see #getElementWithPackagedElementsShape()
	 * @generated
	 */
	EReference getElementWithPackagedElementsShape_PackagedElementCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PackagedElementCompartment <em>Packaged Element Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Packaged Element Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.PackagedElementCompartment
	 * @generated
	 */
	EClass getPackagedElementCompartment();

	/**
	 * Returns the meta object for the container reference '
	 * {@link org.eclipse.papyrus.umldi.PackagedElementCompartment#getElementWithPackagedElementsShape <em>Element With Packaged Elements Shape</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Element With Packaged Elements Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PackagedElementCompartment#getElementWithPackagedElementsShape()
	 * @see #getPackagedElementCompartment()
	 * @generated
	 */
	EReference getPackagedElementCompartment_ElementWithPackagedElementsShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ConstraintShape <em>Constraint Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constraint Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintShape
	 * @generated
	 */
	EClass getConstraintShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.AttributeCompartment <em>Attribute Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Attribute Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.AttributeCompartment
	 * @generated
	 */
	EClass getAttributeCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.AttributeCompartment#getClassifierWithAttributesShape
	 * <em>Classifier With Attributes Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Classifier With Attributes Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.AttributeCompartment#getClassifierWithAttributesShape()
	 * @see #getAttributeCompartment()
	 * @generated
	 */
	EReference getAttributeCompartment_ClassifierWithAttributesShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassifierWithAttributesShape <em>Classifier With Attributes Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Classifier With Attributes Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithAttributesShape
	 * @generated
	 */
	EClass getClassifierWithAttributesShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ClassifierWithAttributesShape#getAttributeCompartment
	 * <em>Attribute Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Attribute Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithAttributesShape#getAttributeCompartment()
	 * @see #getClassifierWithAttributesShape()
	 * @generated
	 */
	EReference getClassifierWithAttributesShape_AttributeCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.OperationCompartment <em>Operation Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Operation Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.OperationCompartment
	 * @generated
	 */
	EClass getOperationCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.OperationCompartment#getClassifierWithOperationsShape
	 * <em>Classifier With Operations Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Classifier With Operations Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.OperationCompartment#getClassifierWithOperationsShape()
	 * @see #getOperationCompartment()
	 * @generated
	 */
	EReference getOperationCompartment_ClassifierWithOperationsShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassifierWithOperationsShape <em>Classifier With Operations Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Classifier With Operations Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithOperationsShape
	 * @generated
	 */
	EClass getClassifierWithOperationsShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ClassifierWithOperationsShape#getOperationCompartment
	 * <em>Operation Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Operation Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithOperationsShape#getOperationCompartment()
	 * @see #getClassifierWithOperationsShape()
	 * @generated
	 */
	EReference getClassifierWithOperationsShape_OperationCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ReceptionCompartment <em>Reception Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Reception Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ReceptionCompartment
	 * @generated
	 */
	EClass getReceptionCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ReceptionCompartment#getClassifierWithReceptionShape
	 * <em>Classifier With Reception Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Classifier With Reception Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ReceptionCompartment#getClassifierWithReceptionShape()
	 * @see #getReceptionCompartment()
	 * @generated
	 */
	EReference getReceptionCompartment_ClassifierWithReceptionShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassifierWithReceptionsShape <em>Classifier With Receptions Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Classifier With Receptions Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithReceptionsShape
	 * @generated
	 */
	EClass getClassifierWithReceptionsShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ClassifierWithReceptionsShape#getReceptionCompartment
	 * <em>Reception Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Reception Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithReceptionsShape#getReceptionCompartment()
	 * @see #getClassifierWithReceptionsShape()
	 * @generated
	 */
	EReference getClassifierWithReceptionsShape_ReceptionCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.LiteralCompartment <em>Literal Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Literal Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.LiteralCompartment
	 * @generated
	 */
	EClass getLiteralCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.LiteralCompartment#getEnumerationShape
	 * <em>Enumeration Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Enumeration Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.LiteralCompartment#getEnumerationShape()
	 * @see #getLiteralCompartment()
	 * @generated
	 */
	EReference getLiteralCompartment_EnumerationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.EnumerationShape <em>Enumeration Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Enumeration Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.EnumerationShape
	 * @generated
	 */
	EClass getEnumerationShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.EnumerationShape#getLiteralCompartment
	 * <em>Literal Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Literal Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.EnumerationShape#getLiteralCompartment()
	 * @see #getEnumerationShape()
	 * @generated
	 */
	EReference getEnumerationShape_LiteralCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.RoleLabel <em>Role Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Role Label</em>'.
	 * @see org.eclipse.papyrus.umldi.RoleLabel
	 * @generated
	 */
	EClass getRoleLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.RoleLabel#getAssociationEdge <em>Association Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Association Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.RoleLabel#getAssociationEdge()
	 * @see #getRoleLabel()
	 * @generated
	 */
	EReference getRoleLabel_AssociationEdge();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.RoleLabel#getInstanceSpecificationEdge
	 * <em>Instance Specification Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Instance Specification Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.RoleLabel#getInstanceSpecificationEdge()
	 * @see #getRoleLabel()
	 * @generated
	 */
	EReference getRoleLabel_InstanceSpecificationEdge();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.RoleLabel#getRoleBindingEdge <em>Role Binding Edge</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Role Binding Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.RoleLabel#getRoleBindingEdge()
	 * @see #getRoleLabel()
	 * @generated
	 */
	EReference getRoleLabel_RoleBindingEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.AssociationEdge <em>Association Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Association Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.AssociationEdge
	 * @generated
	 */
	EClass getAssociationEdge();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.AssociationEdge#getEndMultiplicityLabel
	 * <em>End Multiplicity Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>End Multiplicity Label</em>'.
	 * @see org.eclipse.papyrus.umldi.AssociationEdge#getEndMultiplicityLabel()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EReference getAssociationEdge_EndMultiplicityLabel();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.AssociationEdge#getEndConstraintLabel
	 * <em>End Constraint Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>End Constraint Label</em>'.
	 * @see org.eclipse.papyrus.umldi.AssociationEdge#getEndConstraintLabel()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EReference getAssociationEdge_EndConstraintLabel();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.AssociationEdge#getEndRoleLabel
	 * <em>End Role Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>End Role Label</em>'.
	 * @see org.eclipse.papyrus.umldi.AssociationEdge#getEndRoleLabel()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EReference getAssociationEdge_EndRoleLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ElementEdge <em>Element Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Element Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementEdge
	 * @generated
	 */
	EClass getElementEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.MultiplicityLabel <em>Multiplicity Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Multiplicity Label</em>'.
	 * @see org.eclipse.papyrus.umldi.MultiplicityLabel
	 * @generated
	 */
	EClass getMultiplicityLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.MultiplicityLabel#getPropertyEdge <em>Property Edge</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Property Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.MultiplicityLabel#getPropertyEdge()
	 * @see #getMultiplicityLabel()
	 * @generated
	 */
	EReference getMultiplicityLabel_PropertyEdge();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.MultiplicityLabel#getConnectorEdge
	 * <em>Connector Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Connector Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.MultiplicityLabel#getConnectorEdge()
	 * @see #getMultiplicityLabel()
	 * @generated
	 */
	EReference getMultiplicityLabel_ConnectorEdge();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.MultiplicityLabel#getAssociationEdge
	 * <em>Association Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Association Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.MultiplicityLabel#getAssociationEdge()
	 * @see #getMultiplicityLabel()
	 * @generated
	 */
	EReference getMultiplicityLabel_AssociationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PropertyEdge <em>Property Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Property Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.PropertyEdge
	 * @generated
	 */
	EClass getPropertyEdge();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.PropertyEdge#getConstraintLabel
	 * <em>Constraint Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Constraint Label</em>'.
	 * @see org.eclipse.papyrus.umldi.PropertyEdge#getConstraintLabel()
	 * @see #getPropertyEdge()
	 * @generated
	 */
	EReference getPropertyEdge_ConstraintLabel();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.PropertyEdge#getMultiplicityLabel
	 * <em>Multiplicity Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Multiplicity Label</em>'.
	 * @see org.eclipse.papyrus.umldi.PropertyEdge#getMultiplicityLabel()
	 * @see #getPropertyEdge()
	 * @generated
	 */
	EReference getPropertyEdge_MultiplicityLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ConstraintLabel <em>Constraint Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Constraint Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintLabel
	 * @generated
	 */
	EClass getConstraintLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConstraintLabel#getAssociationEdge
	 * <em>Association Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Association Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintLabel#getAssociationEdge()
	 * @see #getConstraintLabel()
	 * @generated
	 */
	EReference getConstraintLabel_AssociationEdge();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConstraintLabel#getGeneralizationSetEdge
	 * <em>Generalization Set Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Generalization Set Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintLabel#getGeneralizationSetEdge()
	 * @see #getConstraintLabel()
	 * @generated
	 */
	EReference getConstraintLabel_GeneralizationSetEdge();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConstraintLabel#getObjectNodeShape
	 * <em>Object Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Object Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintLabel#getObjectNodeShape()
	 * @see #getConstraintLabel()
	 * @generated
	 */
	EReference getConstraintLabel_ObjectNodeShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConstraintLabel#getLifelineShape <em>Lifeline Shape</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Lifeline Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintLabel#getLifelineShape()
	 * @see #getConstraintLabel()
	 * @generated
	 */
	EReference getConstraintLabel_LifelineShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConstraintLabel#getActionShape <em>Action Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Action Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintLabel#getActionShape()
	 * @see #getConstraintLabel()
	 * @generated
	 */
	EReference getConstraintLabel_ActionShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConstraintLabel#getPropertyEdge <em>Property Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Property Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ConstraintLabel#getPropertyEdge()
	 * @see #getConstraintLabel()
	 * @generated
	 */
	EReference getConstraintLabel_PropertyEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.GeneralizationSetEdge <em>Generalization Set Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Generalization Set Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.GeneralizationSetEdge
	 * @generated
	 */
	EClass getGeneralizationSetEdge();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.GeneralizationSetEdge#getPowerLabel
	 * <em>Power Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Power Label</em>'.
	 * @see org.eclipse.papyrus.umldi.GeneralizationSetEdge#getPowerLabel()
	 * @see #getGeneralizationSetEdge()
	 * @generated
	 */
	EReference getGeneralizationSetEdge_PowerLabel();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.GeneralizationSetEdge#getConstraintLabel
	 * <em>Constraint Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Constraint Label</em>'.
	 * @see org.eclipse.papyrus.umldi.GeneralizationSetEdge#getConstraintLabel()
	 * @see #getGeneralizationSetEdge()
	 * @generated
	 */
	EReference getGeneralizationSetEdge_ConstraintLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PowerLabel <em>Power Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Power Label</em>'.
	 * @see org.eclipse.papyrus.umldi.PowerLabel
	 * @generated
	 */
	EClass getPowerLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.PowerLabel#getGeneralizationSetEdge
	 * <em>Generalization Set Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Generalization Set Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.PowerLabel#getGeneralizationSetEdge()
	 * @see #getPowerLabel()
	 * @generated
	 */
	EReference getPowerLabel_GeneralizationSetEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ObjectNodeShape <em>Object Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Object Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ObjectNodeShape
	 * @generated
	 */
	EClass getObjectNodeShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ObjectNodeShape#getSelectionLabel
	 * <em>Selection Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Selection Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ObjectNodeShape#getSelectionLabel()
	 * @see #getObjectNodeShape()
	 * @generated
	 */
	EReference getObjectNodeShape_SelectionLabel();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ObjectNodeShape#getConstraintLabel
	 * <em>Constraint Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Constraint Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ObjectNodeShape#getConstraintLabel()
	 * @see #getObjectNodeShape()
	 * @generated
	 */
	EReference getObjectNodeShape_ConstraintLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityNodeShape <em>Activity Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityNodeShape
	 * @generated
	 */
	EClass getActivityNodeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SelectionLabel <em>Selection Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Selection Label</em>'.
	 * @see org.eclipse.papyrus.umldi.SelectionLabel
	 * @generated
	 */
	EClass getSelectionLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.SelectionLabel#getObjectFlowEdge
	 * <em>Object Flow Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Object Flow Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.SelectionLabel#getObjectFlowEdge()
	 * @see #getSelectionLabel()
	 * @generated
	 */
	EReference getSelectionLabel_ObjectFlowEdge();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.SelectionLabel#getObjectNodeShape
	 * <em>Object Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Object Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.SelectionLabel#getObjectNodeShape()
	 * @see #getSelectionLabel()
	 * @generated
	 */
	EReference getSelectionLabel_ObjectNodeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ObjectFlowEdge <em>Object Flow Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Object Flow Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ObjectFlowEdge
	 * @generated
	 */
	EClass getObjectFlowEdge();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ObjectFlowEdge#getTransformationLabel
	 * <em>Transformation Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Transformation Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ObjectFlowEdge#getTransformationLabel()
	 * @see #getObjectFlowEdge()
	 * @generated
	 */
	EReference getObjectFlowEdge_TransformationLabel();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ObjectFlowEdge#getSelectionLabel
	 * <em>Selection Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Selection Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ObjectFlowEdge#getSelectionLabel()
	 * @see #getObjectFlowEdge()
	 * @generated
	 */
	EReference getObjectFlowEdge_SelectionLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityEdgeEdge <em>Activity Edge Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Edge Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityEdgeEdge
	 * @generated
	 */
	EClass getActivityEdgeEdge();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ActivityEdgeEdge#getGuardLabel <em>Guard Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Guard Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityEdgeEdge#getGuardLabel()
	 * @see #getActivityEdgeEdge()
	 * @generated
	 */
	EReference getActivityEdgeEdge_GuardLabel();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ActivityEdgeEdge#getWeightLabel <em>Weight Label</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Weight Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityEdgeEdge#getWeightLabel()
	 * @see #getActivityEdgeEdge()
	 * @generated
	 */
	EReference getActivityEdgeEdge_WeightLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.GuardLabel <em>Guard Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Guard Label</em>'.
	 * @see org.eclipse.papyrus.umldi.GuardLabel
	 * @generated
	 */
	EClass getGuardLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.GuardLabel#getActivityEdgeEdge
	 * <em>Activity Edge Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity Edge Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.GuardLabel#getActivityEdgeEdge()
	 * @see #getGuardLabel()
	 * @generated
	 */
	EReference getGuardLabel_ActivityEdgeEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.WeightLabel <em>Weight Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Weight Label</em>'.
	 * @see org.eclipse.papyrus.umldi.WeightLabel
	 * @generated
	 */
	EClass getWeightLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.WeightLabel#getActivityEdgeEdge
	 * <em>Activity Edge Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity Edge Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.WeightLabel#getActivityEdgeEdge()
	 * @see #getWeightLabel()
	 * @generated
	 */
	EReference getWeightLabel_ActivityEdgeEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TransformationLabel <em>Transformation Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Transformation Label</em>'.
	 * @see org.eclipse.papyrus.umldi.TransformationLabel
	 * @generated
	 */
	EClass getTransformationLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.TransformationLabel#getObjectFlowEdge
	 * <em>Object Flow Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Object Flow Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.TransformationLabel#getObjectFlowEdge()
	 * @see #getTransformationLabel()
	 * @generated
	 */
	EReference getTransformationLabel_ObjectFlowEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ConnectorEdge <em>Connector Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Connector Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ConnectorEdge
	 * @generated
	 */
	EClass getConnectorEdge();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.ConnectorEdge#getEndMultiplicityLabel
	 * <em>End Multiplicity Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>End Multiplicity Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ConnectorEdge#getEndMultiplicityLabel()
	 * @see #getConnectorEdge()
	 * @generated
	 */
	EReference getConnectorEdge_EndMultiplicityLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InstanceSpecificationEdge <em>Instance Specification Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Instance Specification Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.InstanceSpecificationEdge
	 * @generated
	 */
	EClass getInstanceSpecificationEdge();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.InstanceSpecificationEdge#getEndRoleLabel
	 * <em>End Role Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>End Role Label</em>'.
	 * @see org.eclipse.papyrus.umldi.InstanceSpecificationEdge#getEndRoleLabel()
	 * @see #getInstanceSpecificationEdge()
	 * @generated
	 */
	EReference getInstanceSpecificationEdge_EndRoleLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DependencyEdge <em>Dependency Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dependency Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.DependencyEdge
	 * @generated
	 */
	EClass getDependencyEdge();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.DependencyEdge#getRoleLabel <em>Role Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Role Label</em>'.
	 * @see org.eclipse.papyrus.umldi.DependencyEdge#getRoleLabel()
	 * @see #getDependencyEdge()
	 * @generated
	 */
	EReference getDependencyEdge_RoleLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InstanceSpecificationShape <em>Instance Specification Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Instance Specification Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InstanceSpecificationShape
	 * @generated
	 */
	EClass getInstanceSpecificationShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.InstanceSpecificationShape#getSlotCompartment
	 * <em>Slot Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Slot Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.InstanceSpecificationShape#getSlotCompartment()
	 * @see #getInstanceSpecificationShape()
	 * @generated
	 */
	EReference getInstanceSpecificationShape_SlotCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DeploymentTargetShape <em>Deployment Target Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Deployment Target Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DeploymentTargetShape
	 * @generated
	 */
	EClass getDeploymentTargetShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.DeploymentTargetShape#getDeployedArtifactCompartment
	 * <em>Deployed Artifact Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Deployed Artifact Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.DeploymentTargetShape#getDeployedArtifactCompartment()
	 * @see #getDeploymentTargetShape()
	 * @generated
	 */
	EReference getDeploymentTargetShape_DeployedArtifactCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DeployedArtifactCompartment <em>Deployed Artifact Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Deployed Artifact Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.DeployedArtifactCompartment
	 * @generated
	 */
	EClass getDeployedArtifactCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.DeployedArtifactCompartment#getDeploymentTargetShape
	 * <em>Deployment Target Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Deployment Target Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DeployedArtifactCompartment#getDeploymentTargetShape()
	 * @see #getDeployedArtifactCompartment()
	 * @generated
	 */
	EReference getDeployedArtifactCompartment_DeploymentTargetShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SlotCompartment <em>Slot Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Slot Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.SlotCompartment
	 * @generated
	 */
	EClass getSlotCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.SlotCompartment#getInstanceSpecificationShape
	 * <em>Instance Specification Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Instance Specification Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.SlotCompartment#getInstanceSpecificationShape()
	 * @see #getSlotCompartment()
	 * @generated
	 */
	EReference getSlotCompartment_InstanceSpecificationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassShape <em>Class Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Class Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassShape
	 * @generated
	 */
	EClass getClassShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ElementWithPortsShape <em>Element With Ports Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Element With Ports Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithPortsShape
	 * @generated
	 */
	EClass getElementWithPortsShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.ElementWithPortsShape#getPortShape
	 * <em>Port Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Port Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithPortsShape#getPortShape()
	 * @see #getElementWithPortsShape()
	 * @generated
	 */
	EReference getElementWithPortsShape_PortShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ElementWithStructureShape <em>Element With Structure Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Element With Structure Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithStructureShape
	 * @generated
	 */
	EClass getElementWithStructureShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ElementWithStructureShape#getStructureCompartment
	 * <em>Structure Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Structure Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithStructureShape#getStructureCompartment()
	 * @see #getElementWithStructureShape()
	 * @generated
	 */
	EReference getElementWithStructureShape_StructureCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StructureCompartment <em>Structure Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Structure Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.StructureCompartment
	 * @generated
	 */
	EClass getStructureCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.StructureCompartment#getElementWithStructureShape
	 * <em>Element With Structure Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Element With Structure Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StructureCompartment#getElementWithStructureShape()
	 * @see #getStructureCompartment()
	 * @generated
	 */
	EReference getStructureCompartment_ElementWithStructureShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PortShape <em>Port Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Port Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PortShape
	 * @generated
	 */
	EClass getPortShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.PortShape#getElementWithPortsShape
	 * <em>Element With Ports Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Element With Ports Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PortShape#getElementWithPortsShape()
	 * @see #getPortShape()
	 * @generated
	 */
	EReference getPortShape_ElementWithPortsShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ClassifierWithNestedClassifiersShape
	 * <em>Classifier With Nested Classifiers Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Classifier With Nested Classifiers Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithNestedClassifiersShape
	 * @generated
	 */
	EClass getClassifierWithNestedClassifiersShape();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link org.eclipse.papyrus.umldi.ClassifierWithNestedClassifiersShape#getNestedClassifierCompartment <em>Nested Classifier Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Nested Classifier Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ClassifierWithNestedClassifiersShape#getNestedClassifierCompartment()
	 * @see #getClassifierWithNestedClassifiersShape()
	 * @generated
	 */
	EReference getClassifierWithNestedClassifiersShape_NestedClassifierCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.NestedClassifierCompartment <em>Nested Classifier Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Nested Classifier Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.NestedClassifierCompartment
	 * @generated
	 */
	EClass getNestedClassifierCompartment();

	/**
	 * Returns the meta object for the container reference '
	 * {@link org.eclipse.papyrus.umldi.NestedClassifierCompartment#getClassifierWithNestedClassifiersShape
	 * <em>Classifier With Nested Classifiers Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Classifier With Nested Classifiers Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.NestedClassifierCompartment#getClassifierWithNestedClassifiersShape()
	 * @see #getNestedClassifierCompartment()
	 * @generated
	 */
	EReference getNestedClassifierCompartment_ClassifierWithNestedClassifiersShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.BehavioredClassifierShape <em>Behaviored Classifier Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Behaviored Classifier Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.BehavioredClassifierShape
	 * @generated
	 */
	EClass getBehavioredClassifierShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.BehavioredClassifierShape#getOwnedBehaviorCompartment
	 * <em>Owned Behavior Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Owned Behavior Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.BehavioredClassifierShape#getOwnedBehaviorCompartment()
	 * @see #getBehavioredClassifierShape()
	 * @generated
	 */
	EReference getBehavioredClassifierShape_OwnedBehaviorCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.OwnedBehaviorCompartment <em>Owned Behavior Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Owned Behavior Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.OwnedBehaviorCompartment
	 * @generated
	 */
	EClass getOwnedBehaviorCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.OwnedBehaviorCompartment#getBehavioredClassifierShape
	 * <em>Behaviored Classifier Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Behaviored Classifier Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.OwnedBehaviorCompartment#getBehavioredClassifierShape()
	 * @see #getOwnedBehaviorCompartment()
	 * @generated
	 */
	EReference getOwnedBehaviorCompartment_BehavioredClassifierShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InterfaceShape <em>Interface Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interface Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InterfaceShape
	 * @generated
	 */
	EClass getInterfaceShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DataTypeShape <em>Data Type Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Data Type Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DataTypeShape
	 * @generated
	 */
	EClass getDataTypeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PrimitiveTypeShape <em>Primitive Type Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Primitive Type Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PrimitiveTypeShape
	 * @generated
	 */
	EClass getPrimitiveTypeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SignalShape <em>Signal Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Signal Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.SignalShape
	 * @generated
	 */
	EClass getSignalShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ModelShape <em>Model Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Model Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ModelShape
	 * @generated
	 */
	EClass getModelShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ContainmentEdge <em>Containment Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Containment Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ContainmentEdge
	 * @generated
	 */
	EClass getContainmentEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.GeneralizationEdge <em>Generalization Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Generalization Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.GeneralizationEdge
	 * @generated
	 */
	EClass getGeneralizationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.RealizationEdge <em>Realization Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Realization Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.RealizationEdge
	 * @generated
	 */
	EClass getRealizationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.AbstractionEdge <em>Abstraction Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Abstraction Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.AbstractionEdge
	 * @generated
	 */
	EClass getAbstractionEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InterfaceRealizationEdge <em>Interface Realization Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interface Realization Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.InterfaceRealizationEdge
	 * @generated
	 */
	EClass getInterfaceRealizationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UsageEdge <em>Usage Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Usage Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.UsageEdge
	 * @generated
	 */
	EClass getUsageEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ElementImportEdge <em>Element Import Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Element Import Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementImportEdge
	 * @generated
	 */
	EClass getElementImportEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PackageImportEdge <em>Package Import Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Package Import Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.PackageImportEdge
	 * @generated
	 */
	EClass getPackageImportEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PackageMergeEdge <em>Package Merge Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Package Merge Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.PackageMergeEdge
	 * @generated
	 */
	EClass getPackageMergeEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SubstitutionEdge <em>Substitution Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Substitution Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.SubstitutionEdge
	 * @generated
	 */
	EClass getSubstitutionEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InformationFlowEdge <em>Information Flow Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Information Flow Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.InformationFlowEdge
	 * @generated
	 */
	EClass getInformationFlowEdge();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.InformationFlowEdge#getConveyedLabel
	 * <em>Conveyed Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Conveyed Label</em>'.
	 * @see org.eclipse.papyrus.umldi.InformationFlowEdge#getConveyedLabel()
	 * @see #getInformationFlowEdge()
	 * @generated
	 */
	EReference getInformationFlowEdge_ConveyedLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ConveyedLabel <em>Conveyed Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Conveyed Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ConveyedLabel
	 * @generated
	 */
	EClass getConveyedLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConveyedLabel#getInformationFlowEdge
	 * <em>Information Flow Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Information Flow Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ConveyedLabel#getInformationFlowEdge()
	 * @see #getConveyedLabel()
	 * @generated
	 */
	EReference getConveyedLabel_InformationFlowEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.AssociationClassEdge <em>Association Class Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Association Class Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.AssociationClassEdge
	 * @generated
	 */
	EClass getAssociationClassEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.CommentShape <em>Comment Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Comment Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.CommentShape
	 * @generated
	 */
	EClass getCommentShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.AttachmentEdge <em>Attachment Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Attachment Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.AttachmentEdge
	 * @generated
	 */
	EClass getAttachmentEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.AssociationClassShape <em>Association Class Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Association Class Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.AssociationClassShape
	 * @generated
	 */
	EClass getAssociationClassShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ComponentShape <em>Component Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Component Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ComponentShape
	 * @generated
	 */
	EClass getComponentShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InformationItemShape <em>Information Item Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Information Item Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InformationItemShape
	 * @generated
	 */
	EClass getInformationItemShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.RepresentationEdge <em>Representation Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Representation Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.RepresentationEdge
	 * @generated
	 */
	EClass getRepresentationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.AssociationShape <em>Association Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Association Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.AssociationShape
	 * @generated
	 */
	EClass getAssociationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DependencyShape <em>Dependency Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Dependency Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DependencyShape
	 * @generated
	 */
	EClass getDependencyShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TimeObservationShape <em>Time Observation Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Time Observation Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.TimeObservationShape
	 * @generated
	 */
	EClass getTimeObservationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TimeObservationShape_TimeObservationShape
	 * <em>Time Observation Shape Time Observation Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Time Observation Shape Time Observation Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.TimeObservationShape_TimeObservationShape
	 * @generated
	 */
	EClass getTimeObservationShape_TimeObservationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DurationObservationShape <em>Duration Observation Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Duration Observation Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DurationObservationShape
	 * @generated
	 */
	EClass getDurationObservationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PackageDiagram <em>Package Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Package Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.PackageDiagram
	 * @generated
	 */
	EClass getPackageDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ProfileDiagram <em>Profile Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Profile Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.ProfileDiagram
	 * @generated
	 */
	EClass getProfileDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.CompositeStructureDiagram <em>Composite Structure Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Composite Structure Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.CompositeStructureDiagram
	 * @generated
	 */
	EClass getCompositeStructureDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DeploymentDiagram <em>Deployment Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Deployment Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.DeploymentDiagram
	 * @generated
	 */
	EClass getDeploymentDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ComponentDiagram <em>Component Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Component Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.ComponentDiagram
	 * @generated
	 */
	EClass getComponentDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ObjectDiagram <em>Object Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Object Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.ObjectDiagram
	 * @generated
	 */
	EClass getObjectDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ProfileShape <em>Profile Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Profile Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ProfileShape
	 * @generated
	 */
	EClass getProfileShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ProfileApplicationEdge <em>Profile Application Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Profile Application Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ProfileApplicationEdge
	 * @generated
	 */
	EClass getProfileApplicationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExtensionEdge <em>Extension Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Extension Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ExtensionEdge
	 * @generated
	 */
	EClass getExtensionEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.BehaviorDiagram <em>Behavior Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Behavior Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.BehaviorDiagram
	 * @generated
	 */
	EClass getBehaviorDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UseCaseDiagram <em>Use Case Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Use Case Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.UseCaseDiagram
	 * @generated
	 */
	EClass getUseCaseDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ArtifactShape <em>Artifact Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Artifact Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ArtifactShape
	 * @generated
	 */
	EClass getArtifactShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ArtifactShape#getNestedArtifactCompartment
	 * <em>Nested Artifact Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Nested Artifact Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ArtifactShape#getNestedArtifactCompartment()
	 * @see #getArtifactShape()
	 * @generated
	 */
	EReference getArtifactShape_NestedArtifactCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.NestedArtifactCompartment <em>Nested Artifact Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Nested Artifact Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.NestedArtifactCompartment
	 * @generated
	 */
	EClass getNestedArtifactCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.NestedArtifactCompartment#getArtifactShape
	 * <em>Artifact Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Artifact Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.NestedArtifactCompartment#getArtifactShape()
	 * @see #getNestedArtifactCompartment()
	 * @generated
	 */
	EReference getNestedArtifactCompartment_ArtifactShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ComponentRealizationEdge <em>Component Realization Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Component Realization Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ComponentRealizationEdge
	 * @generated
	 */
	EClass getComponentRealizationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ManifestationEdge <em>Manifestation Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Manifestation Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ManifestationEdge
	 * @generated
	 */
	EClass getManifestationEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PropertyShape <em>Property Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Property Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PropertyShape
	 * @generated
	 */
	EClass getPropertyShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.CollaborationShape <em>Collaboration Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Collaboration Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.CollaborationShape
	 * @generated
	 */
	EClass getCollaborationShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.CollaborationShape#getReceptionCompartment
	 * <em>Reception Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Reception Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.CollaborationShape#getReceptionCompartment()
	 * @see #getCollaborationShape()
	 * @generated
	 */
	EReference getCollaborationShape_ReceptionCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.CollaborationUseShape <em>Collaboration Use Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Collaboration Use Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.CollaborationUseShape
	 * @generated
	 */
	EClass getCollaborationUseShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TemplateBindingEdge <em>Template Binding Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Template Binding Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.TemplateBindingEdge
	 * @generated
	 */
	EClass getTemplateBindingEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StereotypeShape <em>Stereotype Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Stereotype Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StereotypeShape
	 * @generated
	 */
	EClass getStereotypeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.NodeShape <em>Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.NodeShape
	 * @generated
	 */
	EClass getNodeShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.NodeShape#getNestedNodeCompartment
	 * <em>Nested Node Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Nested Node Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.NodeShape#getNestedNodeCompartment()
	 * @see #getNodeShape()
	 * @generated
	 */
	EReference getNodeShape_NestedNodeCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.NestedNodeCompartment <em>Nested Node Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Nested Node Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.NestedNodeCompartment
	 * @generated
	 */
	EClass getNestedNodeCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.NestedNodeCompartment#getNodeShape <em>Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.NestedNodeCompartment#getNodeShape()
	 * @see #getNestedNodeCompartment()
	 * @generated
	 */
	EReference getNestedNodeCompartment_NodeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DeviceShape <em>Device Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Device Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DeviceShape
	 * @generated
	 */
	EClass getDeviceShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExecutionEnvironmentShape <em>Execution Environment Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Execution Environment Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ExecutionEnvironmentShape
	 * @generated
	 */
	EClass getExecutionEnvironmentShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityShape <em>Activity Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityShape
	 * @generated
	 */
	EClass getActivityShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ActivityShape#getParameterCompartment
	 * <em>Parameter Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Parameter Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityShape#getParameterCompartment()
	 * @see #getActivityShape()
	 * @generated
	 */
	EReference getActivityShape_ParameterCompartment();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ActivityShape#getPostConditionCompartment
	 * <em>Post Condition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Post Condition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityShape#getPostConditionCompartment()
	 * @see #getActivityShape()
	 * @generated
	 */
	EReference getActivityShape_PostConditionCompartment();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ActivityShape#getPreConditionCompartment
	 * <em>Pre Condition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Pre Condition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityShape#getPreConditionCompartment()
	 * @see #getActivityShape()
	 * @generated
	 */
	EReference getActivityShape_PreConditionCompartment();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.ActivityShape#getActivityParameterNodeShape
	 * <em>Activity Parameter Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Activity Parameter Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityShape#getActivityParameterNodeShape()
	 * @see #getActivityShape()
	 * @generated
	 */
	EReference getActivityShape_ActivityParameterNodeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ElementWithActivityNodesShape <em>Element With Activity Nodes Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Element With Activity Nodes Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithActivityNodesShape
	 * @generated
	 */
	EClass getElementWithActivityNodesShape();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link org.eclipse.papyrus.umldi.ElementWithActivityNodesShape#getActivityNodeCompartment <em>Activity Node Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Activity Node Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ElementWithActivityNodesShape#getActivityNodeCompartment()
	 * @see #getElementWithActivityNodesShape()
	 * @generated
	 */
	EReference getElementWithActivityNodesShape_ActivityNodeCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityNodeCompartment <em>Activity Node Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Node Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityNodeCompartment
	 * @generated
	 */
	EClass getActivityNodeCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ActivityNodeCompartment#getElementWithActivityNodesShape
	 * <em>Element With Activity Nodes Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Element With Activity Nodes Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityNodeCompartment#getElementWithActivityNodesShape()
	 * @see #getActivityNodeCompartment()
	 * @generated
	 */
	EReference getActivityNodeCompartment_ElementWithActivityNodesShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ParameterCompartment <em>Parameter Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Parameter Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ParameterCompartment
	 * @generated
	 */
	EClass getParameterCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ParameterCompartment#getActivityShape
	 * <em>Activity Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ParameterCompartment#getActivityShape()
	 * @see #getParameterCompartment()
	 * @generated
	 */
	EReference getParameterCompartment_ActivityShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PostConditionCompartment <em>Post Condition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Post Condition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.PostConditionCompartment
	 * @generated
	 */
	EClass getPostConditionCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.PostConditionCompartment#getActivityShape
	 * <em>Activity Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PostConditionCompartment#getActivityShape()
	 * @see #getPostConditionCompartment()
	 * @generated
	 */
	EReference getPostConditionCompartment_ActivityShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PreConditionCompartment <em>Pre Condition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Pre Condition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.PreConditionCompartment
	 * @generated
	 */
	EClass getPreConditionCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.PreConditionCompartment#getActivityShape
	 * <em>Activity Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PreConditionCompartment#getActivityShape()
	 * @see #getPreConditionCompartment()
	 * @generated
	 */
	EReference getPreConditionCompartment_ActivityShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityParameterNodeShape <em>Activity Parameter Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Parameter Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityParameterNodeShape
	 * @generated
	 */
	EClass getActivityParameterNodeShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ActivityParameterNodeShape#getActivityShape
	 * <em>Activity Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityParameterNodeShape#getActivityShape()
	 * @see #getActivityParameterNodeShape()
	 * @generated
	 */
	EReference getActivityParameterNodeShape_ActivityShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionShape <em>Interaction Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionShape
	 * @generated
	 */
	EClass getInteractionShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionFragmentWithSubfragmentsShape
	 * <em>Interaction Fragment With Subfragments Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Fragment With Subfragments Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionFragmentWithSubfragmentsShape
	 * @generated
	 */
	EClass getInteractionFragmentWithSubfragmentsShape();

	/**
	 * Returns the meta object for the containment reference '
	 * {@link org.eclipse.papyrus.umldi.InteractionFragmentWithSubfragmentsShape#getSubfragmentCompartment <em>Subfragment Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Subfragment Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionFragmentWithSubfragmentsShape#getSubfragmentCompartment()
	 * @see #getInteractionFragmentWithSubfragmentsShape()
	 * @generated
	 */
	EReference getInteractionFragmentWithSubfragmentsShape_SubfragmentCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionFragmentShape <em>Interaction Fragment Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Fragment Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionFragmentShape
	 * @generated
	 */
	EClass getInteractionFragmentShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.InteractionFragmentShape#getLifelineShape
	 * <em>Lifeline Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Lifeline Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionFragmentShape#getLifelineShape()
	 * @see #getInteractionFragmentShape()
	 * @generated
	 */
	EReference getInteractionFragmentShape_LifelineShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SubfragmentCompartment <em>Subfragment Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Subfragment Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.SubfragmentCompartment
	 * @generated
	 */
	EClass getSubfragmentCompartment();

	/**
	 * Returns the meta object for the container reference '
	 * {@link org.eclipse.papyrus.umldi.SubfragmentCompartment#getInteractionFragmentWithSubfragmentsShape
	 * <em>Interaction Fragment With Subfragments Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interaction Fragment With Subfragments Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.SubfragmentCompartment#getInteractionFragmentWithSubfragmentsShape()
	 * @see #getSubfragmentCompartment()
	 * @generated
	 */
	EReference getSubfragmentCompartment_InteractionFragmentWithSubfragmentsShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionFragmentWithGatesShape
	 * <em>Interaction Fragment With Gates Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Fragment With Gates Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionFragmentWithGatesShape
	 * @generated
	 */
	EClass getInteractionFragmentWithGatesShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.InteractionFragmentWithGatesShape#getGateShape
	 * <em>Gate Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Gate Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionFragmentWithGatesShape#getGateShape()
	 * @see #getInteractionFragmentWithGatesShape()
	 * @generated
	 */
	EReference getInteractionFragmentWithGatesShape_GateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.GateShape <em>Gate Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Gate Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.GateShape
	 * @generated
	 */
	EClass getGateShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.GateShape#getInteractionFragmentWithGatesShape
	 * <em>Interaction Fragment With Gates Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interaction Fragment With Gates Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.GateShape#getInteractionFragmentWithGatesShape()
	 * @see #getGateShape()
	 * @generated
	 */
	EReference getGateShape_InteractionFragmentWithGatesShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.OpaqueBehaviorShape <em>Opaque Behavior Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Opaque Behavior Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.OpaqueBehaviorShape
	 * @generated
	 */
	EClass getOpaqueBehaviorShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.FunctionBehaviorShape <em>Function Behavior Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Function Behavior Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.FunctionBehaviorShape
	 * @generated
	 */
	EClass getFunctionBehaviorShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StateMachineShape <em>State Machine Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>State Machine Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StateMachineShape
	 * @generated
	 */
	EClass getStateMachineShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.BaseStateShape <em>Base State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Base State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.BaseStateShape
	 * @generated
	 */
	EClass getBaseStateShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.BaseStateShape#getConnectionPointShape
	 * <em>Connection Point Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Connection Point Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.BaseStateShape#getConnectionPointShape()
	 * @see #getBaseStateShape()
	 * @generated
	 */
	EReference getBaseStateShape_ConnectionPointShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.BaseStateShape#getRegionCompartment
	 * <em>Region Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Region Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.BaseStateShape#getRegionCompartment()
	 * @see #getBaseStateShape()
	 * @generated
	 */
	EReference getBaseStateShape_RegionCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PseudostateShape <em>Pseudostate Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Pseudostate Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PseudostateShape
	 * @generated
	 */
	EClass getPseudostateShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.PseudostateShape#getBaseStateShape
	 * <em>Base State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Base State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PseudostateShape#getBaseStateShape()
	 * @see #getPseudostateShape()
	 * @generated
	 */
	EReference getPseudostateShape_BaseStateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.RegionCompartment <em>Region Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Region Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.RegionCompartment
	 * @generated
	 */
	EClass getRegionCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.RegionCompartment#getBaseStateShape
	 * <em>Base State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Base State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.RegionCompartment#getBaseStateShape()
	 * @see #getRegionCompartment()
	 * @generated
	 */
	EReference getRegionCompartment_BaseStateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ProtocolStateMachineShape <em>Protocol State Machine Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Protocol State Machine Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ProtocolStateMachineShape
	 * @generated
	 */
	EClass getProtocolStateMachineShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DeploymentSpecificationShape <em>Deployment Specification Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Deployment Specification Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DeploymentSpecificationShape
	 * @generated
	 */
	EClass getDeploymentSpecificationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.CommunicationPathEdge <em>Communication Path Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Communication Path Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.CommunicationPathEdge
	 * @generated
	 */
	EClass getCommunicationPathEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DeploymentEdge <em>Deployment Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Deployment Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.DeploymentEdge
	 * @generated
	 */
	EClass getDeploymentEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActorShape <em>Actor Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Actor Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActorShape
	 * @generated
	 */
	EClass getActorShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExtensionPointCompartment <em>Extension Point Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Extension Point Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ExtensionPointCompartment
	 * @generated
	 */
	EClass getExtensionPointCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ExtensionPointCompartment#getUseCaseShape
	 * <em>Use Case Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Use Case Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ExtensionPointCompartment#getUseCaseShape()
	 * @see #getExtensionPointCompartment()
	 * @generated
	 */
	EReference getExtensionPointCompartment_UseCaseShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.UseCaseShape <em>Use Case Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Use Case Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.UseCaseShape
	 * @generated
	 */
	EClass getUseCaseShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.UseCaseShape#getExtensionPointCompartment
	 * <em>Extension Point Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Extension Point Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.UseCaseShape#getExtensionPointCompartment()
	 * @see #getUseCaseShape()
	 * @generated
	 */
	EReference getUseCaseShape_ExtensionPointCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.IncludeEdge <em>Include Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Include Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.IncludeEdge
	 * @generated
	 */
	EClass getIncludeEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExtendEdge <em>Extend Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Extend Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ExtendEdge
	 * @generated
	 */
	EClass getExtendEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StateMachineDiagram <em>State Machine Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>State Machine Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.StateMachineDiagram
	 * @generated
	 */
	EClass getStateMachineDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityDiagram <em>Activity Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityDiagram
	 * @generated
	 */
	EClass getActivityDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SequenceDiagram <em>Sequence Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Sequence Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.SequenceDiagram
	 * @generated
	 */
	EClass getSequenceDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionDiagram <em>Interaction Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionDiagram
	 * @generated
	 */
	EClass getInteractionDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.CommunicationDiagram <em>Communication Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Communication Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.CommunicationDiagram
	 * @generated
	 */
	EClass getCommunicationDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TimingDiagram <em>Timing Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Timing Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.TimingDiagram
	 * @generated
	 */
	EClass getTimingDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionOverviewDiagram <em>Interaction Overview Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Overview Diagram</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionOverviewDiagram
	 * @generated
	 */
	EClass getInteractionOverviewDiagram();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InternalBehaviorCompartment <em>Internal Behavior Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Internal Behavior Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.InternalBehaviorCompartment
	 * @generated
	 */
	EClass getInternalBehaviorCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.InternalBehaviorCompartment#getStateShape
	 * <em>State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InternalBehaviorCompartment#getStateShape()
	 * @see #getInternalBehaviorCompartment()
	 * @generated
	 */
	EReference getInternalBehaviorCompartment_StateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StateShape <em>State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StateShape
	 * @generated
	 */
	EClass getStateShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.StateShape#getConnectionPointReferenceShape
	 * <em>Connection Point Reference Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Connection Point Reference Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StateShape#getConnectionPointReferenceShape()
	 * @see #getStateShape()
	 * @generated
	 */
	EReference getStateShape_ConnectionPointReferenceShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.StateShape#getInternalTransitionCompartment
	 * <em>Internal Transition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Internal Transition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.StateShape#getInternalTransitionCompartment()
	 * @see #getStateShape()
	 * @generated
	 */
	EReference getStateShape_InternalTransitionCompartment();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.StateShape#getDeferrableTriggerCompartment
	 * <em>Deferrable Trigger Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Deferrable Trigger Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.StateShape#getDeferrableTriggerCompartment()
	 * @see #getStateShape()
	 * @generated
	 */
	EReference getStateShape_DeferrableTriggerCompartment();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.StateShape#getInternalBehaviorCompartment
	 * <em>Internal Behavior Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Internal Behavior Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.StateShape#getInternalBehaviorCompartment()
	 * @see #getStateShape()
	 * @generated
	 */
	EReference getStateShape_InternalBehaviorCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ConnectionPointReferenceShape <em>Connection Point Reference Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Connection Point Reference Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ConnectionPointReferenceShape
	 * @generated
	 */
	EClass getConnectionPointReferenceShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ConnectionPointReferenceShape#getStateShape
	 * <em>State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ConnectionPointReferenceShape#getStateShape()
	 * @see #getConnectionPointReferenceShape()
	 * @generated
	 */
	EReference getConnectionPointReferenceShape_StateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InternalTransitionCompartment <em>Internal Transition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Internal Transition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.InternalTransitionCompartment
	 * @generated
	 */
	EClass getInternalTransitionCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.InternalTransitionCompartment#getStateShape
	 * <em>State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InternalTransitionCompartment#getStateShape()
	 * @see #getInternalTransitionCompartment()
	 * @generated
	 */
	EReference getInternalTransitionCompartment_StateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DeferrableTriggerCompartment <em>Deferrable Trigger Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Deferrable Trigger Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.DeferrableTriggerCompartment
	 * @generated
	 */
	EClass getDeferrableTriggerCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.DeferrableTriggerCompartment#getStateShape
	 * <em>State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DeferrableTriggerCompartment#getStateShape()
	 * @see #getDeferrableTriggerCompartment()
	 * @generated
	 */
	EReference getDeferrableTriggerCompartment_StateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.RegionShape <em>Region Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Region Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.RegionShape
	 * @generated
	 */
	EClass getRegionShape();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.papyrus.umldi.RegionShape#getPlacement <em>Placement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute list '<em>Placement</em>'.
	 * @see org.eclipse.papyrus.umldi.RegionShape#getPlacement()
	 * @see #getRegionShape()
	 * @generated
	 */
	EAttribute getRegionShape_Placement();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.RegionShape#getSubvertexCompartment
	 * <em>Subvertex Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Subvertex Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.RegionShape#getSubvertexCompartment()
	 * @see #getRegionShape()
	 * @generated
	 */
	EReference getRegionShape_SubvertexCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SubvertexCompartment <em>Subvertex Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Subvertex Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.SubvertexCompartment
	 * @generated
	 */
	EClass getSubvertexCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.SubvertexCompartment#getRegionShape
	 * <em>Region Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Region Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.SubvertexCompartment#getRegionShape()
	 * @see #getSubvertexCompartment()
	 * @generated
	 */
	EReference getSubvertexCompartment_RegionShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TransitionEdge <em>Transition Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Transition Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.TransitionEdge
	 * @generated
	 */
	EClass getTransitionEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ControlFlowEdge <em>Control Flow Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Control Flow Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ControlFlowEdge
	 * @generated
	 */
	EClass getControlFlowEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityGroupShape <em>Activity Group Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Group Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityGroupShape
	 * @generated
	 */
	EClass getActivityGroupShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExceptionHandlerEdge <em>Exception Handler Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Exception Handler Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.ExceptionHandlerEdge
	 * @generated
	 */
	EClass getExceptionHandlerEdge();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ExceptionHandlerEdge#getTypeLabel <em>Type Label</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Type Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ExceptionHandlerEdge#getTypeLabel()
	 * @see #getExceptionHandlerEdge()
	 * @generated
	 */
	EReference getExceptionHandlerEdge_TypeLabel();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ExceptionHandlerEdge#getIconLabel <em>Icon Label</em>}
	 * '.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Icon Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ExceptionHandlerEdge#getIconLabel()
	 * @see #getExceptionHandlerEdge()
	 * @generated
	 */
	EReference getExceptionHandlerEdge_IconLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TypeLabel <em>Type Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Type Label</em>'.
	 * @see org.eclipse.papyrus.umldi.TypeLabel
	 * @generated
	 */
	EClass getTypeLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.TypeLabel#getInteractionUseShape
	 * <em>Interaction Use Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Interaction Use Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.TypeLabel#getInteractionUseShape()
	 * @see #getTypeLabel()
	 * @generated
	 */
	EReference getTypeLabel_InteractionUseShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.TypeLabel#getExceptionHandlerEdge
	 * <em>Exception Handler Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Exception Handler Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.TypeLabel#getExceptionHandlerEdge()
	 * @see #getTypeLabel()
	 * @generated
	 */
	EReference getTypeLabel_ExceptionHandlerEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.IconLabel <em>Icon Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Icon Label</em>'.
	 * @see org.eclipse.papyrus.umldi.IconLabel
	 * @generated
	 */
	EClass getIconLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.IconLabel#getExceptionHandlerEdge
	 * <em>Exception Handler Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Exception Handler Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.IconLabel#getExceptionHandlerEdge()
	 * @see #getIconLabel()
	 * @generated
	 */
	EReference getIconLabel_ExceptionHandlerEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActionShape <em>Action Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Action Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActionShape
	 * @generated
	 */
	EClass getActionShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.ActionShape#getPinShape <em>Pin Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Pin Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActionShape#getPinShape()
	 * @see #getActionShape()
	 * @generated
	 */
	EReference getActionShape_PinShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.ActionShape#getConditionLabel
	 * <em>Condition Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Condition Label</em>'.
	 * @see org.eclipse.papyrus.umldi.ActionShape#getConditionLabel()
	 * @see #getActionShape()
	 * @generated
	 */
	EReference getActionShape_ConditionLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PinShape <em>Pin Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Pin Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PinShape
	 * @generated
	 */
	EClass getPinShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.PinShape#getActionShape <em>Action Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Action Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.PinShape#getActionShape()
	 * @see #getPinShape()
	 * @generated
	 */
	EReference getPinShape_ActionShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.SubpartitionCompartment <em>Subpartition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Subpartition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.SubpartitionCompartment
	 * @generated
	 */
	EClass getSubpartitionCompartment();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.SubpartitionCompartment#getActivityPartitionShape
	 * <em>Activity Partition Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Activity Partition Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.SubpartitionCompartment#getActivityPartitionShape()
	 * @see #getSubpartitionCompartment()
	 * @generated
	 */
	EReference getSubpartitionCompartment_ActivityPartitionShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ActivityPartitionShape <em>Activity Partition Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Activity Partition Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityPartitionShape
	 * @generated
	 */
	EClass getActivityPartitionShape();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.papyrus.umldi.ActivityPartitionShape#isVertical <em>Is Vertical</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Is Vertical</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityPartitionShape#isVertical()
	 * @see #getActivityPartitionShape()
	 * @generated
	 */
	EAttribute getActivityPartitionShape_IsVertical();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.ActivityPartitionShape#getSubpartitionCompartment
	 * <em>Subpartition Compartment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Subpartition Compartment</em>'.
	 * @see org.eclipse.papyrus.umldi.ActivityPartitionShape#getSubpartitionCompartment()
	 * @see #getActivityPartitionShape()
	 * @generated
	 */
	EReference getActivityPartitionShape_SubpartitionCompartment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StructuredActivityNodeShape <em>Structured Activity Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Structured Activity Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StructuredActivityNodeShape
	 * @generated
	 */
	EClass getStructuredActivityNodeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExpansionRegionShape <em>Expansion Region Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Expansion Region Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ExpansionRegionShape
	 * @generated
	 */
	EClass getExpansionRegionShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.ExpansionRegionShape#getExpansionNodeShape
	 * <em>Expansion Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Expansion Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ExpansionRegionShape#getExpansionNodeShape()
	 * @see #getExpansionRegionShape()
	 * @generated
	 */
	EReference getExpansionRegionShape_ExpansionNodeShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExpansionNodeShape <em>Expansion Node Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Expansion Node Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ExpansionNodeShape
	 * @generated
	 */
	EClass getExpansionNodeShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.ExpansionNodeShape#getExpansionRegionShape
	 * <em>Expansion Region Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Expansion Region Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ExpansionNodeShape#getExpansionRegionShape()
	 * @see #getExpansionNodeShape()
	 * @generated
	 */
	EReference getExpansionNodeShape_ExpansionRegionShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.LifelineShape <em>Lifeline Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Lifeline Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.LifelineShape
	 * @generated
	 */
	EClass getLifelineShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.LifelineShape#getSubfragmentShape
	 * <em>Subfragment Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Subfragment Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.LifelineShape#getSubfragmentShape()
	 * @see #getLifelineShape()
	 * @generated
	 */
	EReference getLifelineShape_SubfragmentShape();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.LifelineShape#getNestingLifelineShape
	 * <em>Nesting Lifeline Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Nesting Lifeline Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.LifelineShape#getNestingLifelineShape()
	 * @see #getLifelineShape()
	 * @generated
	 */
	EReference getLifelineShape_NestingLifelineShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.LifelineShape#getNestedLifelineShape
	 * <em>Nested Lifeline Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Nested Lifeline Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.LifelineShape#getNestedLifelineShape()
	 * @see #getLifelineShape()
	 * @generated
	 */
	EReference getLifelineShape_NestedLifelineShape();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.LifelineShape#getConstraintLabel
	 * <em>Constraint Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Constraint Label</em>'.
	 * @see org.eclipse.papyrus.umldi.LifelineShape#getConstraintLabel()
	 * @see #getLifelineShape()
	 * @generated
	 */
	EReference getLifelineShape_ConstraintLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.ExecutionSpecificationShape <em>Execution Specification Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Execution Specification Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.ExecutionSpecificationShape
	 * @generated
	 */
	EClass getExecutionSpecificationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DurationConstraintShape <em>Duration Constraint Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Duration Constraint Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DurationConstraintShape
	 * @generated
	 */
	EClass getDurationConstraintShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TimeConstraintShape <em>Time Constraint Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Time Constraint Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.TimeConstraintShape
	 * @generated
	 */
	EClass getTimeConstraintShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.TimeExpressionShape <em>Time Expression Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Time Expression Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.TimeExpressionShape
	 * @generated
	 */
	EClass getTimeExpressionShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.DurationShape <em>Duration Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Duration Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.DurationShape
	 * @generated
	 */
	EClass getDurationShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.PathEdge <em>Path Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Path Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.PathEdge
	 * @generated
	 */
	EClass getPathEdge();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.papyrus.umldi.PathEdge#getMessageLabel <em>Message Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference list '<em>Message Label</em>'.
	 * @see org.eclipse.papyrus.umldi.PathEdge#getMessageLabel()
	 * @see #getPathEdge()
	 * @generated
	 */
	EReference getPathEdge_MessageLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.MessageLabel <em>Message Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Message Label</em>'.
	 * @see org.eclipse.papyrus.umldi.MessageLabel
	 * @generated
	 */
	EClass getMessageLabel();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.papyrus.umldi.MessageLabel#getPathEdge <em>Path Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the container reference '<em>Path Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.MessageLabel#getPathEdge()
	 * @see #getMessageLabel()
	 * @generated
	 */
	EReference getMessageLabel_PathEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.StateInvariantShape <em>State Invariant Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>State Invariant Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StateInvariantShape
	 * @generated
	 */
	EClass getStateInvariantShape();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.papyrus.umldi.StateInvariantShape#isUseStateShape <em>Use State Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the attribute '<em>Use State Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.StateInvariantShape#isUseStateShape()
	 * @see #getStateInvariantShape()
	 * @generated
	 */
	EAttribute getStateInvariantShape_UseStateShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.MessageEdge <em>Message Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Message Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.MessageEdge
	 * @generated
	 */
	EClass getMessageEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.GeneralOrderingEdge <em>General Ordering Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>General Ordering Edge</em>'.
	 * @see org.eclipse.papyrus.umldi.GeneralOrderingEdge
	 * @generated
	 */
	EClass getGeneralOrderingEdge();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.CombinedFragmentShape <em>Combined Fragment Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Combined Fragment Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.CombinedFragmentShape
	 * @generated
	 */
	EClass getCombinedFragmentShape();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionUseShape <em>Interaction Use Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Use Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionUseShape
	 * @generated
	 */
	EClass getInteractionUseShape();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.papyrus.umldi.InteractionUseShape#getTypeLabel <em>Type Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for the containment reference '<em>Type Label</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionUseShape#getTypeLabel()
	 * @see #getInteractionUseShape()
	 * @generated
	 */
	EReference getInteractionUseShape_TypeLabel();

	/**
	 * Returns the meta object for class '{@link org.eclipse.papyrus.umldi.InteractionOperandShape <em>Interaction Operand Shape</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for class '<em>Interaction Operand Shape</em>'.
	 * @see org.eclipse.papyrus.umldi.InteractionOperandShape
	 * @generated
	 */
	EClass getInteractionOperandShape();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.papyrus.umldi.CompartmentLayout <em>Compartment Layout</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Compartment Layout</em>'.
	 * @see org.eclipse.papyrus.umldi.CompartmentLayout
	 * @generated
	 */
	EEnum getCompartmentLayout();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.papyrus.umldi.Placement <em>Placement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the meta object for enum '<em>Placement</em>'.
	 * @see org.eclipse.papyrus.umldi.Placement
	 * @generated
	 */
	EEnum getPlacement();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	UMLDIFactory getUMLDIFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 * <li>each class,</li>
	 * <li>each feature of each class,</li>
	 * <li>each operation of each class,</li>
	 * <li>each enum,</li>
	 * <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	interface Literals {

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UmlDiagramImpl <em>Uml Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UmlDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlDiagram()
		 * @generated
		 */
		EClass UML_DIAGRAM = eINSTANCE.getUmlDiagram();

		/**
		 * The meta object literal for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM__TOP_UML_DIAGRAM_ELEMENT = eINSTANCE.getUmlDiagram_TopUmlDiagramElement();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UmlDiagramElementImpl <em>Uml Diagram Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UmlDiagramElementImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlDiagramElement()
		 * @generated
		 */
		EClass UML_DIAGRAM_ELEMENT = eINSTANCE.getUmlDiagramElement();

		/**
		 * The meta object literal for the '<em><b>Uml Model Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM_ELEMENT__UML_MODEL_ELEMENT = eINSTANCE.getUmlDiagramElement_UmlModelElement();

		/**
		 * The meta object literal for the '<em><b>Shared Uml Style</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM_ELEMENT__SHARED_UML_STYLE = eINSTANCE.getUmlDiagramElement_SharedUmlStyle();

		/**
		 * The meta object literal for the '<em><b>Local Uml Style</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM_ELEMENT__LOCAL_UML_STYLE = eINSTANCE.getUmlDiagramElement_LocalUmlStyle();

		/**
		 * The meta object literal for the '<em><b>Owned Uml Diagram Element</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM_ELEMENT__OWNED_UML_DIAGRAM_ELEMENT = eINSTANCE.getUmlDiagramElement_OwnedUmlDiagramElement();

		/**
		 * The meta object literal for the '<em><b>Owning Uml Diagram Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM_ELEMENT__OWNING_UML_DIAGRAM_ELEMENT = eINSTANCE.getUmlDiagramElement_OwningUmlDiagramElement();

		/**
		 * The meta object literal for the '<em><b>Target Uml Edge</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM_ELEMENT__TARGET_UML_EDGE = eINSTANCE.getUmlDiagramElement_TargetUmlEdge();

		/**
		 * The meta object literal for the '<em><b>Source Uml Edge</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_DIAGRAM_ELEMENT__SOURCE_UML_EDGE = eINSTANCE.getUmlDiagramElement_SourceUmlEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UmlStyleImpl <em>Uml Style</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UmlStyleImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlStyle()
		 * @generated
		 */
		EClass UML_STYLE = eINSTANCE.getUmlStyle();

		/**
		 * The meta object literal for the '<em><b>Font Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute UML_STYLE__FONT_NAME = eINSTANCE.getUmlStyle_FontName();

		/**
		 * The meta object literal for the '<em><b>Font Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute UML_STYLE__FONT_SIZE = eINSTANCE.getUmlStyle_FontSize();

		/**
		 * The meta object literal for the '<em><b>Fontsize Positive</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EOperation UML_STYLE___FONTSIZE_POSITIVE__DIAGNOSTICCHAIN_MAP = eINSTANCE.getUmlStyle__FontsizePositive__DiagnosticChain_Map();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UmlEdgeImpl <em>Uml Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UmlEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlEdge()
		 * @generated
		 */
		EClass UML_EDGE = eINSTANCE.getUmlEdge();

		/**
		 * The meta object literal for the '<em><b>Source Uml Diagram Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_EDGE__SOURCE_UML_DIAGRAM_ELEMENT = eINSTANCE.getUmlEdge_SourceUmlDiagramElement();

		/**
		 * The meta object literal for the '<em><b>Target Uml Diagram Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_EDGE__TARGET_UML_DIAGRAM_ELEMENT = eINSTANCE.getUmlEdge_TargetUmlDiagramElement();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TopUmlDiagramElementImpl <em>Top Uml Diagram Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TopUmlDiagramElementImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTopUmlDiagramElement()
		 * @generated
		 */
		EClass TOP_UML_DIAGRAM_ELEMENT = eINSTANCE.getTopUmlDiagramElement();

		/**
		 * The meta object literal for the '<em><b>Uml Diagram</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TOP_UML_DIAGRAM_ELEMENT__UML_DIAGRAM = eINSTANCE.getTopUmlDiagramElement_UmlDiagram();

		/**
		 * The meta object literal for the '<em><b>Diagram Compartment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TOP_UML_DIAGRAM_ELEMENT__DIAGRAM_COMPARTMENT = eINSTANCE.getTopUmlDiagramElement_DiagramCompartment();

		/**
		 * The meta object literal for the '<em><b>Main Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TOP_UML_DIAGRAM_ELEMENT__MAIN_LABEL = eINSTANCE.getTopUmlDiagramElement_MainLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StereotypedDiagramElementImpl <em>Stereotyped Diagram Element</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StereotypedDiagramElementImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypedDiagramElement()
		 * @generated
		 */
		EClass STEREOTYPED_DIAGRAM_ELEMENT = eINSTANCE.getStereotypedDiagramElement();

		/**
		 * The meta object literal for the '<em><b>Show Stereotype Attributes</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute STEREOTYPED_DIAGRAM_ELEMENT__SHOW_STEREOTYPE_ATTRIBUTES = eINSTANCE.getStereotypedDiagramElement_ShowStereotypeAttributes();

		/**
		 * The meta object literal for the '<em><b>Stereotype Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STEREOTYPED_DIAGRAM_ELEMENT__STEREOTYPE_LABEL = eINSTANCE.getStereotypedDiagramElement_StereotypeLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DiagramCompartmentImpl <em>Diagram Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DiagramCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDiagramCompartment()
		 * @generated
		 */
		EClass DIAGRAM_COMPARTMENT = eINSTANCE.getDiagramCompartment();

		/**
		 * The meta object literal for the '<em><b>Top Uml Diagram Element</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference DIAGRAM_COMPARTMENT__TOP_UML_DIAGRAM_ELEMENT = eINSTANCE.getDiagramCompartment_TopUmlDiagramElement();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UmlCompartmentImpl <em>Uml Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UmlCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlCompartment()
		 * @generated
		 */
		EClass UML_COMPARTMENT = eINSTANCE.getUmlCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.MainLabelImpl <em>Main Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.MainLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMainLabel()
		 * @generated
		 */
		EClass MAIN_LABEL = eINSTANCE.getMainLabel();

		/**
		 * The meta object literal for the '<em><b>Top Uml Diagram Element</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference MAIN_LABEL__TOP_UML_DIAGRAM_ELEMENT = eINSTANCE.getMainLabel_TopUmlDiagramElement();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UmlLabelImpl <em>Uml Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UmlLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlLabel()
		 * @generated
		 */
		EClass UML_LABEL = eINSTANCE.getUmlLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UmlShapeImpl <em>Uml Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UmlShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUmlShape()
		 * @generated
		 */
		EClass UML_SHAPE = eINSTANCE.getUmlShape();

		/**
		 * The meta object literal for the '<em><b>Stereotype Compartment</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference UML_SHAPE__STEREOTYPE_COMPARTMENT = eINSTANCE.getUmlShape_StereotypeCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassDiagramImpl <em>Class Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassDiagram()
		 * @generated
		 */
		EClass CLASS_DIAGRAM = eINSTANCE.getClassDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StructureDiagramImpl <em>Structure Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StructureDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStructureDiagram()
		 * @generated
		 */
		EClass STRUCTURE_DIAGRAM = eINSTANCE.getStructureDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierShapeImpl <em>Classifier Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassifierShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierShape()
		 * @generated
		 */
		EClass CLASSIFIER_SHAPE = eINSTANCE.getClassifierShape();

		/**
		 * The meta object literal for the '<em><b>Use Classifier Notation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute CLASSIFIER_SHAPE__USE_CLASSIFIER_NOTATION = eINSTANCE.getClassifierShape_UseClassifierNotation();

		/**
		 * The meta object literal for the '<em><b>Owned Use Case Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CLASSIFIER_SHAPE__OWNED_USE_CASE_COMPARTMENT = eINSTANCE.getClassifierShape_OwnedUseCaseCompartment();

		/**
		 * The meta object literal for the '<em><b>Use Case Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CLASSIFIER_SHAPE__USE_CASE_COMPARTMENT = eINSTANCE.getClassifierShape_UseCaseCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TemplateableElementShapeImpl <em>Templateable Element Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TemplateableElementShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTemplateableElementShape()
		 * @generated
		 */
		EClass TEMPLATEABLE_ELEMENT_SHAPE = eINSTANCE.getTemplateableElementShape();

		/**
		 * The meta object literal for the '<em><b>Template Parameter Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TEMPLATEABLE_ELEMENT_SHAPE__TEMPLATE_PARAMETER_COMPARTMENT = eINSTANCE.getTemplateableElementShape_TemplateParameterCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ElementShapeImpl <em>Element Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ElementShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementShape()
		 * @generated
		 */
		EClass ELEMENT_SHAPE = eINSTANCE.getElementShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StereotypeCompartmentImpl <em>Stereotype Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StereotypeCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypeCompartment()
		 * @generated
		 */
		EClass STEREOTYPE_COMPARTMENT = eINSTANCE.getStereotypeCompartment();

		/**
		 * The meta object literal for the '<em><b>Uml Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STEREOTYPE_COMPARTMENT__UML_SHAPE = eINSTANCE.getStereotypeCompartment_UmlShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TemplateParameterCompartmentImpl
		 * <em>Template Parameter Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TemplateParameterCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTemplateParameterCompartment()
		 * @generated
		 */
		EClass TEMPLATE_PARAMETER_COMPARTMENT = eINSTANCE.getTemplateParameterCompartment();

		/**
		 * The meta object literal for the '<em><b>Templateable Element Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TEMPLATE_PARAMETER_COMPARTMENT__TEMPLATEABLE_ELEMENT_SHAPE = eINSTANCE.getTemplateParameterCompartment_TemplateableElementShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ListCompartmentImpl <em>List Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ListCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getListCompartment()
		 * @generated
		 */
		EClass LIST_COMPARTMENT = eINSTANCE.getListCompartment();

		/**
		 * The meta object literal for the '<em><b>List Item Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference LIST_COMPARTMENT__LIST_ITEM_LABEL = eINSTANCE.getListCompartment_ListItemLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ListItemLabelImpl <em>List Item Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ListItemLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getListItemLabel()
		 * @generated
		 */
		EClass LIST_ITEM_LABEL = eINSTANCE.getListItemLabel();

		/**
		 * The meta object literal for the '<em><b>List Compartment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference LIST_ITEM_LABEL__LIST_COMPARTMENT = eINSTANCE.getListItemLabel_ListCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StereotypeLabelImpl <em>Stereotype Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StereotypeLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypeLabel()
		 * @generated
		 */
		EClass STEREOTYPE_LABEL = eINSTANCE.getStereotypeLabel();

		/**
		 * The meta object literal for the '<em><b>Stereotyped Diagram Element</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STEREOTYPE_LABEL__STEREOTYPED_DIAGRAM_ELEMENT = eINSTANCE.getStereotypeLabel_StereotypedDiagramElement();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.OwnedUseCaseCompartmentImpl <em>Owned Use Case Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.OwnedUseCaseCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOwnedUseCaseCompartment()
		 * @generated
		 */
		EClass OWNED_USE_CASE_COMPARTMENT = eINSTANCE.getOwnedUseCaseCompartment();

		/**
		 * The meta object literal for the '<em><b>Classifier Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference OWNED_USE_CASE_COMPARTMENT__CLASSIFIER_SHAPE = eINSTANCE.getOwnedUseCaseCompartment_ClassifierShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierCompartmentImpl <em>Classifier Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassifierCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierCompartment()
		 * @generated
		 */
		EClass CLASSIFIER_COMPARTMENT = eINSTANCE.getClassifierCompartment();

		/**
		 * The meta object literal for the '<em><b>Layout</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute CLASSIFIER_COMPARTMENT__LAYOUT = eINSTANCE.getClassifierCompartment_Layout();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UseCaseCompartmentImpl <em>Use Case Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UseCaseCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUseCaseCompartment()
		 * @generated
		 */
		EClass USE_CASE_COMPARTMENT = eINSTANCE.getUseCaseCompartment();

		/**
		 * The meta object literal for the '<em><b>Classifier Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference USE_CASE_COMPARTMENT__CLASSIFIER_SHAPE = eINSTANCE.getUseCaseCompartment_ClassifierShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PackageShapeImpl <em>Package Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PackageShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageShape()
		 * @generated
		 */
		EClass PACKAGE_SHAPE = eINSTANCE.getPackageShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithPackagedElementsShapeImpl
		 * <em>Element With Packaged Elements Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ElementWithPackagedElementsShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithPackagedElementsShape()
		 * @generated
		 */
		EClass ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE = eINSTANCE.getElementWithPackagedElementsShape();

		/**
		 * The meta object literal for the '<em><b>Packaged Element Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE__PACKAGED_ELEMENT_COMPARTMENT = eINSTANCE.getElementWithPackagedElementsShape_PackagedElementCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PackagedElementCompartmentImpl
		 * <em>Packaged Element Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PackagedElementCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackagedElementCompartment()
		 * @generated
		 */
		EClass PACKAGED_ELEMENT_COMPARTMENT = eINSTANCE.getPackagedElementCompartment();

		/**
		 * The meta object literal for the '<em><b>Element With Packaged Elements Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PACKAGED_ELEMENT_COMPARTMENT__ELEMENT_WITH_PACKAGED_ELEMENTS_SHAPE = eINSTANCE.getPackagedElementCompartment_ElementWithPackagedElementsShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ConstraintShapeImpl <em>Constraint Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ConstraintShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConstraintShape()
		 * @generated
		 */
		EClass CONSTRAINT_SHAPE = eINSTANCE.getConstraintShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.AttributeCompartmentImpl <em>Attribute Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.AttributeCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAttributeCompartment()
		 * @generated
		 */
		EClass ATTRIBUTE_COMPARTMENT = eINSTANCE.getAttributeCompartment();

		/**
		 * The meta object literal for the '<em><b>Classifier With Attributes Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ATTRIBUTE_COMPARTMENT__CLASSIFIER_WITH_ATTRIBUTES_SHAPE = eINSTANCE.getAttributeCompartment_ClassifierWithAttributesShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithAttributesShapeImpl
		 * <em>Classifier With Attributes Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithAttributesShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithAttributesShape()
		 * @generated
		 */
		EClass CLASSIFIER_WITH_ATTRIBUTES_SHAPE = eINSTANCE.getClassifierWithAttributesShape();

		/**
		 * The meta object literal for the '<em><b>Attribute Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CLASSIFIER_WITH_ATTRIBUTES_SHAPE__ATTRIBUTE_COMPARTMENT = eINSTANCE.getClassifierWithAttributesShape_AttributeCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.OperationCompartmentImpl <em>Operation Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.OperationCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOperationCompartment()
		 * @generated
		 */
		EClass OPERATION_COMPARTMENT = eINSTANCE.getOperationCompartment();

		/**
		 * The meta object literal for the '<em><b>Classifier With Operations Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference OPERATION_COMPARTMENT__CLASSIFIER_WITH_OPERATIONS_SHAPE = eINSTANCE.getOperationCompartment_ClassifierWithOperationsShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithOperationsShapeImpl
		 * <em>Classifier With Operations Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithOperationsShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithOperationsShape()
		 * @generated
		 */
		EClass CLASSIFIER_WITH_OPERATIONS_SHAPE = eINSTANCE.getClassifierWithOperationsShape();

		/**
		 * The meta object literal for the '<em><b>Operation Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CLASSIFIER_WITH_OPERATIONS_SHAPE__OPERATION_COMPARTMENT = eINSTANCE.getClassifierWithOperationsShape_OperationCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ReceptionCompartmentImpl <em>Reception Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ReceptionCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getReceptionCompartment()
		 * @generated
		 */
		EClass RECEPTION_COMPARTMENT = eINSTANCE.getReceptionCompartment();

		/**
		 * The meta object literal for the '<em><b>Classifier With Reception Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference RECEPTION_COMPARTMENT__CLASSIFIER_WITH_RECEPTION_SHAPE = eINSTANCE.getReceptionCompartment_ClassifierWithReceptionShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithReceptionsShapeImpl
		 * <em>Classifier With Receptions Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithReceptionsShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithReceptionsShape()
		 * @generated
		 */
		EClass CLASSIFIER_WITH_RECEPTIONS_SHAPE = eINSTANCE.getClassifierWithReceptionsShape();

		/**
		 * The meta object literal for the '<em><b>Reception Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CLASSIFIER_WITH_RECEPTIONS_SHAPE__RECEPTION_COMPARTMENT = eINSTANCE.getClassifierWithReceptionsShape_ReceptionCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.LiteralCompartmentImpl <em>Literal Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.LiteralCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getLiteralCompartment()
		 * @generated
		 */
		EClass LITERAL_COMPARTMENT = eINSTANCE.getLiteralCompartment();

		/**
		 * The meta object literal for the '<em><b>Enumeration Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference LITERAL_COMPARTMENT__ENUMERATION_SHAPE = eINSTANCE.getLiteralCompartment_EnumerationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.EnumerationShapeImpl <em>Enumeration Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.EnumerationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getEnumerationShape()
		 * @generated
		 */
		EClass ENUMERATION_SHAPE = eINSTANCE.getEnumerationShape();

		/**
		 * The meta object literal for the '<em><b>Literal Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ENUMERATION_SHAPE__LITERAL_COMPARTMENT = eINSTANCE.getEnumerationShape_LiteralCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.RoleLabelImpl <em>Role Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.RoleLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRoleLabel()
		 * @generated
		 */
		EClass ROLE_LABEL = eINSTANCE.getRoleLabel();

		/**
		 * The meta object literal for the '<em><b>Association Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ROLE_LABEL__ASSOCIATION_EDGE = eINSTANCE.getRoleLabel_AssociationEdge();

		/**
		 * The meta object literal for the '<em><b>Instance Specification Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ROLE_LABEL__INSTANCE_SPECIFICATION_EDGE = eINSTANCE.getRoleLabel_InstanceSpecificationEdge();

		/**
		 * The meta object literal for the '<em><b>Role Binding Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ROLE_LABEL__ROLE_BINDING_EDGE = eINSTANCE.getRoleLabel_RoleBindingEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.AssociationEdgeImpl <em>Association Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.AssociationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationEdge()
		 * @generated
		 */
		EClass ASSOCIATION_EDGE = eINSTANCE.getAssociationEdge();

		/**
		 * The meta object literal for the '<em><b>End Multiplicity Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ASSOCIATION_EDGE__END_MULTIPLICITY_LABEL = eINSTANCE.getAssociationEdge_EndMultiplicityLabel();

		/**
		 * The meta object literal for the '<em><b>End Constraint Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ASSOCIATION_EDGE__END_CONSTRAINT_LABEL = eINSTANCE.getAssociationEdge_EndConstraintLabel();

		/**
		 * The meta object literal for the '<em><b>End Role Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ASSOCIATION_EDGE__END_ROLE_LABEL = eINSTANCE.getAssociationEdge_EndRoleLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ElementEdgeImpl <em>Element Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ElementEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementEdge()
		 * @generated
		 */
		EClass ELEMENT_EDGE = eINSTANCE.getElementEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.MultiplicityLabelImpl <em>Multiplicity Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.MultiplicityLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMultiplicityLabel()
		 * @generated
		 */
		EClass MULTIPLICITY_LABEL = eINSTANCE.getMultiplicityLabel();

		/**
		 * The meta object literal for the '<em><b>Property Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference MULTIPLICITY_LABEL__PROPERTY_EDGE = eINSTANCE.getMultiplicityLabel_PropertyEdge();

		/**
		 * The meta object literal for the '<em><b>Connector Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference MULTIPLICITY_LABEL__CONNECTOR_EDGE = eINSTANCE.getMultiplicityLabel_ConnectorEdge();

		/**
		 * The meta object literal for the '<em><b>Association Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference MULTIPLICITY_LABEL__ASSOCIATION_EDGE = eINSTANCE.getMultiplicityLabel_AssociationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PropertyEdgeImpl <em>Property Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PropertyEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPropertyEdge()
		 * @generated
		 */
		EClass PROPERTY_EDGE = eINSTANCE.getPropertyEdge();

		/**
		 * The meta object literal for the '<em><b>Constraint Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PROPERTY_EDGE__CONSTRAINT_LABEL = eINSTANCE.getPropertyEdge_ConstraintLabel();

		/**
		 * The meta object literal for the '<em><b>Multiplicity Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PROPERTY_EDGE__MULTIPLICITY_LABEL = eINSTANCE.getPropertyEdge_MultiplicityLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ConstraintLabelImpl <em>Constraint Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ConstraintLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConstraintLabel()
		 * @generated
		 */
		EClass CONSTRAINT_LABEL = eINSTANCE.getConstraintLabel();

		/**
		 * The meta object literal for the '<em><b>Association Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONSTRAINT_LABEL__ASSOCIATION_EDGE = eINSTANCE.getConstraintLabel_AssociationEdge();

		/**
		 * The meta object literal for the '<em><b>Generalization Set Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONSTRAINT_LABEL__GENERALIZATION_SET_EDGE = eINSTANCE.getConstraintLabel_GeneralizationSetEdge();

		/**
		 * The meta object literal for the '<em><b>Object Node Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONSTRAINT_LABEL__OBJECT_NODE_SHAPE = eINSTANCE.getConstraintLabel_ObjectNodeShape();

		/**
		 * The meta object literal for the '<em><b>Lifeline Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONSTRAINT_LABEL__LIFELINE_SHAPE = eINSTANCE.getConstraintLabel_LifelineShape();

		/**
		 * The meta object literal for the '<em><b>Action Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONSTRAINT_LABEL__ACTION_SHAPE = eINSTANCE.getConstraintLabel_ActionShape();

		/**
		 * The meta object literal for the '<em><b>Property Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONSTRAINT_LABEL__PROPERTY_EDGE = eINSTANCE.getConstraintLabel_PropertyEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.GeneralizationSetEdgeImpl <em>Generalization Set Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.GeneralizationSetEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGeneralizationSetEdge()
		 * @generated
		 */
		EClass GENERALIZATION_SET_EDGE = eINSTANCE.getGeneralizationSetEdge();

		/**
		 * The meta object literal for the '<em><b>Power Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference GENERALIZATION_SET_EDGE__POWER_LABEL = eINSTANCE.getGeneralizationSetEdge_PowerLabel();

		/**
		 * The meta object literal for the '<em><b>Constraint Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference GENERALIZATION_SET_EDGE__CONSTRAINT_LABEL = eINSTANCE.getGeneralizationSetEdge_ConstraintLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PowerLabelImpl <em>Power Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PowerLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPowerLabel()
		 * @generated
		 */
		EClass POWER_LABEL = eINSTANCE.getPowerLabel();

		/**
		 * The meta object literal for the '<em><b>Generalization Set Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference POWER_LABEL__GENERALIZATION_SET_EDGE = eINSTANCE.getPowerLabel_GeneralizationSetEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ObjectNodeShapeImpl <em>Object Node Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ObjectNodeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getObjectNodeShape()
		 * @generated
		 */
		EClass OBJECT_NODE_SHAPE = eINSTANCE.getObjectNodeShape();

		/**
		 * The meta object literal for the '<em><b>Selection Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference OBJECT_NODE_SHAPE__SELECTION_LABEL = eINSTANCE.getObjectNodeShape_SelectionLabel();

		/**
		 * The meta object literal for the '<em><b>Constraint Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference OBJECT_NODE_SHAPE__CONSTRAINT_LABEL = eINSTANCE.getObjectNodeShape_ConstraintLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityNodeShapeImpl <em>Activity Node Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityNodeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityNodeShape()
		 * @generated
		 */
		EClass ACTIVITY_NODE_SHAPE = eINSTANCE.getActivityNodeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SelectionLabelImpl <em>Selection Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SelectionLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSelectionLabel()
		 * @generated
		 */
		EClass SELECTION_LABEL = eINSTANCE.getSelectionLabel();

		/**
		 * The meta object literal for the '<em><b>Object Flow Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference SELECTION_LABEL__OBJECT_FLOW_EDGE = eINSTANCE.getSelectionLabel_ObjectFlowEdge();

		/**
		 * The meta object literal for the '<em><b>Object Node Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference SELECTION_LABEL__OBJECT_NODE_SHAPE = eINSTANCE.getSelectionLabel_ObjectNodeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ObjectFlowEdgeImpl <em>Object Flow Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ObjectFlowEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getObjectFlowEdge()
		 * @generated
		 */
		EClass OBJECT_FLOW_EDGE = eINSTANCE.getObjectFlowEdge();

		/**
		 * The meta object literal for the '<em><b>Transformation Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference OBJECT_FLOW_EDGE__TRANSFORMATION_LABEL = eINSTANCE.getObjectFlowEdge_TransformationLabel();

		/**
		 * The meta object literal for the '<em><b>Selection Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference OBJECT_FLOW_EDGE__SELECTION_LABEL = eINSTANCE.getObjectFlowEdge_SelectionLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityEdgeEdgeImpl <em>Activity Edge Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityEdgeEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityEdgeEdge()
		 * @generated
		 */
		EClass ACTIVITY_EDGE_EDGE = eINSTANCE.getActivityEdgeEdge();

		/**
		 * The meta object literal for the '<em><b>Guard Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_EDGE_EDGE__GUARD_LABEL = eINSTANCE.getActivityEdgeEdge_GuardLabel();

		/**
		 * The meta object literal for the '<em><b>Weight Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_EDGE_EDGE__WEIGHT_LABEL = eINSTANCE.getActivityEdgeEdge_WeightLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.GuardLabelImpl <em>Guard Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.GuardLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGuardLabel()
		 * @generated
		 */
		EClass GUARD_LABEL = eINSTANCE.getGuardLabel();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference GUARD_LABEL__ACTIVITY_EDGE_EDGE = eINSTANCE.getGuardLabel_ActivityEdgeEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.WeightLabelImpl <em>Weight Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.WeightLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getWeightLabel()
		 * @generated
		 */
		EClass WEIGHT_LABEL = eINSTANCE.getWeightLabel();

		/**
		 * The meta object literal for the '<em><b>Activity Edge Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference WEIGHT_LABEL__ACTIVITY_EDGE_EDGE = eINSTANCE.getWeightLabel_ActivityEdgeEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TransformationLabelImpl <em>Transformation Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TransformationLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTransformationLabel()
		 * @generated
		 */
		EClass TRANSFORMATION_LABEL = eINSTANCE.getTransformationLabel();

		/**
		 * The meta object literal for the '<em><b>Object Flow Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TRANSFORMATION_LABEL__OBJECT_FLOW_EDGE = eINSTANCE.getTransformationLabel_ObjectFlowEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ConnectorEdgeImpl <em>Connector Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ConnectorEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConnectorEdge()
		 * @generated
		 */
		EClass CONNECTOR_EDGE = eINSTANCE.getConnectorEdge();

		/**
		 * The meta object literal for the '<em><b>End Multiplicity Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONNECTOR_EDGE__END_MULTIPLICITY_LABEL = eINSTANCE.getConnectorEdge_EndMultiplicityLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InstanceSpecificationEdgeImpl <em>Instance Specification Edge</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InstanceSpecificationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInstanceSpecificationEdge()
		 * @generated
		 */
		EClass INSTANCE_SPECIFICATION_EDGE = eINSTANCE.getInstanceSpecificationEdge();

		/**
		 * The meta object literal for the '<em><b>End Role Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INSTANCE_SPECIFICATION_EDGE__END_ROLE_LABEL = eINSTANCE.getInstanceSpecificationEdge_EndRoleLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DependencyEdgeImpl <em>Dependency Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DependencyEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDependencyEdge()
		 * @generated
		 */
		EClass DEPENDENCY_EDGE = eINSTANCE.getDependencyEdge();

		/**
		 * The meta object literal for the '<em><b>Role Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference DEPENDENCY_EDGE__ROLE_LABEL = eINSTANCE.getDependencyEdge_RoleLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InstanceSpecificationShapeImpl
		 * <em>Instance Specification Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InstanceSpecificationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInstanceSpecificationShape()
		 * @generated
		 */
		EClass INSTANCE_SPECIFICATION_SHAPE = eINSTANCE.getInstanceSpecificationShape();

		/**
		 * The meta object literal for the '<em><b>Slot Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INSTANCE_SPECIFICATION_SHAPE__SLOT_COMPARTMENT = eINSTANCE.getInstanceSpecificationShape_SlotCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentTargetShapeImpl <em>Deployment Target Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DeploymentTargetShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentTargetShape()
		 * @generated
		 */
		EClass DEPLOYMENT_TARGET_SHAPE = eINSTANCE.getDeploymentTargetShape();

		/**
		 * The meta object literal for the '<em><b>Deployed Artifact Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference DEPLOYMENT_TARGET_SHAPE__DEPLOYED_ARTIFACT_COMPARTMENT = eINSTANCE.getDeploymentTargetShape_DeployedArtifactCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DeployedArtifactCompartmentImpl
		 * <em>Deployed Artifact Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DeployedArtifactCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeployedArtifactCompartment()
		 * @generated
		 */
		EClass DEPLOYED_ARTIFACT_COMPARTMENT = eINSTANCE.getDeployedArtifactCompartment();

		/**
		 * The meta object literal for the '<em><b>Deployment Target Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference DEPLOYED_ARTIFACT_COMPARTMENT__DEPLOYMENT_TARGET_SHAPE = eINSTANCE.getDeployedArtifactCompartment_DeploymentTargetShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SlotCompartmentImpl <em>Slot Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SlotCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSlotCompartment()
		 * @generated
		 */
		EClass SLOT_COMPARTMENT = eINSTANCE.getSlotCompartment();

		/**
		 * The meta object literal for the '<em><b>Instance Specification Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference SLOT_COMPARTMENT__INSTANCE_SPECIFICATION_SHAPE = eINSTANCE.getSlotCompartment_InstanceSpecificationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassShapeImpl <em>Class Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassShape()
		 * @generated
		 */
		EClass CLASS_SHAPE = eINSTANCE.getClassShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithPortsShapeImpl <em>Element With Ports Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ElementWithPortsShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithPortsShape()
		 * @generated
		 */
		EClass ELEMENT_WITH_PORTS_SHAPE = eINSTANCE.getElementWithPortsShape();

		/**
		 * The meta object literal for the '<em><b>Port Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ELEMENT_WITH_PORTS_SHAPE__PORT_SHAPE = eINSTANCE.getElementWithPortsShape_PortShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithStructureShapeImpl <em>Element With Structure Shape</em>}
		 * ' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ElementWithStructureShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithStructureShape()
		 * @generated
		 */
		EClass ELEMENT_WITH_STRUCTURE_SHAPE = eINSTANCE.getElementWithStructureShape();

		/**
		 * The meta object literal for the '<em><b>Structure Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ELEMENT_WITH_STRUCTURE_SHAPE__STRUCTURE_COMPARTMENT = eINSTANCE.getElementWithStructureShape_StructureCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StructureCompartmentImpl <em>Structure Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StructureCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStructureCompartment()
		 * @generated
		 */
		EClass STRUCTURE_COMPARTMENT = eINSTANCE.getStructureCompartment();

		/**
		 * The meta object literal for the '<em><b>Element With Structure Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STRUCTURE_COMPARTMENT__ELEMENT_WITH_STRUCTURE_SHAPE = eINSTANCE.getStructureCompartment_ElementWithStructureShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PortShapeImpl <em>Port Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PortShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPortShape()
		 * @generated
		 */
		EClass PORT_SHAPE = eINSTANCE.getPortShape();

		/**
		 * The meta object literal for the '<em><b>Element With Ports Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PORT_SHAPE__ELEMENT_WITH_PORTS_SHAPE = eINSTANCE.getPortShape_ElementWithPortsShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ClassifierWithNestedClassifiersShapeImpl
		 * <em>Classifier With Nested Classifiers Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ClassifierWithNestedClassifiersShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getClassifierWithNestedClassifiersShape()
		 * @generated
		 */
		EClass CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE = eINSTANCE.getClassifierWithNestedClassifiersShape();

		/**
		 * The meta object literal for the '<em><b>Nested Classifier Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE__NESTED_CLASSIFIER_COMPARTMENT = eINSTANCE.getClassifierWithNestedClassifiersShape_NestedClassifierCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.NestedClassifierCompartmentImpl
		 * <em>Nested Classifier Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.NestedClassifierCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNestedClassifierCompartment()
		 * @generated
		 */
		EClass NESTED_CLASSIFIER_COMPARTMENT = eINSTANCE.getNestedClassifierCompartment();

		/**
		 * The meta object literal for the '<em><b>Classifier With Nested Classifiers Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference NESTED_CLASSIFIER_COMPARTMENT__CLASSIFIER_WITH_NESTED_CLASSIFIERS_SHAPE = eINSTANCE.getNestedClassifierCompartment_ClassifierWithNestedClassifiersShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.BehavioredClassifierShapeImpl <em>Behaviored Classifier Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.BehavioredClassifierShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getBehavioredClassifierShape()
		 * @generated
		 */
		EClass BEHAVIORED_CLASSIFIER_SHAPE = eINSTANCE.getBehavioredClassifierShape();

		/**
		 * The meta object literal for the '<em><b>Owned Behavior Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference BEHAVIORED_CLASSIFIER_SHAPE__OWNED_BEHAVIOR_COMPARTMENT = eINSTANCE.getBehavioredClassifierShape_OwnedBehaviorCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.OwnedBehaviorCompartmentImpl <em>Owned Behavior Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.OwnedBehaviorCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOwnedBehaviorCompartment()
		 * @generated
		 */
		EClass OWNED_BEHAVIOR_COMPARTMENT = eINSTANCE.getOwnedBehaviorCompartment();

		/**
		 * The meta object literal for the '<em><b>Behaviored Classifier Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference OWNED_BEHAVIOR_COMPARTMENT__BEHAVIORED_CLASSIFIER_SHAPE = eINSTANCE.getOwnedBehaviorCompartment_BehavioredClassifierShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InterfaceShapeImpl <em>Interface Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InterfaceShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInterfaceShape()
		 * @generated
		 */
		EClass INTERFACE_SHAPE = eINSTANCE.getInterfaceShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DataTypeShapeImpl <em>Data Type Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DataTypeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDataTypeShape()
		 * @generated
		 */
		EClass DATA_TYPE_SHAPE = eINSTANCE.getDataTypeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PrimitiveTypeShapeImpl <em>Primitive Type Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PrimitiveTypeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPrimitiveTypeShape()
		 * @generated
		 */
		EClass PRIMITIVE_TYPE_SHAPE = eINSTANCE.getPrimitiveTypeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SignalShapeImpl <em>Signal Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SignalShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSignalShape()
		 * @generated
		 */
		EClass SIGNAL_SHAPE = eINSTANCE.getSignalShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ModelShapeImpl <em>Model Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ModelShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getModelShape()
		 * @generated
		 */
		EClass MODEL_SHAPE = eINSTANCE.getModelShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ContainmentEdgeImpl <em>Containment Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ContainmentEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getContainmentEdge()
		 * @generated
		 */
		EClass CONTAINMENT_EDGE = eINSTANCE.getContainmentEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.GeneralizationEdgeImpl <em>Generalization Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.GeneralizationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGeneralizationEdge()
		 * @generated
		 */
		EClass GENERALIZATION_EDGE = eINSTANCE.getGeneralizationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.RealizationEdgeImpl <em>Realization Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.RealizationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRealizationEdge()
		 * @generated
		 */
		EClass REALIZATION_EDGE = eINSTANCE.getRealizationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.AbstractionEdgeImpl <em>Abstraction Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.AbstractionEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAbstractionEdge()
		 * @generated
		 */
		EClass ABSTRACTION_EDGE = eINSTANCE.getAbstractionEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InterfaceRealizationEdgeImpl <em>Interface Realization Edge</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InterfaceRealizationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInterfaceRealizationEdge()
		 * @generated
		 */
		EClass INTERFACE_REALIZATION_EDGE = eINSTANCE.getInterfaceRealizationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UsageEdgeImpl <em>Usage Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UsageEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUsageEdge()
		 * @generated
		 */
		EClass USAGE_EDGE = eINSTANCE.getUsageEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ElementImportEdgeImpl <em>Element Import Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ElementImportEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementImportEdge()
		 * @generated
		 */
		EClass ELEMENT_IMPORT_EDGE = eINSTANCE.getElementImportEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PackageImportEdgeImpl <em>Package Import Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PackageImportEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageImportEdge()
		 * @generated
		 */
		EClass PACKAGE_IMPORT_EDGE = eINSTANCE.getPackageImportEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PackageMergeEdgeImpl <em>Package Merge Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PackageMergeEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageMergeEdge()
		 * @generated
		 */
		EClass PACKAGE_MERGE_EDGE = eINSTANCE.getPackageMergeEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SubstitutionEdgeImpl <em>Substitution Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SubstitutionEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubstitutionEdge()
		 * @generated
		 */
		EClass SUBSTITUTION_EDGE = eINSTANCE.getSubstitutionEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InformationFlowEdgeImpl <em>Information Flow Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InformationFlowEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInformationFlowEdge()
		 * @generated
		 */
		EClass INFORMATION_FLOW_EDGE = eINSTANCE.getInformationFlowEdge();

		/**
		 * The meta object literal for the '<em><b>Conveyed Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INFORMATION_FLOW_EDGE__CONVEYED_LABEL = eINSTANCE.getInformationFlowEdge_ConveyedLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ConveyedLabelImpl <em>Conveyed Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ConveyedLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConveyedLabel()
		 * @generated
		 */
		EClass CONVEYED_LABEL = eINSTANCE.getConveyedLabel();

		/**
		 * The meta object literal for the '<em><b>Information Flow Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONVEYED_LABEL__INFORMATION_FLOW_EDGE = eINSTANCE.getConveyedLabel_InformationFlowEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.AssociationClassEdgeImpl <em>Association Class Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.AssociationClassEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationClassEdge()
		 * @generated
		 */
		EClass ASSOCIATION_CLASS_EDGE = eINSTANCE.getAssociationClassEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.CommentShapeImpl <em>Comment Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.CommentShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCommentShape()
		 * @generated
		 */
		EClass COMMENT_SHAPE = eINSTANCE.getCommentShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.AttachmentEdgeImpl <em>Attachment Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.AttachmentEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAttachmentEdge()
		 * @generated
		 */
		EClass ATTACHMENT_EDGE = eINSTANCE.getAttachmentEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.AssociationClassShapeImpl <em>Association Class Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.AssociationClassShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationClassShape()
		 * @generated
		 */
		EClass ASSOCIATION_CLASS_SHAPE = eINSTANCE.getAssociationClassShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ComponentShapeImpl <em>Component Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ComponentShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getComponentShape()
		 * @generated
		 */
		EClass COMPONENT_SHAPE = eINSTANCE.getComponentShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InformationItemShapeImpl <em>Information Item Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InformationItemShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInformationItemShape()
		 * @generated
		 */
		EClass INFORMATION_ITEM_SHAPE = eINSTANCE.getInformationItemShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.RepresentationEdgeImpl <em>Representation Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.RepresentationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRepresentationEdge()
		 * @generated
		 */
		EClass REPRESENTATION_EDGE = eINSTANCE.getRepresentationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.AssociationShapeImpl <em>Association Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.AssociationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getAssociationShape()
		 * @generated
		 */
		EClass ASSOCIATION_SHAPE = eINSTANCE.getAssociationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DependencyShapeImpl <em>Dependency Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DependencyShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDependencyShape()
		 * @generated
		 */
		EClass DEPENDENCY_SHAPE = eINSTANCE.getDependencyShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TimeObservationShapeImpl <em>Time Observation Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TimeObservationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeObservationShape()
		 * @generated
		 */
		EClass TIME_OBSERVATION_SHAPE = eINSTANCE.getTimeObservationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TimeObservationShape_TimeObservationShapeImpl
		 * <em>Time Observation Shape Time Observation Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TimeObservationShape_TimeObservationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeObservationShape_TimeObservationShape()
		 * @generated
		 */
		EClass TIME_OBSERVATION_SHAPE_TIME_OBSERVATION_SHAPE = eINSTANCE.getTimeObservationShape_TimeObservationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DurationObservationShapeImpl <em>Duration Observation Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DurationObservationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDurationObservationShape()
		 * @generated
		 */
		EClass DURATION_OBSERVATION_SHAPE = eINSTANCE.getDurationObservationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PackageDiagramImpl <em>Package Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PackageDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPackageDiagram()
		 * @generated
		 */
		EClass PACKAGE_DIAGRAM = eINSTANCE.getPackageDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ProfileDiagramImpl <em>Profile Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ProfileDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProfileDiagram()
		 * @generated
		 */
		EClass PROFILE_DIAGRAM = eINSTANCE.getProfileDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.CompositeStructureDiagramImpl <em>Composite Structure Diagram</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.CompositeStructureDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCompositeStructureDiagram()
		 * @generated
		 */
		EClass COMPOSITE_STRUCTURE_DIAGRAM = eINSTANCE.getCompositeStructureDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentDiagramImpl <em>Deployment Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DeploymentDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentDiagram()
		 * @generated
		 */
		EClass DEPLOYMENT_DIAGRAM = eINSTANCE.getDeploymentDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ComponentDiagramImpl <em>Component Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ComponentDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getComponentDiagram()
		 * @generated
		 */
		EClass COMPONENT_DIAGRAM = eINSTANCE.getComponentDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ObjectDiagramImpl <em>Object Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ObjectDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getObjectDiagram()
		 * @generated
		 */
		EClass OBJECT_DIAGRAM = eINSTANCE.getObjectDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ProfileShapeImpl <em>Profile Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ProfileShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProfileShape()
		 * @generated
		 */
		EClass PROFILE_SHAPE = eINSTANCE.getProfileShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ProfileApplicationEdgeImpl <em>Profile Application Edge</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ProfileApplicationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProfileApplicationEdge()
		 * @generated
		 */
		EClass PROFILE_APPLICATION_EDGE = eINSTANCE.getProfileApplicationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExtensionEdgeImpl <em>Extension Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExtensionEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExtensionEdge()
		 * @generated
		 */
		EClass EXTENSION_EDGE = eINSTANCE.getExtensionEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.BehaviorDiagramImpl <em>Behavior Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.BehaviorDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getBehaviorDiagram()
		 * @generated
		 */
		EClass BEHAVIOR_DIAGRAM = eINSTANCE.getBehaviorDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UseCaseDiagramImpl <em>Use Case Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UseCaseDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUseCaseDiagram()
		 * @generated
		 */
		EClass USE_CASE_DIAGRAM = eINSTANCE.getUseCaseDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ArtifactShapeImpl <em>Artifact Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ArtifactShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getArtifactShape()
		 * @generated
		 */
		EClass ARTIFACT_SHAPE = eINSTANCE.getArtifactShape();

		/**
		 * The meta object literal for the '<em><b>Nested Artifact Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ARTIFACT_SHAPE__NESTED_ARTIFACT_COMPARTMENT = eINSTANCE.getArtifactShape_NestedArtifactCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.NestedArtifactCompartmentImpl <em>Nested Artifact Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.NestedArtifactCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNestedArtifactCompartment()
		 * @generated
		 */
		EClass NESTED_ARTIFACT_COMPARTMENT = eINSTANCE.getNestedArtifactCompartment();

		/**
		 * The meta object literal for the '<em><b>Artifact Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference NESTED_ARTIFACT_COMPARTMENT__ARTIFACT_SHAPE = eINSTANCE.getNestedArtifactCompartment_ArtifactShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ComponentRealizationEdgeImpl <em>Component Realization Edge</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ComponentRealizationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getComponentRealizationEdge()
		 * @generated
		 */
		EClass COMPONENT_REALIZATION_EDGE = eINSTANCE.getComponentRealizationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ManifestationEdgeImpl <em>Manifestation Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ManifestationEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getManifestationEdge()
		 * @generated
		 */
		EClass MANIFESTATION_EDGE = eINSTANCE.getManifestationEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PropertyShapeImpl <em>Property Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PropertyShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPropertyShape()
		 * @generated
		 */
		EClass PROPERTY_SHAPE = eINSTANCE.getPropertyShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.CollaborationShapeImpl <em>Collaboration Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.CollaborationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCollaborationShape()
		 * @generated
		 */
		EClass COLLABORATION_SHAPE = eINSTANCE.getCollaborationShape();

		/**
		 * The meta object literal for the '<em><b>Reception Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference COLLABORATION_SHAPE__RECEPTION_COMPARTMENT = eINSTANCE.getCollaborationShape_ReceptionCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.CollaborationUseShapeImpl <em>Collaboration Use Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.CollaborationUseShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCollaborationUseShape()
		 * @generated
		 */
		EClass COLLABORATION_USE_SHAPE = eINSTANCE.getCollaborationUseShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TemplateBindingEdgeImpl <em>Template Binding Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TemplateBindingEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTemplateBindingEdge()
		 * @generated
		 */
		EClass TEMPLATE_BINDING_EDGE = eINSTANCE.getTemplateBindingEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StereotypeShapeImpl <em>Stereotype Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StereotypeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStereotypeShape()
		 * @generated
		 */
		EClass STEREOTYPE_SHAPE = eINSTANCE.getStereotypeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.NodeShapeImpl <em>Node Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.NodeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNodeShape()
		 * @generated
		 */
		EClass NODE_SHAPE = eINSTANCE.getNodeShape();

		/**
		 * The meta object literal for the '<em><b>Nested Node Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference NODE_SHAPE__NESTED_NODE_COMPARTMENT = eINSTANCE.getNodeShape_NestedNodeCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.NestedNodeCompartmentImpl <em>Nested Node Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.NestedNodeCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getNestedNodeCompartment()
		 * @generated
		 */
		EClass NESTED_NODE_COMPARTMENT = eINSTANCE.getNestedNodeCompartment();

		/**
		 * The meta object literal for the '<em><b>Node Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference NESTED_NODE_COMPARTMENT__NODE_SHAPE = eINSTANCE.getNestedNodeCompartment_NodeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DeviceShapeImpl <em>Device Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DeviceShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeviceShape()
		 * @generated
		 */
		EClass DEVICE_SHAPE = eINSTANCE.getDeviceShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExecutionEnvironmentShapeImpl <em>Execution Environment Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExecutionEnvironmentShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExecutionEnvironmentShape()
		 * @generated
		 */
		EClass EXECUTION_ENVIRONMENT_SHAPE = eINSTANCE.getExecutionEnvironmentShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityShapeImpl <em>Activity Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityShape()
		 * @generated
		 */
		EClass ACTIVITY_SHAPE = eINSTANCE.getActivityShape();

		/**
		 * The meta object literal for the '<em><b>Parameter Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_SHAPE__PARAMETER_COMPARTMENT = eINSTANCE.getActivityShape_ParameterCompartment();

		/**
		 * The meta object literal for the '<em><b>Post Condition Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_SHAPE__POST_CONDITION_COMPARTMENT = eINSTANCE.getActivityShape_PostConditionCompartment();

		/**
		 * The meta object literal for the '<em><b>Pre Condition Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_SHAPE__PRE_CONDITION_COMPARTMENT = eINSTANCE.getActivityShape_PreConditionCompartment();

		/**
		 * The meta object literal for the '<em><b>Activity Parameter Node Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_SHAPE__ACTIVITY_PARAMETER_NODE_SHAPE = eINSTANCE.getActivityShape_ActivityParameterNodeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ElementWithActivityNodesShapeImpl
		 * <em>Element With Activity Nodes Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ElementWithActivityNodesShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getElementWithActivityNodesShape()
		 * @generated
		 */
		EClass ELEMENT_WITH_ACTIVITY_NODES_SHAPE = eINSTANCE.getElementWithActivityNodesShape();

		/**
		 * The meta object literal for the '<em><b>Activity Node Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ELEMENT_WITH_ACTIVITY_NODES_SHAPE__ACTIVITY_NODE_COMPARTMENT = eINSTANCE.getElementWithActivityNodesShape_ActivityNodeCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityNodeCompartmentImpl <em>Activity Node Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityNodeCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityNodeCompartment()
		 * @generated
		 */
		EClass ACTIVITY_NODE_COMPARTMENT = eINSTANCE.getActivityNodeCompartment();

		/**
		 * The meta object literal for the '<em><b>Element With Activity Nodes Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_NODE_COMPARTMENT__ELEMENT_WITH_ACTIVITY_NODES_SHAPE = eINSTANCE.getActivityNodeCompartment_ElementWithActivityNodesShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ParameterCompartmentImpl <em>Parameter Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ParameterCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getParameterCompartment()
		 * @generated
		 */
		EClass PARAMETER_COMPARTMENT = eINSTANCE.getParameterCompartment();

		/**
		 * The meta object literal for the '<em><b>Activity Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PARAMETER_COMPARTMENT__ACTIVITY_SHAPE = eINSTANCE.getParameterCompartment_ActivityShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PostConditionCompartmentImpl <em>Post Condition Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PostConditionCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPostConditionCompartment()
		 * @generated
		 */
		EClass POST_CONDITION_COMPARTMENT = eINSTANCE.getPostConditionCompartment();

		/**
		 * The meta object literal for the '<em><b>Activity Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference POST_CONDITION_COMPARTMENT__ACTIVITY_SHAPE = eINSTANCE.getPostConditionCompartment_ActivityShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PreConditionCompartmentImpl <em>Pre Condition Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PreConditionCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPreConditionCompartment()
		 * @generated
		 */
		EClass PRE_CONDITION_COMPARTMENT = eINSTANCE.getPreConditionCompartment();

		/**
		 * The meta object literal for the '<em><b>Activity Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PRE_CONDITION_COMPARTMENT__ACTIVITY_SHAPE = eINSTANCE.getPreConditionCompartment_ActivityShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityParameterNodeShapeImpl
		 * <em>Activity Parameter Node Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityParameterNodeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityParameterNodeShape()
		 * @generated
		 */
		EClass ACTIVITY_PARAMETER_NODE_SHAPE = eINSTANCE.getActivityParameterNodeShape();

		/**
		 * The meta object literal for the '<em><b>Activity Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_PARAMETER_NODE_SHAPE__ACTIVITY_SHAPE = eINSTANCE.getActivityParameterNodeShape_ActivityShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionShapeImpl <em>Interaction Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionShape()
		 * @generated
		 */
		EClass INTERACTION_SHAPE = eINSTANCE.getInteractionShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionFragmentWithSubfragmentsShapeImpl
		 * <em>Interaction Fragment With Subfragments Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionFragmentWithSubfragmentsShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionFragmentWithSubfragmentsShape()
		 * @generated
		 */
		EClass INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE = eINSTANCE.getInteractionFragmentWithSubfragmentsShape();

		/**
		 * The meta object literal for the '<em><b>Subfragment Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE__SUBFRAGMENT_COMPARTMENT = eINSTANCE.getInteractionFragmentWithSubfragmentsShape_SubfragmentCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionFragmentShapeImpl <em>Interaction Fragment Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionFragmentShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionFragmentShape()
		 * @generated
		 */
		EClass INTERACTION_FRAGMENT_SHAPE = eINSTANCE.getInteractionFragmentShape();

		/**
		 * The meta object literal for the '<em><b>Lifeline Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INTERACTION_FRAGMENT_SHAPE__LIFELINE_SHAPE = eINSTANCE.getInteractionFragmentShape_LifelineShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SubfragmentCompartmentImpl <em>Subfragment Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SubfragmentCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubfragmentCompartment()
		 * @generated
		 */
		EClass SUBFRAGMENT_COMPARTMENT = eINSTANCE.getSubfragmentCompartment();

		/**
		 * The meta object literal for the '<em><b>Interaction Fragment With Subfragments Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference SUBFRAGMENT_COMPARTMENT__INTERACTION_FRAGMENT_WITH_SUBFRAGMENTS_SHAPE = eINSTANCE.getSubfragmentCompartment_InteractionFragmentWithSubfragmentsShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionFragmentWithGatesShapeImpl
		 * <em>Interaction Fragment With Gates Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionFragmentWithGatesShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionFragmentWithGatesShape()
		 * @generated
		 */
		EClass INTERACTION_FRAGMENT_WITH_GATES_SHAPE = eINSTANCE.getInteractionFragmentWithGatesShape();

		/**
		 * The meta object literal for the '<em><b>Gate Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INTERACTION_FRAGMENT_WITH_GATES_SHAPE__GATE_SHAPE = eINSTANCE.getInteractionFragmentWithGatesShape_GateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.GateShapeImpl <em>Gate Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.GateShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGateShape()
		 * @generated
		 */
		EClass GATE_SHAPE = eINSTANCE.getGateShape();

		/**
		 * The meta object literal for the '<em><b>Interaction Fragment With Gates Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference GATE_SHAPE__INTERACTION_FRAGMENT_WITH_GATES_SHAPE = eINSTANCE.getGateShape_InteractionFragmentWithGatesShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.OpaqueBehaviorShapeImpl <em>Opaque Behavior Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.OpaqueBehaviorShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getOpaqueBehaviorShape()
		 * @generated
		 */
		EClass OPAQUE_BEHAVIOR_SHAPE = eINSTANCE.getOpaqueBehaviorShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.FunctionBehaviorShapeImpl <em>Function Behavior Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.FunctionBehaviorShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getFunctionBehaviorShape()
		 * @generated
		 */
		EClass FUNCTION_BEHAVIOR_SHAPE = eINSTANCE.getFunctionBehaviorShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StateMachineShapeImpl <em>State Machine Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StateMachineShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateMachineShape()
		 * @generated
		 */
		EClass STATE_MACHINE_SHAPE = eINSTANCE.getStateMachineShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.BaseStateShapeImpl <em>Base State Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.BaseStateShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getBaseStateShape()
		 * @generated
		 */
		EClass BASE_STATE_SHAPE = eINSTANCE.getBaseStateShape();

		/**
		 * The meta object literal for the '<em><b>Connection Point Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference BASE_STATE_SHAPE__CONNECTION_POINT_SHAPE = eINSTANCE.getBaseStateShape_ConnectionPointShape();

		/**
		 * The meta object literal for the '<em><b>Region Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference BASE_STATE_SHAPE__REGION_COMPARTMENT = eINSTANCE.getBaseStateShape_RegionCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PseudostateShapeImpl <em>Pseudostate Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PseudostateShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPseudostateShape()
		 * @generated
		 */
		EClass PSEUDOSTATE_SHAPE = eINSTANCE.getPseudostateShape();

		/**
		 * The meta object literal for the '<em><b>Base State Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PSEUDOSTATE_SHAPE__BASE_STATE_SHAPE = eINSTANCE.getPseudostateShape_BaseStateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.RegionCompartmentImpl <em>Region Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.RegionCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRegionCompartment()
		 * @generated
		 */
		EClass REGION_COMPARTMENT = eINSTANCE.getRegionCompartment();

		/**
		 * The meta object literal for the '<em><b>Base State Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference REGION_COMPARTMENT__BASE_STATE_SHAPE = eINSTANCE.getRegionCompartment_BaseStateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ProtocolStateMachineShapeImpl <em>Protocol State Machine Shape</em>}
		 * ' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ProtocolStateMachineShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getProtocolStateMachineShape()
		 * @generated
		 */
		EClass PROTOCOL_STATE_MACHINE_SHAPE = eINSTANCE.getProtocolStateMachineShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentSpecificationShapeImpl
		 * <em>Deployment Specification Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DeploymentSpecificationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentSpecificationShape()
		 * @generated
		 */
		EClass DEPLOYMENT_SPECIFICATION_SHAPE = eINSTANCE.getDeploymentSpecificationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.CommunicationPathEdgeImpl <em>Communication Path Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.CommunicationPathEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCommunicationPathEdge()
		 * @generated
		 */
		EClass COMMUNICATION_PATH_EDGE = eINSTANCE.getCommunicationPathEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DeploymentEdgeImpl <em>Deployment Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DeploymentEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeploymentEdge()
		 * @generated
		 */
		EClass DEPLOYMENT_EDGE = eINSTANCE.getDeploymentEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActorShapeImpl <em>Actor Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActorShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActorShape()
		 * @generated
		 */
		EClass ACTOR_SHAPE = eINSTANCE.getActorShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExtensionPointCompartmentImpl <em>Extension Point Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExtensionPointCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExtensionPointCompartment()
		 * @generated
		 */
		EClass EXTENSION_POINT_COMPARTMENT = eINSTANCE.getExtensionPointCompartment();

		/**
		 * The meta object literal for the '<em><b>Use Case Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference EXTENSION_POINT_COMPARTMENT__USE_CASE_SHAPE = eINSTANCE.getExtensionPointCompartment_UseCaseShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.UseCaseShapeImpl <em>Use Case Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.UseCaseShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getUseCaseShape()
		 * @generated
		 */
		EClass USE_CASE_SHAPE = eINSTANCE.getUseCaseShape();

		/**
		 * The meta object literal for the '<em><b>Extension Point Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference USE_CASE_SHAPE__EXTENSION_POINT_COMPARTMENT = eINSTANCE.getUseCaseShape_ExtensionPointCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.IncludeEdgeImpl <em>Include Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.IncludeEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getIncludeEdge()
		 * @generated
		 */
		EClass INCLUDE_EDGE = eINSTANCE.getIncludeEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExtendEdgeImpl <em>Extend Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExtendEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExtendEdge()
		 * @generated
		 */
		EClass EXTEND_EDGE = eINSTANCE.getExtendEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StateMachineDiagramImpl <em>State Machine Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StateMachineDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateMachineDiagram()
		 * @generated
		 */
		EClass STATE_MACHINE_DIAGRAM = eINSTANCE.getStateMachineDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityDiagramImpl <em>Activity Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityDiagram()
		 * @generated
		 */
		EClass ACTIVITY_DIAGRAM = eINSTANCE.getActivityDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SequenceDiagramImpl <em>Sequence Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SequenceDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSequenceDiagram()
		 * @generated
		 */
		EClass SEQUENCE_DIAGRAM = eINSTANCE.getSequenceDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionDiagramImpl <em>Interaction Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionDiagram()
		 * @generated
		 */
		EClass INTERACTION_DIAGRAM = eINSTANCE.getInteractionDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.CommunicationDiagramImpl <em>Communication Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.CommunicationDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCommunicationDiagram()
		 * @generated
		 */
		EClass COMMUNICATION_DIAGRAM = eINSTANCE.getCommunicationDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TimingDiagramImpl <em>Timing Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TimingDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimingDiagram()
		 * @generated
		 */
		EClass TIMING_DIAGRAM = eINSTANCE.getTimingDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionOverviewDiagramImpl
		 * <em>Interaction Overview Diagram</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionOverviewDiagramImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionOverviewDiagram()
		 * @generated
		 */
		EClass INTERACTION_OVERVIEW_DIAGRAM = eINSTANCE.getInteractionOverviewDiagram();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InternalBehaviorCompartmentImpl
		 * <em>Internal Behavior Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InternalBehaviorCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInternalBehaviorCompartment()
		 * @generated
		 */
		EClass INTERNAL_BEHAVIOR_COMPARTMENT = eINSTANCE.getInternalBehaviorCompartment();

		/**
		 * The meta object literal for the '<em><b>State Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INTERNAL_BEHAVIOR_COMPARTMENT__STATE_SHAPE = eINSTANCE.getInternalBehaviorCompartment_StateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StateShapeImpl <em>State Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StateShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateShape()
		 * @generated
		 */
		EClass STATE_SHAPE = eINSTANCE.getStateShape();

		/**
		 * The meta object literal for the '<em><b>Connection Point Reference Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STATE_SHAPE__CONNECTION_POINT_REFERENCE_SHAPE = eINSTANCE.getStateShape_ConnectionPointReferenceShape();

		/**
		 * The meta object literal for the '<em><b>Internal Transition Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STATE_SHAPE__INTERNAL_TRANSITION_COMPARTMENT = eINSTANCE.getStateShape_InternalTransitionCompartment();

		/**
		 * The meta object literal for the '<em><b>Deferrable Trigger Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STATE_SHAPE__DEFERRABLE_TRIGGER_COMPARTMENT = eINSTANCE.getStateShape_DeferrableTriggerCompartment();

		/**
		 * The meta object literal for the '<em><b>Internal Behavior Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference STATE_SHAPE__INTERNAL_BEHAVIOR_COMPARTMENT = eINSTANCE.getStateShape_InternalBehaviorCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ConnectionPointReferenceShapeImpl
		 * <em>Connection Point Reference Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ConnectionPointReferenceShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getConnectionPointReferenceShape()
		 * @generated
		 */
		EClass CONNECTION_POINT_REFERENCE_SHAPE = eINSTANCE.getConnectionPointReferenceShape();

		/**
		 * The meta object literal for the '<em><b>State Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference CONNECTION_POINT_REFERENCE_SHAPE__STATE_SHAPE = eINSTANCE.getConnectionPointReferenceShape_StateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InternalTransitionCompartmentImpl
		 * <em>Internal Transition Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InternalTransitionCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInternalTransitionCompartment()
		 * @generated
		 */
		EClass INTERNAL_TRANSITION_COMPARTMENT = eINSTANCE.getInternalTransitionCompartment();

		/**
		 * The meta object literal for the '<em><b>State Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INTERNAL_TRANSITION_COMPARTMENT__STATE_SHAPE = eINSTANCE.getInternalTransitionCompartment_StateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DeferrableTriggerCompartmentImpl
		 * <em>Deferrable Trigger Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DeferrableTriggerCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDeferrableTriggerCompartment()
		 * @generated
		 */
		EClass DEFERRABLE_TRIGGER_COMPARTMENT = eINSTANCE.getDeferrableTriggerCompartment();

		/**
		 * The meta object literal for the '<em><b>State Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference DEFERRABLE_TRIGGER_COMPARTMENT__STATE_SHAPE = eINSTANCE.getDeferrableTriggerCompartment_StateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.RegionShapeImpl <em>Region Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.RegionShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getRegionShape()
		 * @generated
		 */
		EClass REGION_SHAPE = eINSTANCE.getRegionShape();

		/**
		 * The meta object literal for the '<em><b>Placement</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute REGION_SHAPE__PLACEMENT = eINSTANCE.getRegionShape_Placement();

		/**
		 * The meta object literal for the '<em><b>Subvertex Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference REGION_SHAPE__SUBVERTEX_COMPARTMENT = eINSTANCE.getRegionShape_SubvertexCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SubvertexCompartmentImpl <em>Subvertex Compartment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SubvertexCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubvertexCompartment()
		 * @generated
		 */
		EClass SUBVERTEX_COMPARTMENT = eINSTANCE.getSubvertexCompartment();

		/**
		 * The meta object literal for the '<em><b>Region Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference SUBVERTEX_COMPARTMENT__REGION_SHAPE = eINSTANCE.getSubvertexCompartment_RegionShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TransitionEdgeImpl <em>Transition Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TransitionEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTransitionEdge()
		 * @generated
		 */
		EClass TRANSITION_EDGE = eINSTANCE.getTransitionEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ControlFlowEdgeImpl <em>Control Flow Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ControlFlowEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getControlFlowEdge()
		 * @generated
		 */
		EClass CONTROL_FLOW_EDGE = eINSTANCE.getControlFlowEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityGroupShapeImpl <em>Activity Group Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityGroupShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityGroupShape()
		 * @generated
		 */
		EClass ACTIVITY_GROUP_SHAPE = eINSTANCE.getActivityGroupShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExceptionHandlerEdgeImpl <em>Exception Handler Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExceptionHandlerEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExceptionHandlerEdge()
		 * @generated
		 */
		EClass EXCEPTION_HANDLER_EDGE = eINSTANCE.getExceptionHandlerEdge();

		/**
		 * The meta object literal for the '<em><b>Type Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference EXCEPTION_HANDLER_EDGE__TYPE_LABEL = eINSTANCE.getExceptionHandlerEdge_TypeLabel();

		/**
		 * The meta object literal for the '<em><b>Icon Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference EXCEPTION_HANDLER_EDGE__ICON_LABEL = eINSTANCE.getExceptionHandlerEdge_IconLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TypeLabelImpl <em>Type Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TypeLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTypeLabel()
		 * @generated
		 */
		EClass TYPE_LABEL = eINSTANCE.getTypeLabel();

		/**
		 * The meta object literal for the '<em><b>Interaction Use Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TYPE_LABEL__INTERACTION_USE_SHAPE = eINSTANCE.getTypeLabel_InteractionUseShape();

		/**
		 * The meta object literal for the '<em><b>Exception Handler Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference TYPE_LABEL__EXCEPTION_HANDLER_EDGE = eINSTANCE.getTypeLabel_ExceptionHandlerEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.IconLabelImpl <em>Icon Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.IconLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getIconLabel()
		 * @generated
		 */
		EClass ICON_LABEL = eINSTANCE.getIconLabel();

		/**
		 * The meta object literal for the '<em><b>Exception Handler Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ICON_LABEL__EXCEPTION_HANDLER_EDGE = eINSTANCE.getIconLabel_ExceptionHandlerEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActionShapeImpl <em>Action Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActionShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActionShape()
		 * @generated
		 */
		EClass ACTION_SHAPE = eINSTANCE.getActionShape();

		/**
		 * The meta object literal for the '<em><b>Pin Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTION_SHAPE__PIN_SHAPE = eINSTANCE.getActionShape_PinShape();

		/**
		 * The meta object literal for the '<em><b>Condition Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTION_SHAPE__CONDITION_LABEL = eINSTANCE.getActionShape_ConditionLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PinShapeImpl <em>Pin Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PinShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPinShape()
		 * @generated
		 */
		EClass PIN_SHAPE = eINSTANCE.getPinShape();

		/**
		 * The meta object literal for the '<em><b>Action Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PIN_SHAPE__ACTION_SHAPE = eINSTANCE.getPinShape_ActionShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.SubpartitionCompartmentImpl <em>Subpartition Compartment</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.SubpartitionCompartmentImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getSubpartitionCompartment()
		 * @generated
		 */
		EClass SUBPARTITION_COMPARTMENT = eINSTANCE.getSubpartitionCompartment();

		/**
		 * The meta object literal for the '<em><b>Activity Partition Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference SUBPARTITION_COMPARTMENT__ACTIVITY_PARTITION_SHAPE = eINSTANCE.getSubpartitionCompartment_ActivityPartitionShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ActivityPartitionShapeImpl <em>Activity Partition Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ActivityPartitionShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getActivityPartitionShape()
		 * @generated
		 */
		EClass ACTIVITY_PARTITION_SHAPE = eINSTANCE.getActivityPartitionShape();

		/**
		 * The meta object literal for the '<em><b>Is Vertical</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute ACTIVITY_PARTITION_SHAPE__IS_VERTICAL = eINSTANCE.getActivityPartitionShape_IsVertical();

		/**
		 * The meta object literal for the '<em><b>Subpartition Compartment</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference ACTIVITY_PARTITION_SHAPE__SUBPARTITION_COMPARTMENT = eINSTANCE.getActivityPartitionShape_SubpartitionCompartment();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StructuredActivityNodeShapeImpl
		 * <em>Structured Activity Node Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StructuredActivityNodeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStructuredActivityNodeShape()
		 * @generated
		 */
		EClass STRUCTURED_ACTIVITY_NODE_SHAPE = eINSTANCE.getStructuredActivityNodeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExpansionRegionShapeImpl <em>Expansion Region Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExpansionRegionShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExpansionRegionShape()
		 * @generated
		 */
		EClass EXPANSION_REGION_SHAPE = eINSTANCE.getExpansionRegionShape();

		/**
		 * The meta object literal for the '<em><b>Expansion Node Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference EXPANSION_REGION_SHAPE__EXPANSION_NODE_SHAPE = eINSTANCE.getExpansionRegionShape_ExpansionNodeShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExpansionNodeShapeImpl <em>Expansion Node Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExpansionNodeShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExpansionNodeShape()
		 * @generated
		 */
		EClass EXPANSION_NODE_SHAPE = eINSTANCE.getExpansionNodeShape();

		/**
		 * The meta object literal for the '<em><b>Expansion Region Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference EXPANSION_NODE_SHAPE__EXPANSION_REGION_SHAPE = eINSTANCE.getExpansionNodeShape_ExpansionRegionShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.LifelineShapeImpl <em>Lifeline Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.LifelineShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getLifelineShape()
		 * @generated
		 */
		EClass LIFELINE_SHAPE = eINSTANCE.getLifelineShape();

		/**
		 * The meta object literal for the '<em><b>Subfragment Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference LIFELINE_SHAPE__SUBFRAGMENT_SHAPE = eINSTANCE.getLifelineShape_SubfragmentShape();

		/**
		 * The meta object literal for the '<em><b>Nesting Lifeline Shape</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference LIFELINE_SHAPE__NESTING_LIFELINE_SHAPE = eINSTANCE.getLifelineShape_NestingLifelineShape();

		/**
		 * The meta object literal for the '<em><b>Nested Lifeline Shape</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference LIFELINE_SHAPE__NESTED_LIFELINE_SHAPE = eINSTANCE.getLifelineShape_NestedLifelineShape();

		/**
		 * The meta object literal for the '<em><b>Constraint Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference LIFELINE_SHAPE__CONSTRAINT_LABEL = eINSTANCE.getLifelineShape_ConstraintLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.ExecutionSpecificationShapeImpl
		 * <em>Execution Specification Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.ExecutionSpecificationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getExecutionSpecificationShape()
		 * @generated
		 */
		EClass EXECUTION_SPECIFICATION_SHAPE = eINSTANCE.getExecutionSpecificationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DurationConstraintShapeImpl <em>Duration Constraint Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DurationConstraintShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDurationConstraintShape()
		 * @generated
		 */
		EClass DURATION_CONSTRAINT_SHAPE = eINSTANCE.getDurationConstraintShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TimeConstraintShapeImpl <em>Time Constraint Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TimeConstraintShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeConstraintShape()
		 * @generated
		 */
		EClass TIME_CONSTRAINT_SHAPE = eINSTANCE.getTimeConstraintShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.TimeExpressionShapeImpl <em>Time Expression Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.TimeExpressionShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getTimeExpressionShape()
		 * @generated
		 */
		EClass TIME_EXPRESSION_SHAPE = eINSTANCE.getTimeExpressionShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.DurationShapeImpl <em>Duration Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.DurationShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getDurationShape()
		 * @generated
		 */
		EClass DURATION_SHAPE = eINSTANCE.getDurationShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.PathEdgeImpl <em>Path Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.PathEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPathEdge()
		 * @generated
		 */
		EClass PATH_EDGE = eINSTANCE.getPathEdge();

		/**
		 * The meta object literal for the '<em><b>Message Label</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference PATH_EDGE__MESSAGE_LABEL = eINSTANCE.getPathEdge_MessageLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.MessageLabelImpl <em>Message Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.MessageLabelImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMessageLabel()
		 * @generated
		 */
		EClass MESSAGE_LABEL = eINSTANCE.getMessageLabel();

		/**
		 * The meta object literal for the '<em><b>Path Edge</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference MESSAGE_LABEL__PATH_EDGE = eINSTANCE.getMessageLabel_PathEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.StateInvariantShapeImpl <em>State Invariant Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.StateInvariantShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getStateInvariantShape()
		 * @generated
		 */
		EClass STATE_INVARIANT_SHAPE = eINSTANCE.getStateInvariantShape();

		/**
		 * The meta object literal for the '<em><b>Use State Shape</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EAttribute STATE_INVARIANT_SHAPE__USE_STATE_SHAPE = eINSTANCE.getStateInvariantShape_UseStateShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.MessageEdgeImpl <em>Message Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.MessageEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getMessageEdge()
		 * @generated
		 */
		EClass MESSAGE_EDGE = eINSTANCE.getMessageEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.GeneralOrderingEdgeImpl <em>General Ordering Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.GeneralOrderingEdgeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getGeneralOrderingEdge()
		 * @generated
		 */
		EClass GENERAL_ORDERING_EDGE = eINSTANCE.getGeneralOrderingEdge();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.CombinedFragmentShapeImpl <em>Combined Fragment Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.CombinedFragmentShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCombinedFragmentShape()
		 * @generated
		 */
		EClass COMBINED_FRAGMENT_SHAPE = eINSTANCE.getCombinedFragmentShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionUseShapeImpl <em>Interaction Use Shape</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionUseShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionUseShape()
		 * @generated
		 */
		EClass INTERACTION_USE_SHAPE = eINSTANCE.getInteractionUseShape();

		/**
		 * The meta object literal for the '<em><b>Type Label</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @generated
		 */
		EReference INTERACTION_USE_SHAPE__TYPE_LABEL = eINSTANCE.getInteractionUseShape_TypeLabel();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.impl.InteractionOperandShapeImpl <em>Interaction Operand Shape</em>}'
		 * class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.impl.InteractionOperandShapeImpl
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getInteractionOperandShape()
		 * @generated
		 */
		EClass INTERACTION_OPERAND_SHAPE = eINSTANCE.getInteractionOperandShape();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.CompartmentLayout <em>Compartment Layout</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.CompartmentLayout
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getCompartmentLayout()
		 * @generated
		 */
		EEnum COMPARTMENT_LAYOUT = eINSTANCE.getCompartmentLayout();

		/**
		 * The meta object literal for the '{@link org.eclipse.papyrus.umldi.Placement <em>Placement</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * 
		 * @see org.eclipse.papyrus.umldi.Placement
		 * @see org.eclipse.papyrus.umldi.impl.UMLDIPackageImpl#getPlacement()
		 * @generated
		 */
		EEnum PLACEMENT = eINSTANCE.getPlacement();
	}
} //UMLDIPackage
